//  Copyright 2019 root.ext@gmail.com
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

import 'dart:ffi';
import 'opengl_header.dart';
import 'opengl_library.dart';
import 'c_utils.dart';

GlCullFace glCullFace;
GlFrontFace glFrontFace;
GlHint glHint;
GlLineWidth glLineWidth;
GlPointSize glPointSize;
GlPolygonMode glPolygonMode;
GlScissor glScissor;
GlTexParameterf glTexParameterf;
GlTexParameterfv glTexParameterfv;
GlTexParameteri glTexParameteri;
GlTexParameteriv glTexParameteriv;
GlTexImage1D glTexImage1D;
GlTexImage2D glTexImage2D;
GlDrawBuffer glDrawBuffer;
GlClear glClear;
GlClearColor glClearColor;
GlClearStencil glClearStencil;
GlClearDepth glClearDepth;
GlStencilMask glStencilMask;
GlColorMask glColorMask;
GlDepthMask glDepthMask;
GlDisable glDisable;
GlEnable glEnable;
GlFinish glFinish;
GlFlush glFlush;
GlBlendFunc glBlendFunc;
GlLogicOp glLogicOp;
GlStencilFunc glStencilFunc;
GlStencilOp glStencilOp;
GlDepthFunc glDepthFunc;
GlPixelStoref glPixelStoref;
GlPixelStorei glPixelStorei;
GlReadBuffer glReadBuffer;
GlReadPixels glReadPixels;
GlGetBooleanv glGetBooleanv;
GlGetDoublev glGetDoublev;
GlGetError glGetError;
GlGetFloatv glGetFloatv;
GlGetIntegerv glGetIntegerv;
GlGetString glGetString;
GlGetTexImage glGetTexImage;
GlGetTexParameterfv glGetTexParameterfv;
GlGetTexParameteriv glGetTexParameteriv;
GlGetTexLevelParameterfv glGetTexLevelParameterfv;
GlGetTexLevelParameteriv glGetTexLevelParameteriv;
GlIsEnabled glIsEnabled;
GlDepthRange glDepthRange;
GlViewport glViewport;
GlDrawArrays glDrawArrays;
GlDrawElements glDrawElements;
GlGetPointerv glGetPointerv;
GlPolygonOffset glPolygonOffset;
GlCopyTexImage1D glCopyTexImage1D;
GlCopyTexImage2D glCopyTexImage2D;
GlCopyTexSubImage1D glCopyTexSubImage1D;
GlCopyTexSubImage2D glCopyTexSubImage2D;
GlTexSubImage1D glTexSubImage1D;
GlTexSubImage2D glTexSubImage2D;
GlBindTexture glBindTexture;
GlDeleteTextures glDeleteTextures;
GlGenTextures glGenTextures;
GlIsTexture glIsTexture;
GlDrawRangeElements glDrawRangeElements;
GlTexImage3D glTexImage3D;
GlTexSubImage3D glTexSubImage3D;
GlCopyTexSubImage3D glCopyTexSubImage3D;
GlActiveTexture glActiveTexture;
GlSampleCoverage glSampleCoverage;
GlCompressedTexImage3D glCompressedTexImage3D;
GlCompressedTexImage2D glCompressedTexImage2D;
GlCompressedTexImage1D glCompressedTexImage1D;
GlCompressedTexSubImage3D glCompressedTexSubImage3D;
GlCompressedTexSubImage2D glCompressedTexSubImage2D;
GlCompressedTexSubImage1D glCompressedTexSubImage1D;
GlGetCompressedTexImage glGetCompressedTexImage;
GlBlendFuncSeparate glBlendFuncSeparate;
GlMultiDrawArrays glMultiDrawArrays;
GlMultiDrawElements glMultiDrawElements;
GlPointParameterf glPointParameterf;
GlPointParameterfv glPointParameterfv;
GlPointParameteri glPointParameteri;
GlPointParameteriv glPointParameteriv;
GlBlendColor glBlendColor;
GlBlendEquation glBlendEquation;
GlGenQueries glGenQueries;
GlDeleteQueries glDeleteQueries;
GlIsQuery glIsQuery;
GlBeginQuery glBeginQuery;
GlEndQuery glEndQuery;
GlGetQueryiv glGetQueryiv;
GlGetQueryObjectiv glGetQueryObjectiv;
GlGetQueryObjectuiv glGetQueryObjectuiv;
GlBindBuffer glBindBuffer;
GlDeleteBuffers glDeleteBuffers;
GlGenBuffers glGenBuffers;
GlIsBuffer glIsBuffer;
GlBufferData glBufferData;
GlBufferSubData glBufferSubData;
GlGetBufferSubData glGetBufferSubData;
GlMapBuffer glMapBuffer;
GlUnmapBuffer glUnmapBuffer;
GlGetBufferParameteriv glGetBufferParameteriv;
GlGetBufferPointerv glGetBufferPointerv;
GlBlendEquationSeparate glBlendEquationSeparate;
GlDrawBuffers glDrawBuffers;
GlStencilOpSeparate glStencilOpSeparate;
GlStencilFuncSeparate glStencilFuncSeparate;
GlStencilMaskSeparate glStencilMaskSeparate;
GlAttachShader glAttachShader;
GlBindAttribLocation glBindAttribLocation;
GlCompileShader glCompileShader;
GlCreateProgram glCreateProgram;
GlCreateShader glCreateShader;
GlDeleteProgram glDeleteProgram;
GlDeleteShader glDeleteShader;
GlDetachShader glDetachShader;
GlDisableVertexAttribArray glDisableVertexAttribArray;
GlEnableVertexAttribArray glEnableVertexAttribArray;
GlGetActiveAttrib glGetActiveAttrib;
GlGetActiveUniform glGetActiveUniform;
GlGetAttachedShaders glGetAttachedShaders;
GlGetAttribLocation glGetAttribLocation;
GlGetProgramiv glGetProgramiv;
GlGetProgramInfoLog glGetProgramInfoLog;
GlGetShaderiv glGetShaderiv;
GlGetShaderInfoLog glGetShaderInfoLog;
GlGetShaderSource glGetShaderSource;
GlGetUniformLocation glGetUniformLocation;
GlGetUniformfv glGetUniformfv;
GlGetUniformiv glGetUniformiv;
GlGetVertexAttribdv glGetVertexAttribdv;
GlGetVertexAttribfv glGetVertexAttribfv;
GlGetVertexAttribiv glGetVertexAttribiv;
GlGetVertexAttribPointerv glGetVertexAttribPointerv;
GlIsProgram glIsProgram;
GlIsShader glIsShader;
GlLinkProgram glLinkProgram;
GlShaderSource glShaderSource;
GlUseProgram glUseProgram;
GlUniform1f glUniform1f;
GlUniform2f glUniform2f;
GlUniform3f glUniform3f;
GlUniform4f glUniform4f;
GlUniform1i glUniform1i;
GlUniform2i glUniform2i;
GlUniform3i glUniform3i;
GlUniform4i glUniform4i;
GlUniform1fv glUniform1fv;
GlUniform2fv glUniform2fv;
GlUniform3fv glUniform3fv;
GlUniform4fv glUniform4fv;
GlUniform1iv glUniform1iv;
GlUniform2iv glUniform2iv;
GlUniform3iv glUniform3iv;
GlUniform4iv glUniform4iv;
GlUniformMatrix2fv glUniformMatrix2fv;
GlUniformMatrix3fv glUniformMatrix3fv;
GlUniformMatrix4fv glUniformMatrix4fv;
GlValidateProgram glValidateProgram;
GlVertexAttrib1d glVertexAttrib1d;
GlVertexAttrib1dv glVertexAttrib1dv;
GlVertexAttrib1f glVertexAttrib1f;
GlVertexAttrib1fv glVertexAttrib1fv;
GlVertexAttrib1s glVertexAttrib1s;
GlVertexAttrib1sv glVertexAttrib1sv;
GlVertexAttrib2d glVertexAttrib2d;
GlVertexAttrib2dv glVertexAttrib2dv;
GlVertexAttrib2f glVertexAttrib2f;
GlVertexAttrib2fv glVertexAttrib2fv;
GlVertexAttrib2s glVertexAttrib2s;
GlVertexAttrib2sv glVertexAttrib2sv;
GlVertexAttrib3d glVertexAttrib3d;
GlVertexAttrib3dv glVertexAttrib3dv;
GlVertexAttrib3f glVertexAttrib3f;
GlVertexAttrib3fv glVertexAttrib3fv;
GlVertexAttrib3s glVertexAttrib3s;
GlVertexAttrib3sv glVertexAttrib3sv;
GlVertexAttrib4Nbv glVertexAttrib4Nbv;
GlVertexAttrib4Niv glVertexAttrib4Niv;
GlVertexAttrib4Nsv glVertexAttrib4Nsv;
GlVertexAttrib4Nub glVertexAttrib4Nub;
GlVertexAttrib4Nubv glVertexAttrib4Nubv;
GlVertexAttrib4Nuiv glVertexAttrib4Nuiv;
GlVertexAttrib4Nusv glVertexAttrib4Nusv;
GlVertexAttrib4bv glVertexAttrib4bv;
GlVertexAttrib4d glVertexAttrib4d;
GlVertexAttrib4dv glVertexAttrib4dv;
GlVertexAttrib4f glVertexAttrib4f;
GlVertexAttrib4fv glVertexAttrib4fv;
GlVertexAttrib4iv glVertexAttrib4iv;
GlVertexAttrib4s glVertexAttrib4s;
GlVertexAttrib4sv glVertexAttrib4sv;
GlVertexAttrib4ubv glVertexAttrib4ubv;
GlVertexAttrib4uiv glVertexAttrib4uiv;
GlVertexAttrib4usv glVertexAttrib4usv;
GlVertexAttribPointer glVertexAttribPointer;
GlUniformMatrix2x3fv glUniformMatrix2x3fv;
GlUniformMatrix3x2fv glUniformMatrix3x2fv;
GlUniformMatrix2x4fv glUniformMatrix2x4fv;
GlUniformMatrix4x2fv glUniformMatrix4x2fv;
GlUniformMatrix3x4fv glUniformMatrix3x4fv;
GlUniformMatrix4x3fv glUniformMatrix4x3fv;
GlColorMaski glColorMaski;
GlGetBooleani_v glGetBooleani_v;
GlGetIntegeri_v glGetIntegeri_v;
GlEnablei glEnablei;
GlDisablei glDisablei;
GlIsEnabledi glIsEnabledi;
GlBeginTransformFeedback glBeginTransformFeedback;
GlEndTransformFeedback glEndTransformFeedback;
GlBindBufferRange glBindBufferRange;
GlBindBufferBase glBindBufferBase;
GlTransformFeedbackVaryings glTransformFeedbackVaryings;
GlGetTransformFeedbackVarying glGetTransformFeedbackVarying;
GlClampColor glClampColor;
GlBeginConditionalRender glBeginConditionalRender;
GlEndConditionalRender glEndConditionalRender;
GlVertexAttribIPointer glVertexAttribIPointer;
GlGetVertexAttribIiv glGetVertexAttribIiv;
GlGetVertexAttribIuiv glGetVertexAttribIuiv;
GlVertexAttribI1i glVertexAttribI1i;
GlVertexAttribI2i glVertexAttribI2i;
GlVertexAttribI3i glVertexAttribI3i;
GlVertexAttribI4i glVertexAttribI4i;
GlVertexAttribI1ui glVertexAttribI1ui;
GlVertexAttribI2ui glVertexAttribI2ui;
GlVertexAttribI3ui glVertexAttribI3ui;
GlVertexAttribI4ui glVertexAttribI4ui;
GlVertexAttribI1iv glVertexAttribI1iv;
GlVertexAttribI2iv glVertexAttribI2iv;
GlVertexAttribI3iv glVertexAttribI3iv;
GlVertexAttribI4iv glVertexAttribI4iv;
GlVertexAttribI1uiv glVertexAttribI1uiv;
GlVertexAttribI2uiv glVertexAttribI2uiv;
GlVertexAttribI3uiv glVertexAttribI3uiv;
GlVertexAttribI4uiv glVertexAttribI4uiv;
GlVertexAttribI4bv glVertexAttribI4bv;
GlVertexAttribI4sv glVertexAttribI4sv;
GlVertexAttribI4ubv glVertexAttribI4ubv;
GlVertexAttribI4usv glVertexAttribI4usv;
GlGetUniformuiv glGetUniformuiv;
GlBindFragDataLocation glBindFragDataLocation;
GlGetFragDataLocation glGetFragDataLocation;
GlUniform1ui glUniform1ui;
GlUniform2ui glUniform2ui;
GlUniform3ui glUniform3ui;
GlUniform4ui glUniform4ui;
GlUniform1uiv glUniform1uiv;
GlUniform2uiv glUniform2uiv;
GlUniform3uiv glUniform3uiv;
GlUniform4uiv glUniform4uiv;
GlTexParameterIiv glTexParameterIiv;
GlTexParameterIuiv glTexParameterIuiv;
GlGetTexParameterIiv glGetTexParameterIiv;
GlGetTexParameterIuiv glGetTexParameterIuiv;
GlClearBufferiv glClearBufferiv;
GlClearBufferuiv glClearBufferuiv;
GlClearBufferfv glClearBufferfv;
GlClearBufferfi glClearBufferfi;
GlGetStringi glGetStringi;
GlIsRenderbuffer glIsRenderbuffer;
GlBindRenderbuffer glBindRenderbuffer;
GlDeleteRenderbuffers glDeleteRenderbuffers;
GlGenRenderbuffers glGenRenderbuffers;
GlRenderbufferStorage glRenderbufferStorage;
GlGetRenderbufferParameteriv glGetRenderbufferParameteriv;
GlIsFramebuffer glIsFramebuffer;
GlBindFramebuffer glBindFramebuffer;
GlDeleteFramebuffers glDeleteFramebuffers;
GlGenFramebuffers glGenFramebuffers;
GlCheckFramebufferStatus glCheckFramebufferStatus;
GlFramebufferTexture1D glFramebufferTexture1D;
GlFramebufferTexture2D glFramebufferTexture2D;
GlFramebufferTexture3D glFramebufferTexture3D;
GlFramebufferRenderbuffer glFramebufferRenderbuffer;
GlGetFramebufferAttachmentParameteriv glGetFramebufferAttachmentParameteriv;
GlGenerateMipmap glGenerateMipmap;
GlBlitFramebuffer glBlitFramebuffer;
GlRenderbufferStorageMultisample glRenderbufferStorageMultisample;
GlFramebufferTextureLayer glFramebufferTextureLayer;
GlMapBufferRange glMapBufferRange;
GlFlushMappedBufferRange glFlushMappedBufferRange;
GlBindVertexArray glBindVertexArray;
GlDeleteVertexArrays glDeleteVertexArrays;
GlGenVertexArrays glGenVertexArrays;
GlIsVertexArray glIsVertexArray;
GlDrawArraysInstanced glDrawArraysInstanced;
GlDrawElementsInstanced glDrawElementsInstanced;
GlTexBuffer glTexBuffer;
GlPrimitiveRestartIndex glPrimitiveRestartIndex;
GlCopyBufferSubData glCopyBufferSubData;
GlGetUniformIndices glGetUniformIndices;
GlGetActiveUniformsiv glGetActiveUniformsiv;
GlGetActiveUniformName glGetActiveUniformName;
GlGetUniformBlockIndex glGetUniformBlockIndex;
GlGetActiveUniformBlockiv glGetActiveUniformBlockiv;
GlGetActiveUniformBlockName glGetActiveUniformBlockName;
GlUniformBlockBinding glUniformBlockBinding;
GlDrawElementsBaseVertex glDrawElementsBaseVertex;
GlDrawRangeElementsBaseVertex glDrawRangeElementsBaseVertex;
GlDrawElementsInstancedBaseVertex glDrawElementsInstancedBaseVertex;
GlMultiDrawElementsBaseVertex glMultiDrawElementsBaseVertex;
GlProvokingVertex glProvokingVertex;
GlFenceSync glFenceSync;
GlIsSync glIsSync;
GlDeleteSync glDeleteSync;
GlClientWaitSync glClientWaitSync;
GlWaitSync glWaitSync;
GlGetInteger64v glGetInteger64v;
GlGetSynciv glGetSynciv;
GlGetInteger64i_v glGetInteger64i_v;
GlGetBufferParameteri64v glGetBufferParameteri64v;
GlFramebufferTexture glFramebufferTexture;
GlTexImage2DMultisample glTexImage2DMultisample;
GlTexImage3DMultisample glTexImage3DMultisample;
GlGetMultisamplefv glGetMultisamplefv;
GlSampleMaski glSampleMaski;
GlBindFragDataLocationIndexed glBindFragDataLocationIndexed;
GlGetFragDataIndex glGetFragDataIndex;
GlGenSamplers glGenSamplers;
GlDeleteSamplers glDeleteSamplers;
GlIsSampler glIsSampler;
GlBindSampler glBindSampler;
GlSamplerParameteri glSamplerParameteri;
GlSamplerParameteriv glSamplerParameteriv;
GlSamplerParameterf glSamplerParameterf;
GlSamplerParameterfv glSamplerParameterfv;
GlSamplerParameterIiv glSamplerParameterIiv;
GlSamplerParameterIuiv glSamplerParameterIuiv;
GlGetSamplerParameteriv glGetSamplerParameteriv;
GlGetSamplerParameterIiv glGetSamplerParameterIiv;
GlGetSamplerParameterfv glGetSamplerParameterfv;
GlGetSamplerParameterIuiv glGetSamplerParameterIuiv;
GlQueryCounter glQueryCounter;
GlGetQueryObjecti64v glGetQueryObjecti64v;
GlGetQueryObjectui64v glGetQueryObjectui64v;
GlVertexAttribDivisor glVertexAttribDivisor;
GlVertexAttribP1ui glVertexAttribP1ui;
GlVertexAttribP1uiv glVertexAttribP1uiv;
GlVertexAttribP2ui glVertexAttribP2ui;
GlVertexAttribP2uiv glVertexAttribP2uiv;
GlVertexAttribP3ui glVertexAttribP3ui;
GlVertexAttribP3uiv glVertexAttribP3uiv;
GlVertexAttribP4ui glVertexAttribP4ui;
GlVertexAttribP4uiv glVertexAttribP4uiv;
GlMinSampleShading glMinSampleShading;
GlBlendEquationi glBlendEquationi;
GlBlendEquationSeparatei glBlendEquationSeparatei;
GlBlendFunci glBlendFunci;
GlBlendFuncSeparatei glBlendFuncSeparatei;
GlDrawArraysIndirect glDrawArraysIndirect;
GlDrawElementsIndirect glDrawElementsIndirect;
GlUniform1d glUniform1d;
GlUniform2d glUniform2d;
GlUniform3d glUniform3d;
GlUniform4d glUniform4d;
GlUniform1dv glUniform1dv;
GlUniform2dv glUniform2dv;
GlUniform3dv glUniform3dv;
GlUniform4dv glUniform4dv;
GlUniformMatrix2dv glUniformMatrix2dv;
GlUniformMatrix3dv glUniformMatrix3dv;
GlUniformMatrix4dv glUniformMatrix4dv;
GlUniformMatrix2x3dv glUniformMatrix2x3dv;
GlUniformMatrix2x4dv glUniformMatrix2x4dv;
GlUniformMatrix3x2dv glUniformMatrix3x2dv;
GlUniformMatrix3x4dv glUniformMatrix3x4dv;
GlUniformMatrix4x2dv glUniformMatrix4x2dv;
GlUniformMatrix4x3dv glUniformMatrix4x3dv;
GlGetUniformdv glGetUniformdv;
GlGetSubroutineUniformLocation glGetSubroutineUniformLocation;
GlGetSubroutineIndex glGetSubroutineIndex;
GlGetActiveSubroutineUniformiv glGetActiveSubroutineUniformiv;
GlGetActiveSubroutineUniformName glGetActiveSubroutineUniformName;
GlGetActiveSubroutineName glGetActiveSubroutineName;
GlUniformSubroutinesuiv glUniformSubroutinesuiv;
GlGetUniformSubroutineuiv glGetUniformSubroutineuiv;
GlGetProgramStageiv glGetProgramStageiv;
GlPatchParameteri glPatchParameteri;
GlPatchParameterfv glPatchParameterfv;
GlBindTransformFeedback glBindTransformFeedback;
GlDeleteTransformFeedbacks glDeleteTransformFeedbacks;
GlGenTransformFeedbacks glGenTransformFeedbacks;
GlIsTransformFeedback glIsTransformFeedback;
GlPauseTransformFeedback glPauseTransformFeedback;
GlResumeTransformFeedback glResumeTransformFeedback;
GlDrawTransformFeedback glDrawTransformFeedback;
GlDrawTransformFeedbackStream glDrawTransformFeedbackStream;
GlBeginQueryIndexed glBeginQueryIndexed;
GlEndQueryIndexed glEndQueryIndexed;
GlGetQueryIndexediv glGetQueryIndexediv;
GlReleaseShaderCompiler glReleaseShaderCompiler;
GlShaderBinary glShaderBinary;
GlGetShaderPrecisionFormat glGetShaderPrecisionFormat;
GlDepthRangef glDepthRangef;
GlClearDepthf glClearDepthf;
GlGetProgramBinary glGetProgramBinary;
GlProgramBinary glProgramBinary;
GlProgramParameteri glProgramParameteri;
GlUseProgramStages glUseProgramStages;
GlActiveShaderProgram glActiveShaderProgram;
GlCreateShaderProgramv glCreateShaderProgramv;
GlBindProgramPipeline glBindProgramPipeline;
GlDeleteProgramPipelines glDeleteProgramPipelines;
GlGenProgramPipelines glGenProgramPipelines;
GlIsProgramPipeline glIsProgramPipeline;
GlGetProgramPipelineiv glGetProgramPipelineiv;
GlProgramUniform1i glProgramUniform1i;
GlProgramUniform1iv glProgramUniform1iv;
GlProgramUniform1f glProgramUniform1f;
GlProgramUniform1fv glProgramUniform1fv;
GlProgramUniform1d glProgramUniform1d;
GlProgramUniform1dv glProgramUniform1dv;
GlProgramUniform1ui glProgramUniform1ui;
GlProgramUniform1uiv glProgramUniform1uiv;
GlProgramUniform2i glProgramUniform2i;
GlProgramUniform2iv glProgramUniform2iv;
GlProgramUniform2f glProgramUniform2f;
GlProgramUniform2fv glProgramUniform2fv;
GlProgramUniform2d glProgramUniform2d;
GlProgramUniform2dv glProgramUniform2dv;
GlProgramUniform2ui glProgramUniform2ui;
GlProgramUniform2uiv glProgramUniform2uiv;
GlProgramUniform3i glProgramUniform3i;
GlProgramUniform3iv glProgramUniform3iv;
GlProgramUniform3f glProgramUniform3f;
GlProgramUniform3fv glProgramUniform3fv;
GlProgramUniform3d glProgramUniform3d;
GlProgramUniform3dv glProgramUniform3dv;
GlProgramUniform3ui glProgramUniform3ui;
GlProgramUniform3uiv glProgramUniform3uiv;
GlProgramUniform4i glProgramUniform4i;
GlProgramUniform4iv glProgramUniform4iv;
GlProgramUniform4f glProgramUniform4f;
GlProgramUniform4fv glProgramUniform4fv;
GlProgramUniform4d glProgramUniform4d;
GlProgramUniform4dv glProgramUniform4dv;
GlProgramUniform4ui glProgramUniform4ui;
GlProgramUniform4uiv glProgramUniform4uiv;
GlProgramUniformMatrix2fv glProgramUniformMatrix2fv;
GlProgramUniformMatrix3fv glProgramUniformMatrix3fv;
GlProgramUniformMatrix4fv glProgramUniformMatrix4fv;
GlProgramUniformMatrix2dv glProgramUniformMatrix2dv;
GlProgramUniformMatrix3dv glProgramUniformMatrix3dv;
GlProgramUniformMatrix4dv glProgramUniformMatrix4dv;
GlProgramUniformMatrix2x3fv glProgramUniformMatrix2x3fv;
GlProgramUniformMatrix3x2fv glProgramUniformMatrix3x2fv;
GlProgramUniformMatrix2x4fv glProgramUniformMatrix2x4fv;
GlProgramUniformMatrix4x2fv glProgramUniformMatrix4x2fv;
GlProgramUniformMatrix3x4fv glProgramUniformMatrix3x4fv;
GlProgramUniformMatrix4x3fv glProgramUniformMatrix4x3fv;
GlProgramUniformMatrix2x3dv glProgramUniformMatrix2x3dv;
GlProgramUniformMatrix3x2dv glProgramUniformMatrix3x2dv;
GlProgramUniformMatrix2x4dv glProgramUniformMatrix2x4dv;
GlProgramUniformMatrix4x2dv glProgramUniformMatrix4x2dv;
GlProgramUniformMatrix3x4dv glProgramUniformMatrix3x4dv;
GlProgramUniformMatrix4x3dv glProgramUniformMatrix4x3dv;
GlValidateProgramPipeline glValidateProgramPipeline;
GlGetProgramPipelineInfoLog glGetProgramPipelineInfoLog;
GlVertexAttribL1d glVertexAttribL1d;
GlVertexAttribL2d glVertexAttribL2d;
GlVertexAttribL3d glVertexAttribL3d;
GlVertexAttribL4d glVertexAttribL4d;
GlVertexAttribL1dv glVertexAttribL1dv;
GlVertexAttribL2dv glVertexAttribL2dv;
GlVertexAttribL3dv glVertexAttribL3dv;
GlVertexAttribL4dv glVertexAttribL4dv;
GlVertexAttribLPointer glVertexAttribLPointer;
GlGetVertexAttribLdv glGetVertexAttribLdv;
GlViewportArrayv glViewportArrayv;
GlViewportIndexedf glViewportIndexedf;
GlViewportIndexedfv glViewportIndexedfv;
GlScissorArrayv glScissorArrayv;
GlScissorIndexed glScissorIndexed;
GlScissorIndexedv glScissorIndexedv;
GlDepthRangeArrayv glDepthRangeArrayv;
GlDepthRangeIndexed glDepthRangeIndexed;
GlGetFloati_v glGetFloati_v;
GlGetDoublei_v glGetDoublei_v;
GlDrawArraysInstancedBaseInstance glDrawArraysInstancedBaseInstance;
GlDrawElementsInstancedBaseInstance glDrawElementsInstancedBaseInstance;
GlDrawElementsInstancedBaseVertexBaseInstance glDrawElementsInstancedBaseVertexBaseInstance;
GlGetInternalformativ glGetInternalformativ;
GlGetActiveAtomicCounterBufferiv glGetActiveAtomicCounterBufferiv;
GlBindImageTexture glBindImageTexture;
GlMemoryBarrier glMemoryBarrier;
GlTexStorage1D glTexStorage1D;
GlTexStorage2D glTexStorage2D;
GlTexStorage3D glTexStorage3D;
GlDrawTransformFeedbackInstanced glDrawTransformFeedbackInstanced;
GlDrawTransformFeedbackStreamInstanced glDrawTransformFeedbackStreamInstanced;
GlClearBufferData glClearBufferData;
GlClearBufferSubData glClearBufferSubData;
GlDispatchCompute glDispatchCompute;
GlDispatchComputeIndirect glDispatchComputeIndirect;
GlCopyImageSubData glCopyImageSubData;
GlFramebufferParameteri glFramebufferParameteri;
GlGetFramebufferParameteriv glGetFramebufferParameteriv;
GlGetInternalformati64v glGetInternalformati64v;
GlInvalidateTexSubImage glInvalidateTexSubImage;
GlInvalidateTexImage glInvalidateTexImage;
GlInvalidateBufferSubData glInvalidateBufferSubData;
GlInvalidateBufferData glInvalidateBufferData;
GlInvalidateFramebuffer glInvalidateFramebuffer;
GlInvalidateSubFramebuffer glInvalidateSubFramebuffer;
GlMultiDrawArraysIndirect glMultiDrawArraysIndirect;
GlMultiDrawElementsIndirect glMultiDrawElementsIndirect;
GlGetProgramInterfaceiv glGetProgramInterfaceiv;
GlGetProgramResourceIndex glGetProgramResourceIndex;
GlGetProgramResourceName glGetProgramResourceName;
GlGetProgramResourceiv glGetProgramResourceiv;
GlGetProgramResourceLocation glGetProgramResourceLocation;
GlGetProgramResourceLocationIndex glGetProgramResourceLocationIndex;
GlShaderStorageBlockBinding glShaderStorageBlockBinding;
GlTexBufferRange glTexBufferRange;
GlTexStorage2DMultisample glTexStorage2DMultisample;
GlTexStorage3DMultisample glTexStorage3DMultisample;
GlTextureView glTextureView;
GlBindVertexBuffer glBindVertexBuffer;
GlVertexAttribFormat glVertexAttribFormat;
GlVertexAttribIFormat glVertexAttribIFormat;
GlVertexAttribLFormat glVertexAttribLFormat;
GlVertexAttribBinding glVertexAttribBinding;
GlVertexBindingDivisor glVertexBindingDivisor;
GlDebugMessageControl glDebugMessageControl;
GlDebugMessageInsert glDebugMessageInsert;
GlDebugMessageCallback glDebugMessageCallback;
GlGetDebugMessageLog glGetDebugMessageLog;
GlPushDebugGroup glPushDebugGroup;
GlPopDebugGroup glPopDebugGroup;
GlObjectLabel glObjectLabel;
GlGetObjectLabel glGetObjectLabel;
GlObjectPtrLabel glObjectPtrLabel;
GlGetObjectPtrLabel glGetObjectPtrLabel;
GlBufferStorage glBufferStorage;
GlClearTexImage glClearTexImage;
GlClearTexSubImage glClearTexSubImage;
GlBindBuffersBase glBindBuffersBase;
GlBindBuffersRange glBindBuffersRange;
GlBindTextures glBindTextures;
GlBindSamplers glBindSamplers;
GlBindImageTextures glBindImageTextures;
GlBindVertexBuffers glBindVertexBuffers;
GlClipControl glClipControl;
GlCreateTransformFeedbacks glCreateTransformFeedbacks;
GlTransformFeedbackBufferBase glTransformFeedbackBufferBase;
GlTransformFeedbackBufferRange glTransformFeedbackBufferRange;
GlGetTransformFeedbackiv glGetTransformFeedbackiv;
GlGetTransformFeedbacki_v glGetTransformFeedbacki_v;
GlGetTransformFeedbacki64_v glGetTransformFeedbacki64_v;
GlCreateBuffers glCreateBuffers;
GlNamedBufferStorage glNamedBufferStorage;
GlNamedBufferData glNamedBufferData;
GlNamedBufferSubData glNamedBufferSubData;
GlCopyNamedBufferSubData glCopyNamedBufferSubData;
GlClearNamedBufferData glClearNamedBufferData;
GlClearNamedBufferSubData glClearNamedBufferSubData;
GlMapNamedBuffer glMapNamedBuffer;
GlMapNamedBufferRange glMapNamedBufferRange;
GlUnmapNamedBuffer glUnmapNamedBuffer;
GlFlushMappedNamedBufferRange glFlushMappedNamedBufferRange;
GlGetNamedBufferParameteriv glGetNamedBufferParameteriv;
GlGetNamedBufferParameteri64v glGetNamedBufferParameteri64v;
GlGetNamedBufferPointerv glGetNamedBufferPointerv;
GlGetNamedBufferSubData glGetNamedBufferSubData;
GlCreateFramebuffers glCreateFramebuffers;
GlNamedFramebufferRenderbuffer glNamedFramebufferRenderbuffer;
GlNamedFramebufferParameteri glNamedFramebufferParameteri;
GlNamedFramebufferTexture glNamedFramebufferTexture;
GlNamedFramebufferTextureLayer glNamedFramebufferTextureLayer;
GlNamedFramebufferDrawBuffer glNamedFramebufferDrawBuffer;
GlNamedFramebufferDrawBuffers glNamedFramebufferDrawBuffers;
GlNamedFramebufferReadBuffer glNamedFramebufferReadBuffer;
GlInvalidateNamedFramebufferData glInvalidateNamedFramebufferData;
GlInvalidateNamedFramebufferSubData glInvalidateNamedFramebufferSubData;
GlClearNamedFramebufferiv glClearNamedFramebufferiv;
GlClearNamedFramebufferuiv glClearNamedFramebufferuiv;
GlClearNamedFramebufferfv glClearNamedFramebufferfv;
GlClearNamedFramebufferfi glClearNamedFramebufferfi;
GlBlitNamedFramebuffer glBlitNamedFramebuffer;
GlCheckNamedFramebufferStatus glCheckNamedFramebufferStatus;
GlGetNamedFramebufferParameteriv glGetNamedFramebufferParameteriv;
GlGetNamedFramebufferAttachmentParameteriv glGetNamedFramebufferAttachmentParameteriv;
GlCreateRenderbuffers glCreateRenderbuffers;
GlNamedRenderbufferStorage glNamedRenderbufferStorage;
GlNamedRenderbufferStorageMultisample glNamedRenderbufferStorageMultisample;
GlGetNamedRenderbufferParameteriv glGetNamedRenderbufferParameteriv;
GlCreateTextures glCreateTextures;
GlTextureBuffer glTextureBuffer;
GlTextureBufferRange glTextureBufferRange;
GlTextureStorage1D glTextureStorage1D;
GlTextureStorage2D glTextureStorage2D;
GlTextureStorage3D glTextureStorage3D;
GlTextureStorage2DMultisample glTextureStorage2DMultisample;
GlTextureStorage3DMultisample glTextureStorage3DMultisample;
GlTextureSubImage1D glTextureSubImage1D;
GlTextureSubImage2D glTextureSubImage2D;
GlTextureSubImage3D glTextureSubImage3D;
GlCompressedTextureSubImage1D glCompressedTextureSubImage1D;
GlCompressedTextureSubImage2D glCompressedTextureSubImage2D;
GlCompressedTextureSubImage3D glCompressedTextureSubImage3D;
GlCopyTextureSubImage1D glCopyTextureSubImage1D;
GlCopyTextureSubImage2D glCopyTextureSubImage2D;
GlCopyTextureSubImage3D glCopyTextureSubImage3D;
GlTextureParameterf glTextureParameterf;
GlTextureParameterfv glTextureParameterfv;
GlTextureParameteri glTextureParameteri;
GlTextureParameterIiv glTextureParameterIiv;
GlTextureParameterIuiv glTextureParameterIuiv;
GlTextureParameteriv glTextureParameteriv;
GlGenerateTextureMipmap glGenerateTextureMipmap;
GlBindTextureUnit glBindTextureUnit;
GlGetTextureImage glGetTextureImage;
GlGetCompressedTextureImage glGetCompressedTextureImage;
GlGetTextureLevelParameterfv glGetTextureLevelParameterfv;
GlGetTextureLevelParameteriv glGetTextureLevelParameteriv;
GlGetTextureParameterfv glGetTextureParameterfv;
GlGetTextureParameterIiv glGetTextureParameterIiv;
GlGetTextureParameterIuiv glGetTextureParameterIuiv;
GlGetTextureParameteriv glGetTextureParameteriv;
GlCreateVertexArrays glCreateVertexArrays;
GlDisableVertexArrayAttrib glDisableVertexArrayAttrib;
GlEnableVertexArrayAttrib glEnableVertexArrayAttrib;
GlVertexArrayElementBuffer glVertexArrayElementBuffer;
GlVertexArrayVertexBuffer glVertexArrayVertexBuffer;
GlVertexArrayVertexBuffers glVertexArrayVertexBuffers;
GlVertexArrayAttribBinding glVertexArrayAttribBinding;
GlVertexArrayAttribFormat glVertexArrayAttribFormat;
GlVertexArrayAttribIFormat glVertexArrayAttribIFormat;
GlVertexArrayAttribLFormat glVertexArrayAttribLFormat;
GlVertexArrayBindingDivisor glVertexArrayBindingDivisor;
GlGetVertexArrayiv glGetVertexArrayiv;
GlGetVertexArrayIndexediv glGetVertexArrayIndexediv;
GlGetVertexArrayIndexed64iv glGetVertexArrayIndexed64iv;
GlCreateSamplers glCreateSamplers;
GlCreateProgramPipelines glCreateProgramPipelines;
GlCreateQueries glCreateQueries;
GlGetQueryBufferObjecti64v glGetQueryBufferObjecti64v;
GlGetQueryBufferObjectiv glGetQueryBufferObjectiv;
GlGetQueryBufferObjectui64v glGetQueryBufferObjectui64v;
GlGetQueryBufferObjectuiv glGetQueryBufferObjectuiv;
GlMemoryBarrierByRegion glMemoryBarrierByRegion;
GlGetTextureSubImage glGetTextureSubImage;
GlGetCompressedTextureSubImage glGetCompressedTextureSubImage;
GlGetGraphicsResetStatus glGetGraphicsResetStatus;
GlGetnCompressedTexImage glGetnCompressedTexImage;
GlGetnTexImage glGetnTexImage;
GlGetnUniformdv glGetnUniformdv;
GlGetnUniformfv glGetnUniformfv;
GlGetnUniformiv glGetnUniformiv;
GlGetnUniformuiv glGetnUniformuiv;
GlReadnPixels glReadnPixels;
GlTextureBarrier glTextureBarrier;
GlSpecializeShader glSpecializeShader;
GlMultiDrawArraysIndirectCount glMultiDrawArraysIndirectCount;
GlMultiDrawElementsIndirectCount glMultiDrawElementsIndirectCount;
GlPolygonOffsetClamp glPolygonOffsetClamp;
GlPrimitiveBoundingBoxARB glPrimitiveBoundingBoxARB;
GlGetTextureHandleARB glGetTextureHandleARB;
GlGetTextureSamplerHandleARB glGetTextureSamplerHandleARB;
GlMakeTextureHandleResidentARB glMakeTextureHandleResidentARB;
GlMakeTextureHandleNonResidentARB glMakeTextureHandleNonResidentARB;
GlGetImageHandleARB glGetImageHandleARB;
GlMakeImageHandleResidentARB glMakeImageHandleResidentARB;
GlMakeImageHandleNonResidentARB glMakeImageHandleNonResidentARB;
GlUniformHandleui64ARB glUniformHandleui64ARB;
GlUniformHandleui64vARB glUniformHandleui64vARB;
GlProgramUniformHandleui64ARB glProgramUniformHandleui64ARB;
GlProgramUniformHandleui64vARB glProgramUniformHandleui64vARB;
GlIsTextureHandleResidentARB glIsTextureHandleResidentARB;
GlIsImageHandleResidentARB glIsImageHandleResidentARB;
GlVertexAttribL1ui64ARB glVertexAttribL1ui64ARB;
GlVertexAttribL1ui64vARB glVertexAttribL1ui64vARB;
GlGetVertexAttribLui64vARB glGetVertexAttribLui64vARB;
GlCreateSyncFromCLeventARB glCreateSyncFromCLeventARB;
GlDispatchComputeGroupSizeARB glDispatchComputeGroupSizeARB;
GlDebugMessageControlARB glDebugMessageControlARB;
GlDebugMessageInsertARB glDebugMessageInsertARB;
GlDebugMessageCallbackARB glDebugMessageCallbackARB;
GlGetDebugMessageLogARB glGetDebugMessageLogARB;
GlBlendEquationiARB glBlendEquationiARB;
GlBlendEquationSeparateiARB glBlendEquationSeparateiARB;
GlBlendFunciARB glBlendFunciARB;
GlBlendFuncSeparateiARB glBlendFuncSeparateiARB;
GlDrawArraysInstancedARB glDrawArraysInstancedARB;
GlDrawElementsInstancedARB glDrawElementsInstancedARB;
GlProgramParameteriARB glProgramParameteriARB;
GlFramebufferTextureARB glFramebufferTextureARB;
GlFramebufferTextureLayerARB glFramebufferTextureLayerARB;
GlFramebufferTextureFaceARB glFramebufferTextureFaceARB;
GlSpecializeShaderARB glSpecializeShaderARB;
GlUniform1i64ARB glUniform1i64ARB;
GlUniform2i64ARB glUniform2i64ARB;
GlUniform3i64ARB glUniform3i64ARB;
GlUniform4i64ARB glUniform4i64ARB;
GlUniform1i64vARB glUniform1i64vARB;
GlUniform2i64vARB glUniform2i64vARB;
GlUniform3i64vARB glUniform3i64vARB;
GlUniform4i64vARB glUniform4i64vARB;
GlUniform1ui64ARB glUniform1ui64ARB;
GlUniform2ui64ARB glUniform2ui64ARB;
GlUniform3ui64ARB glUniform3ui64ARB;
GlUniform4ui64ARB glUniform4ui64ARB;
GlUniform1ui64vARB glUniform1ui64vARB;
GlUniform2ui64vARB glUniform2ui64vARB;
GlUniform3ui64vARB glUniform3ui64vARB;
GlUniform4ui64vARB glUniform4ui64vARB;
GlGetUniformi64vARB glGetUniformi64vARB;
GlGetUniformui64vARB glGetUniformui64vARB;
GlGetnUniformi64vARB glGetnUniformi64vARB;
GlGetnUniformui64vARB glGetnUniformui64vARB;
GlProgramUniform1i64ARB glProgramUniform1i64ARB;
GlProgramUniform2i64ARB glProgramUniform2i64ARB;
GlProgramUniform3i64ARB glProgramUniform3i64ARB;
GlProgramUniform4i64ARB glProgramUniform4i64ARB;
GlProgramUniform1i64vARB glProgramUniform1i64vARB;
GlProgramUniform2i64vARB glProgramUniform2i64vARB;
GlProgramUniform3i64vARB glProgramUniform3i64vARB;
GlProgramUniform4i64vARB glProgramUniform4i64vARB;
GlProgramUniform1ui64ARB glProgramUniform1ui64ARB;
GlProgramUniform2ui64ARB glProgramUniform2ui64ARB;
GlProgramUniform3ui64ARB glProgramUniform3ui64ARB;
GlProgramUniform4ui64ARB glProgramUniform4ui64ARB;
GlProgramUniform1ui64vARB glProgramUniform1ui64vARB;
GlProgramUniform2ui64vARB glProgramUniform2ui64vARB;
GlProgramUniform3ui64vARB glProgramUniform3ui64vARB;
GlProgramUniform4ui64vARB glProgramUniform4ui64vARB;
GlMultiDrawArraysIndirectCountARB glMultiDrawArraysIndirectCountARB;
GlMultiDrawElementsIndirectCountARB glMultiDrawElementsIndirectCountARB;
GlVertexAttribDivisorARB glVertexAttribDivisorARB;
GlMaxShaderCompilerThreadsARB glMaxShaderCompilerThreadsARB;
GlGetGraphicsResetStatusARB glGetGraphicsResetStatusARB;
GlGetnTexImageARB glGetnTexImageARB;
GlReadnPixelsARB glReadnPixelsARB;
GlGetnCompressedTexImageARB glGetnCompressedTexImageARB;
GlGetnUniformfvARB glGetnUniformfvARB;
GlGetnUniformivARB glGetnUniformivARB;
GlGetnUniformuivARB glGetnUniformuivARB;
GlGetnUniformdvARB glGetnUniformdvARB;
GlFramebufferSampleLocationsfvARB glFramebufferSampleLocationsfvARB;
GlNamedFramebufferSampleLocationsfvARB glNamedFramebufferSampleLocationsfvARB;
GlEvaluateDepthValuesARB glEvaluateDepthValuesARB;
GlMinSampleShadingARB glMinSampleShadingARB;
GlNamedStringARB glNamedStringARB;
GlDeleteNamedStringARB glDeleteNamedStringARB;
GlCompileShaderIncludeARB glCompileShaderIncludeARB;
GlIsNamedStringARB glIsNamedStringARB;
GlGetNamedStringARB glGetNamedStringARB;
GlGetNamedStringivARB glGetNamedStringivARB;
GlBufferPageCommitmentARB glBufferPageCommitmentARB;
GlNamedBufferPageCommitmentEXT glNamedBufferPageCommitmentEXT;
GlNamedBufferPageCommitmentARB glNamedBufferPageCommitmentARB;
GlTexPageCommitmentARB glTexPageCommitmentARB;
GlTexBufferARB glTexBufferARB;
GlBlendBarrierKHR glBlendBarrierKHR;
GlMaxShaderCompilerThreadsKHR glMaxShaderCompilerThreadsKHR;
GlRenderbufferStorageMultisampleAdvancedAMD glRenderbufferStorageMultisampleAdvancedAMD;
GlNamedRenderbufferStorageMultisampleAdvancedAMD glNamedRenderbufferStorageMultisampleAdvancedAMD;
GlGetPerfMonitorGroupsAMD glGetPerfMonitorGroupsAMD;
GlGetPerfMonitorCountersAMD glGetPerfMonitorCountersAMD;
GlGetPerfMonitorGroupStringAMD glGetPerfMonitorGroupStringAMD;
GlGetPerfMonitorCounterStringAMD glGetPerfMonitorCounterStringAMD;
GlGetPerfMonitorCounterInfoAMD glGetPerfMonitorCounterInfoAMD;
GlGenPerfMonitorsAMD glGenPerfMonitorsAMD;
GlDeletePerfMonitorsAMD glDeletePerfMonitorsAMD;
GlSelectPerfMonitorCountersAMD glSelectPerfMonitorCountersAMD;
GlBeginPerfMonitorAMD glBeginPerfMonitorAMD;
GlEndPerfMonitorAMD glEndPerfMonitorAMD;
GlGetPerfMonitorCounterDataAMD glGetPerfMonitorCounterDataAMD;
GlEGLImageTargetTexStorageEXT glEGLImageTargetTexStorageEXT;
GlEGLImageTargetTextureStorageEXT glEGLImageTargetTextureStorageEXT;
GlLabelObjectEXT glLabelObjectEXT;
GlGetObjectLabelEXT glGetObjectLabelEXT;
GlInsertEventMarkerEXT glInsertEventMarkerEXT;
GlPushGroupMarkerEXT glPushGroupMarkerEXT;
GlPopGroupMarkerEXT glPopGroupMarkerEXT;
GlMatrixLoadfEXT glMatrixLoadfEXT;
GlMatrixLoaddEXT glMatrixLoaddEXT;
GlMatrixMultfEXT glMatrixMultfEXT;
GlMatrixMultdEXT glMatrixMultdEXT;
GlMatrixLoadIdentityEXT glMatrixLoadIdentityEXT;
GlMatrixRotatefEXT glMatrixRotatefEXT;
GlMatrixRotatedEXT glMatrixRotatedEXT;
GlMatrixScalefEXT glMatrixScalefEXT;
GlMatrixScaledEXT glMatrixScaledEXT;
GlMatrixTranslatefEXT glMatrixTranslatefEXT;
GlMatrixTranslatedEXT glMatrixTranslatedEXT;
GlMatrixFrustumEXT glMatrixFrustumEXT;
GlMatrixOrthoEXT glMatrixOrthoEXT;
GlMatrixPopEXT glMatrixPopEXT;
GlMatrixPushEXT glMatrixPushEXT;
GlClientAttribDefaultEXT glClientAttribDefaultEXT;
GlPushClientAttribDefaultEXT glPushClientAttribDefaultEXT;
GlTextureParameterfEXT glTextureParameterfEXT;
GlTextureParameterfvEXT glTextureParameterfvEXT;
GlTextureParameteriEXT glTextureParameteriEXT;
GlTextureParameterivEXT glTextureParameterivEXT;
GlTextureImage1DEXT glTextureImage1DEXT;
GlTextureImage2DEXT glTextureImage2DEXT;
GlTextureSubImage1DEXT glTextureSubImage1DEXT;
GlTextureSubImage2DEXT glTextureSubImage2DEXT;
GlCopyTextureImage1DEXT glCopyTextureImage1DEXT;
GlCopyTextureImage2DEXT glCopyTextureImage2DEXT;
GlCopyTextureSubImage1DEXT glCopyTextureSubImage1DEXT;
GlCopyTextureSubImage2DEXT glCopyTextureSubImage2DEXT;
GlGetTextureImageEXT glGetTextureImageEXT;
GlGetTextureParameterfvEXT glGetTextureParameterfvEXT;
GlGetTextureParameterivEXT glGetTextureParameterivEXT;
GlGetTextureLevelParameterfvEXT glGetTextureLevelParameterfvEXT;
GlGetTextureLevelParameterivEXT glGetTextureLevelParameterivEXT;
GlTextureImage3DEXT glTextureImage3DEXT;
GlTextureSubImage3DEXT glTextureSubImage3DEXT;
GlCopyTextureSubImage3DEXT glCopyTextureSubImage3DEXT;
GlBindMultiTextureEXT glBindMultiTextureEXT;
GlMultiTexCoordPointerEXT glMultiTexCoordPointerEXT;
GlMultiTexEnvfEXT glMultiTexEnvfEXT;
GlMultiTexEnvfvEXT glMultiTexEnvfvEXT;
GlMultiTexEnviEXT glMultiTexEnviEXT;
GlMultiTexEnvivEXT glMultiTexEnvivEXT;
GlMultiTexGendEXT glMultiTexGendEXT;
GlMultiTexGendvEXT glMultiTexGendvEXT;
GlMultiTexGenfEXT glMultiTexGenfEXT;
GlMultiTexGenfvEXT glMultiTexGenfvEXT;
GlMultiTexGeniEXT glMultiTexGeniEXT;
GlMultiTexGenivEXT glMultiTexGenivEXT;
GlGetMultiTexEnvfvEXT glGetMultiTexEnvfvEXT;
GlGetMultiTexEnvivEXT glGetMultiTexEnvivEXT;
GlGetMultiTexGendvEXT glGetMultiTexGendvEXT;
GlGetMultiTexGenfvEXT glGetMultiTexGenfvEXT;
GlGetMultiTexGenivEXT glGetMultiTexGenivEXT;
GlMultiTexParameteriEXT glMultiTexParameteriEXT;
GlMultiTexParameterivEXT glMultiTexParameterivEXT;
GlMultiTexParameterfEXT glMultiTexParameterfEXT;
GlMultiTexParameterfvEXT glMultiTexParameterfvEXT;
GlMultiTexImage1DEXT glMultiTexImage1DEXT;
GlMultiTexImage2DEXT glMultiTexImage2DEXT;
GlMultiTexSubImage1DEXT glMultiTexSubImage1DEXT;
GlMultiTexSubImage2DEXT glMultiTexSubImage2DEXT;
GlCopyMultiTexImage1DEXT glCopyMultiTexImage1DEXT;
GlCopyMultiTexImage2DEXT glCopyMultiTexImage2DEXT;
GlCopyMultiTexSubImage1DEXT glCopyMultiTexSubImage1DEXT;
GlCopyMultiTexSubImage2DEXT glCopyMultiTexSubImage2DEXT;
GlGetMultiTexImageEXT glGetMultiTexImageEXT;
GlGetMultiTexParameterfvEXT glGetMultiTexParameterfvEXT;
GlGetMultiTexParameterivEXT glGetMultiTexParameterivEXT;
GlGetMultiTexLevelParameterfvEXT glGetMultiTexLevelParameterfvEXT;
GlGetMultiTexLevelParameterivEXT glGetMultiTexLevelParameterivEXT;
GlMultiTexImage3DEXT glMultiTexImage3DEXT;
GlMultiTexSubImage3DEXT glMultiTexSubImage3DEXT;
GlCopyMultiTexSubImage3DEXT glCopyMultiTexSubImage3DEXT;
GlEnableClientStateIndexedEXT glEnableClientStateIndexedEXT;
GlDisableClientStateIndexedEXT glDisableClientStateIndexedEXT;
GlGetFloatIndexedvEXT glGetFloatIndexedvEXT;
GlGetDoubleIndexedvEXT glGetDoubleIndexedvEXT;
GlGetPointerIndexedvEXT glGetPointerIndexedvEXT;
GlEnableIndexedEXT glEnableIndexedEXT;
GlDisableIndexedEXT glDisableIndexedEXT;
GlIsEnabledIndexedEXT glIsEnabledIndexedEXT;
GlGetIntegerIndexedvEXT glGetIntegerIndexedvEXT;
GlGetBooleanIndexedvEXT glGetBooleanIndexedvEXT;
GlCompressedTextureImage3DEXT glCompressedTextureImage3DEXT;
GlCompressedTextureImage2DEXT glCompressedTextureImage2DEXT;
GlCompressedTextureImage1DEXT glCompressedTextureImage1DEXT;
GlCompressedTextureSubImage3DEXT glCompressedTextureSubImage3DEXT;
GlCompressedTextureSubImage2DEXT glCompressedTextureSubImage2DEXT;
GlCompressedTextureSubImage1DEXT glCompressedTextureSubImage1DEXT;
GlGetCompressedTextureImageEXT glGetCompressedTextureImageEXT;
GlCompressedMultiTexImage3DEXT glCompressedMultiTexImage3DEXT;
GlCompressedMultiTexImage2DEXT glCompressedMultiTexImage2DEXT;
GlCompressedMultiTexImage1DEXT glCompressedMultiTexImage1DEXT;
GlCompressedMultiTexSubImage3DEXT glCompressedMultiTexSubImage3DEXT;
GlCompressedMultiTexSubImage2DEXT glCompressedMultiTexSubImage2DEXT;
GlCompressedMultiTexSubImage1DEXT glCompressedMultiTexSubImage1DEXT;
GlGetCompressedMultiTexImageEXT glGetCompressedMultiTexImageEXT;
GlMatrixLoadTransposefEXT glMatrixLoadTransposefEXT;
GlMatrixLoadTransposedEXT glMatrixLoadTransposedEXT;
GlMatrixMultTransposefEXT glMatrixMultTransposefEXT;
GlMatrixMultTransposedEXT glMatrixMultTransposedEXT;
GlNamedBufferDataEXT glNamedBufferDataEXT;
GlNamedBufferSubDataEXT glNamedBufferSubDataEXT;
GlMapNamedBufferEXT glMapNamedBufferEXT;
GlUnmapNamedBufferEXT glUnmapNamedBufferEXT;
GlGetNamedBufferParameterivEXT glGetNamedBufferParameterivEXT;
GlGetNamedBufferPointervEXT glGetNamedBufferPointervEXT;
GlGetNamedBufferSubDataEXT glGetNamedBufferSubDataEXT;
GlProgramUniform1fEXT glProgramUniform1fEXT;
GlProgramUniform2fEXT glProgramUniform2fEXT;
GlProgramUniform3fEXT glProgramUniform3fEXT;
GlProgramUniform4fEXT glProgramUniform4fEXT;
GlProgramUniform1iEXT glProgramUniform1iEXT;
GlProgramUniform2iEXT glProgramUniform2iEXT;
GlProgramUniform3iEXT glProgramUniform3iEXT;
GlProgramUniform4iEXT glProgramUniform4iEXT;
GlProgramUniform1fvEXT glProgramUniform1fvEXT;
GlProgramUniform2fvEXT glProgramUniform2fvEXT;
GlProgramUniform3fvEXT glProgramUniform3fvEXT;
GlProgramUniform4fvEXT glProgramUniform4fvEXT;
GlProgramUniform1ivEXT glProgramUniform1ivEXT;
GlProgramUniform2ivEXT glProgramUniform2ivEXT;
GlProgramUniform3ivEXT glProgramUniform3ivEXT;
GlProgramUniform4ivEXT glProgramUniform4ivEXT;
GlProgramUniformMatrix2fvEXT glProgramUniformMatrix2fvEXT;
GlProgramUniformMatrix3fvEXT glProgramUniformMatrix3fvEXT;
GlProgramUniformMatrix4fvEXT glProgramUniformMatrix4fvEXT;
GlProgramUniformMatrix2x3fvEXT glProgramUniformMatrix2x3fvEXT;
GlProgramUniformMatrix3x2fvEXT glProgramUniformMatrix3x2fvEXT;
GlProgramUniformMatrix2x4fvEXT glProgramUniformMatrix2x4fvEXT;
GlProgramUniformMatrix4x2fvEXT glProgramUniformMatrix4x2fvEXT;
GlProgramUniformMatrix3x4fvEXT glProgramUniformMatrix3x4fvEXT;
GlProgramUniformMatrix4x3fvEXT glProgramUniformMatrix4x3fvEXT;
GlTextureBufferEXT glTextureBufferEXT;
GlMultiTexBufferEXT glMultiTexBufferEXT;
GlTextureParameterIivEXT glTextureParameterIivEXT;
GlTextureParameterIuivEXT glTextureParameterIuivEXT;
GlGetTextureParameterIivEXT glGetTextureParameterIivEXT;
GlGetTextureParameterIuivEXT glGetTextureParameterIuivEXT;
GlMultiTexParameterIivEXT glMultiTexParameterIivEXT;
GlMultiTexParameterIuivEXT glMultiTexParameterIuivEXT;
GlGetMultiTexParameterIivEXT glGetMultiTexParameterIivEXT;
GlGetMultiTexParameterIuivEXT glGetMultiTexParameterIuivEXT;
GlProgramUniform1uiEXT glProgramUniform1uiEXT;
GlProgramUniform2uiEXT glProgramUniform2uiEXT;
GlProgramUniform3uiEXT glProgramUniform3uiEXT;
GlProgramUniform4uiEXT glProgramUniform4uiEXT;
GlProgramUniform1uivEXT glProgramUniform1uivEXT;
GlProgramUniform2uivEXT glProgramUniform2uivEXT;
GlProgramUniform3uivEXT glProgramUniform3uivEXT;
GlProgramUniform4uivEXT glProgramUniform4uivEXT;
GlNamedProgramLocalParameters4fvEXT glNamedProgramLocalParameters4fvEXT;
GlNamedProgramLocalParameterI4iEXT glNamedProgramLocalParameterI4iEXT;
GlNamedProgramLocalParameterI4ivEXT glNamedProgramLocalParameterI4ivEXT;
GlNamedProgramLocalParametersI4ivEXT glNamedProgramLocalParametersI4ivEXT;
GlNamedProgramLocalParameterI4uiEXT glNamedProgramLocalParameterI4uiEXT;
GlNamedProgramLocalParameterI4uivEXT glNamedProgramLocalParameterI4uivEXT;
GlNamedProgramLocalParametersI4uivEXT glNamedProgramLocalParametersI4uivEXT;
GlGetNamedProgramLocalParameterIivEXT glGetNamedProgramLocalParameterIivEXT;
GlGetNamedProgramLocalParameterIuivEXT glGetNamedProgramLocalParameterIuivEXT;
GlEnableClientStateiEXT glEnableClientStateiEXT;
GlDisableClientStateiEXT glDisableClientStateiEXT;
GlGetFloati_vEXT glGetFloati_vEXT;
GlGetDoublei_vEXT glGetDoublei_vEXT;
GlGetPointeri_vEXT glGetPointeri_vEXT;
GlNamedProgramStringEXT glNamedProgramStringEXT;
GlNamedProgramLocalParameter4dEXT glNamedProgramLocalParameter4dEXT;
GlNamedProgramLocalParameter4dvEXT glNamedProgramLocalParameter4dvEXT;
GlNamedProgramLocalParameter4fEXT glNamedProgramLocalParameter4fEXT;
GlNamedProgramLocalParameter4fvEXT glNamedProgramLocalParameter4fvEXT;
GlGetNamedProgramLocalParameterdvEXT glGetNamedProgramLocalParameterdvEXT;
GlGetNamedProgramLocalParameterfvEXT glGetNamedProgramLocalParameterfvEXT;
GlGetNamedProgramivEXT glGetNamedProgramivEXT;
GlGetNamedProgramStringEXT glGetNamedProgramStringEXT;
GlNamedRenderbufferStorageEXT glNamedRenderbufferStorageEXT;
GlGetNamedRenderbufferParameterivEXT glGetNamedRenderbufferParameterivEXT;
GlNamedRenderbufferStorageMultisampleEXT glNamedRenderbufferStorageMultisampleEXT;
GlNamedRenderbufferStorageMultisampleCoverageEXT glNamedRenderbufferStorageMultisampleCoverageEXT;
GlCheckNamedFramebufferStatusEXT glCheckNamedFramebufferStatusEXT;
GlNamedFramebufferTexture1DEXT glNamedFramebufferTexture1DEXT;
GlNamedFramebufferTexture2DEXT glNamedFramebufferTexture2DEXT;
GlNamedFramebufferTexture3DEXT glNamedFramebufferTexture3DEXT;
GlNamedFramebufferRenderbufferEXT glNamedFramebufferRenderbufferEXT;
GlGetNamedFramebufferAttachmentParameterivEXT glGetNamedFramebufferAttachmentParameterivEXT;
GlGenerateTextureMipmapEXT glGenerateTextureMipmapEXT;
GlGenerateMultiTexMipmapEXT glGenerateMultiTexMipmapEXT;
GlFramebufferDrawBufferEXT glFramebufferDrawBufferEXT;
GlFramebufferDrawBuffersEXT glFramebufferDrawBuffersEXT;
GlFramebufferReadBufferEXT glFramebufferReadBufferEXT;
GlGetFramebufferParameterivEXT glGetFramebufferParameterivEXT;
GlNamedCopyBufferSubDataEXT glNamedCopyBufferSubDataEXT;
GlNamedFramebufferTextureEXT glNamedFramebufferTextureEXT;
GlNamedFramebufferTextureLayerEXT glNamedFramebufferTextureLayerEXT;
GlNamedFramebufferTextureFaceEXT glNamedFramebufferTextureFaceEXT;
GlTextureRenderbufferEXT glTextureRenderbufferEXT;
GlMultiTexRenderbufferEXT glMultiTexRenderbufferEXT;
GlVertexArrayVertexOffsetEXT glVertexArrayVertexOffsetEXT;
GlVertexArrayColorOffsetEXT glVertexArrayColorOffsetEXT;
GlVertexArrayEdgeFlagOffsetEXT glVertexArrayEdgeFlagOffsetEXT;
GlVertexArrayIndexOffsetEXT glVertexArrayIndexOffsetEXT;
GlVertexArrayNormalOffsetEXT glVertexArrayNormalOffsetEXT;
GlVertexArrayTexCoordOffsetEXT glVertexArrayTexCoordOffsetEXT;
GlVertexArrayMultiTexCoordOffsetEXT glVertexArrayMultiTexCoordOffsetEXT;
GlVertexArrayFogCoordOffsetEXT glVertexArrayFogCoordOffsetEXT;
GlVertexArraySecondaryColorOffsetEXT glVertexArraySecondaryColorOffsetEXT;
GlVertexArrayVertexAttribOffsetEXT glVertexArrayVertexAttribOffsetEXT;
GlVertexArrayVertexAttribIOffsetEXT glVertexArrayVertexAttribIOffsetEXT;
GlEnableVertexArrayEXT glEnableVertexArrayEXT;
GlDisableVertexArrayEXT glDisableVertexArrayEXT;
GlEnableVertexArrayAttribEXT glEnableVertexArrayAttribEXT;
GlDisableVertexArrayAttribEXT glDisableVertexArrayAttribEXT;
GlGetVertexArrayIntegervEXT glGetVertexArrayIntegervEXT;
GlGetVertexArrayPointervEXT glGetVertexArrayPointervEXT;
GlGetVertexArrayIntegeri_vEXT glGetVertexArrayIntegeri_vEXT;
GlGetVertexArrayPointeri_vEXT glGetVertexArrayPointeri_vEXT;
GlMapNamedBufferRangeEXT glMapNamedBufferRangeEXT;
GlFlushMappedNamedBufferRangeEXT glFlushMappedNamedBufferRangeEXT;
GlNamedBufferStorageEXT glNamedBufferStorageEXT;
GlClearNamedBufferDataEXT glClearNamedBufferDataEXT;
GlClearNamedBufferSubDataEXT glClearNamedBufferSubDataEXT;
GlNamedFramebufferParameteriEXT glNamedFramebufferParameteriEXT;
GlGetNamedFramebufferParameterivEXT glGetNamedFramebufferParameterivEXT;
GlProgramUniform1dEXT glProgramUniform1dEXT;
GlProgramUniform2dEXT glProgramUniform2dEXT;
GlProgramUniform3dEXT glProgramUniform3dEXT;
GlProgramUniform4dEXT glProgramUniform4dEXT;
GlProgramUniform1dvEXT glProgramUniform1dvEXT;
GlProgramUniform2dvEXT glProgramUniform2dvEXT;
GlProgramUniform3dvEXT glProgramUniform3dvEXT;
GlProgramUniform4dvEXT glProgramUniform4dvEXT;
GlProgramUniformMatrix2dvEXT glProgramUniformMatrix2dvEXT;
GlProgramUniformMatrix3dvEXT glProgramUniformMatrix3dvEXT;
GlProgramUniformMatrix4dvEXT glProgramUniformMatrix4dvEXT;
GlProgramUniformMatrix2x3dvEXT glProgramUniformMatrix2x3dvEXT;
GlProgramUniformMatrix2x4dvEXT glProgramUniformMatrix2x4dvEXT;
GlProgramUniformMatrix3x2dvEXT glProgramUniformMatrix3x2dvEXT;
GlProgramUniformMatrix3x4dvEXT glProgramUniformMatrix3x4dvEXT;
GlProgramUniformMatrix4x2dvEXT glProgramUniformMatrix4x2dvEXT;
GlProgramUniformMatrix4x3dvEXT glProgramUniformMatrix4x3dvEXT;
GlTextureBufferRangeEXT glTextureBufferRangeEXT;
GlTextureStorage1DEXT glTextureStorage1DEXT;
GlTextureStorage2DEXT glTextureStorage2DEXT;
GlTextureStorage3DEXT glTextureStorage3DEXT;
GlTextureStorage2DMultisampleEXT glTextureStorage2DMultisampleEXT;
GlTextureStorage3DMultisampleEXT glTextureStorage3DMultisampleEXT;
GlVertexArrayBindVertexBufferEXT glVertexArrayBindVertexBufferEXT;
GlVertexArrayVertexAttribFormatEXT glVertexArrayVertexAttribFormatEXT;
GlVertexArrayVertexAttribIFormatEXT glVertexArrayVertexAttribIFormatEXT;
GlVertexArrayVertexAttribLFormatEXT glVertexArrayVertexAttribLFormatEXT;
GlVertexArrayVertexAttribBindingEXT glVertexArrayVertexAttribBindingEXT;
GlVertexArrayVertexBindingDivisorEXT glVertexArrayVertexBindingDivisorEXT;
GlVertexArrayVertexAttribLOffsetEXT glVertexArrayVertexAttribLOffsetEXT;
GlTexturePageCommitmentEXT glTexturePageCommitmentEXT;
GlVertexArrayVertexAttribDivisorEXT glVertexArrayVertexAttribDivisorEXT;
GlDrawArraysInstancedEXT glDrawArraysInstancedEXT;
GlDrawElementsInstancedEXT glDrawElementsInstancedEXT;
GlPolygonOffsetClampEXT glPolygonOffsetClampEXT;
GlRasterSamplesEXT glRasterSamplesEXT;
GlUseShaderProgramEXT glUseShaderProgramEXT;
GlActiveProgramEXT glActiveProgramEXT;
GlCreateShaderProgramEXT glCreateShaderProgramEXT;
GlFramebufferFetchBarrierEXT glFramebufferFetchBarrierEXT;
GlWindowRectanglesEXT glWindowRectanglesEXT;
GlApplyFramebufferAttachmentCMAAINTEL glApplyFramebufferAttachmentCMAAINTEL;
GlBeginPerfQueryINTEL glBeginPerfQueryINTEL;
GlCreatePerfQueryINTEL glCreatePerfQueryINTEL;
GlDeletePerfQueryINTEL glDeletePerfQueryINTEL;
GlEndPerfQueryINTEL glEndPerfQueryINTEL;
GlGetFirstPerfQueryIdINTEL glGetFirstPerfQueryIdINTEL;
GlGetNextPerfQueryIdINTEL glGetNextPerfQueryIdINTEL;
GlGetPerfCounterInfoINTEL glGetPerfCounterInfoINTEL;
GlGetPerfQueryDataINTEL glGetPerfQueryDataINTEL;
GlGetPerfQueryIdByNameINTEL glGetPerfQueryIdByNameINTEL;
GlGetPerfQueryInfoINTEL glGetPerfQueryInfoINTEL;
GlMultiDrawArraysIndirectBindlessNV glMultiDrawArraysIndirectBindlessNV;
GlMultiDrawElementsIndirectBindlessNV glMultiDrawElementsIndirectBindlessNV;
GlMultiDrawArraysIndirectBindlessCountNV glMultiDrawArraysIndirectBindlessCountNV;
GlMultiDrawElementsIndirectBindlessCountNV glMultiDrawElementsIndirectBindlessCountNV;
GlGetTextureHandleNV glGetTextureHandleNV;
GlGetTextureSamplerHandleNV glGetTextureSamplerHandleNV;
GlMakeTextureHandleResidentNV glMakeTextureHandleResidentNV;
GlMakeTextureHandleNonResidentNV glMakeTextureHandleNonResidentNV;
GlGetImageHandleNV glGetImageHandleNV;
GlMakeImageHandleResidentNV glMakeImageHandleResidentNV;
GlMakeImageHandleNonResidentNV glMakeImageHandleNonResidentNV;
GlUniformHandleui64NV glUniformHandleui64NV;
GlUniformHandleui64vNV glUniformHandleui64vNV;
GlProgramUniformHandleui64NV glProgramUniformHandleui64NV;
GlProgramUniformHandleui64vNV glProgramUniformHandleui64vNV;
GlIsTextureHandleResidentNV glIsTextureHandleResidentNV;
GlIsImageHandleResidentNV glIsImageHandleResidentNV;
GlBlendParameteriNV glBlendParameteriNV;
GlBlendBarrierNV glBlendBarrierNV;
GlViewportPositionWScaleNV glViewportPositionWScaleNV;
GlCreateStatesNV glCreateStatesNV;
GlDeleteStatesNV glDeleteStatesNV;
GlIsStateNV glIsStateNV;
GlStateCaptureNV glStateCaptureNV;
GlGetCommandHeaderNV glGetCommandHeaderNV;
GlGetStageIndexNV glGetStageIndexNV;
GlDrawCommandsNV glDrawCommandsNV;
GlDrawCommandsAddressNV glDrawCommandsAddressNV;
GlDrawCommandsStatesNV glDrawCommandsStatesNV;
GlDrawCommandsStatesAddressNV glDrawCommandsStatesAddressNV;
GlCreateCommandListsNV glCreateCommandListsNV;
GlDeleteCommandListsNV glDeleteCommandListsNV;
GlIsCommandListNV glIsCommandListNV;
GlListDrawCommandsStatesClientNV glListDrawCommandsStatesClientNV;
GlCommandListSegmentsNV glCommandListSegmentsNV;
GlCompileCommandListNV glCompileCommandListNV;
GlCallCommandListNV glCallCommandListNV;
GlBeginConditionalRenderNV glBeginConditionalRenderNV;
GlEndConditionalRenderNV glEndConditionalRenderNV;
GlSubpixelPrecisionBiasNV glSubpixelPrecisionBiasNV;
GlConservativeRasterParameterfNV glConservativeRasterParameterfNV;
GlConservativeRasterParameteriNV glConservativeRasterParameteriNV;
GlDrawVkImageNV glDrawVkImageNV;
GlGetVkProcAddrNV glGetVkProcAddrNV;
GlWaitVkSemaphoreNV glWaitVkSemaphoreNV;
GlSignalVkSemaphoreNV glSignalVkSemaphoreNV;
GlSignalVkFenceNV glSignalVkFenceNV;
GlFragmentCoverageColorNV glFragmentCoverageColorNV;
GlCoverageModulationTableNV glCoverageModulationTableNV;
GlGetCoverageModulationTableNV glGetCoverageModulationTableNV;
GlCoverageModulationNV glCoverageModulationNV;
GlRenderbufferStorageMultisampleCoverageNV glRenderbufferStorageMultisampleCoverageNV;
GlUniform1i64NV glUniform1i64NV;
GlUniform2i64NV glUniform2i64NV;
GlUniform3i64NV glUniform3i64NV;
GlUniform4i64NV glUniform4i64NV;
GlUniform1i64vNV glUniform1i64vNV;
GlUniform2i64vNV glUniform2i64vNV;
GlUniform3i64vNV glUniform3i64vNV;
GlUniform4i64vNV glUniform4i64vNV;
GlUniform1ui64NV glUniform1ui64NV;
GlUniform2ui64NV glUniform2ui64NV;
GlUniform3ui64NV glUniform3ui64NV;
GlUniform4ui64NV glUniform4ui64NV;
GlUniform1ui64vNV glUniform1ui64vNV;
GlUniform2ui64vNV glUniform2ui64vNV;
GlUniform3ui64vNV glUniform3ui64vNV;
GlUniform4ui64vNV glUniform4ui64vNV;
GlGetUniformi64vNV glGetUniformi64vNV;
GlProgramUniform1i64NV glProgramUniform1i64NV;
GlProgramUniform2i64NV glProgramUniform2i64NV;
GlProgramUniform3i64NV glProgramUniform3i64NV;
GlProgramUniform4i64NV glProgramUniform4i64NV;
GlProgramUniform1i64vNV glProgramUniform1i64vNV;
GlProgramUniform2i64vNV glProgramUniform2i64vNV;
GlProgramUniform3i64vNV glProgramUniform3i64vNV;
GlProgramUniform4i64vNV glProgramUniform4i64vNV;
GlProgramUniform1ui64NV glProgramUniform1ui64NV;
GlProgramUniform2ui64NV glProgramUniform2ui64NV;
GlProgramUniform3ui64NV glProgramUniform3ui64NV;
GlProgramUniform4ui64NV glProgramUniform4ui64NV;
GlProgramUniform1ui64vNV glProgramUniform1ui64vNV;
GlProgramUniform2ui64vNV glProgramUniform2ui64vNV;
GlProgramUniform3ui64vNV glProgramUniform3ui64vNV;
GlProgramUniform4ui64vNV glProgramUniform4ui64vNV;
GlGetInternalformatSampleivNV glGetInternalformatSampleivNV;
GlGetMemoryObjectDetachedResourcesuivNV glGetMemoryObjectDetachedResourcesuivNV;
GlResetMemoryObjectParameterNV glResetMemoryObjectParameterNV;
GlTexAttachMemoryNV glTexAttachMemoryNV;
GlBufferAttachMemoryNV glBufferAttachMemoryNV;
GlTextureAttachMemoryNV glTextureAttachMemoryNV;
GlNamedBufferAttachMemoryNV glNamedBufferAttachMemoryNV;
GlDrawMeshTasksNV glDrawMeshTasksNV;
GlDrawMeshTasksIndirectNV glDrawMeshTasksIndirectNV;
GlMultiDrawMeshTasksIndirectNV glMultiDrawMeshTasksIndirectNV;
GlMultiDrawMeshTasksIndirectCountNV glMultiDrawMeshTasksIndirectCountNV;
GlGenPathsNV glGenPathsNV;
GlDeletePathsNV glDeletePathsNV;
GlIsPathNV glIsPathNV;
GlPathCommandsNV glPathCommandsNV;
GlPathCoordsNV glPathCoordsNV;
GlPathSubCommandsNV glPathSubCommandsNV;
GlPathSubCoordsNV glPathSubCoordsNV;
GlPathStringNV glPathStringNV;
GlPathGlyphsNV glPathGlyphsNV;
GlPathGlyphRangeNV glPathGlyphRangeNV;
GlWeightPathsNV glWeightPathsNV;
GlCopyPathNV glCopyPathNV;
GlInterpolatePathsNV glInterpolatePathsNV;
GlTransformPathNV glTransformPathNV;
GlPathParameterivNV glPathParameterivNV;
GlPathParameteriNV glPathParameteriNV;
GlPathParameterfvNV glPathParameterfvNV;
GlPathParameterfNV glPathParameterfNV;
GlPathDashArrayNV glPathDashArrayNV;
GlPathStencilFuncNV glPathStencilFuncNV;
GlPathStencilDepthOffsetNV glPathStencilDepthOffsetNV;
GlStencilFillPathNV glStencilFillPathNV;
GlStencilStrokePathNV glStencilStrokePathNV;
GlStencilFillPathInstancedNV glStencilFillPathInstancedNV;
GlStencilStrokePathInstancedNV glStencilStrokePathInstancedNV;
GlPathCoverDepthFuncNV glPathCoverDepthFuncNV;
GlCoverFillPathNV glCoverFillPathNV;
GlCoverStrokePathNV glCoverStrokePathNV;
GlCoverFillPathInstancedNV glCoverFillPathInstancedNV;
GlCoverStrokePathInstancedNV glCoverStrokePathInstancedNV;
GlGetPathParameterivNV glGetPathParameterivNV;
GlGetPathParameterfvNV glGetPathParameterfvNV;
GlGetPathCommandsNV glGetPathCommandsNV;
GlGetPathCoordsNV glGetPathCoordsNV;
GlGetPathDashArrayNV glGetPathDashArrayNV;
GlGetPathMetricsNV glGetPathMetricsNV;
GlGetPathMetricRangeNV glGetPathMetricRangeNV;
GlGetPathSpacingNV glGetPathSpacingNV;
GlIsPointInFillPathNV glIsPointInFillPathNV;
GlIsPointInStrokePathNV glIsPointInStrokePathNV;
GlGetPathLengthNV glGetPathLengthNV;
GlPointAlongPathNV glPointAlongPathNV;
GlMatrixLoad3x2fNV glMatrixLoad3x2fNV;
GlMatrixLoad3x3fNV glMatrixLoad3x3fNV;
GlMatrixLoadTranspose3x3fNV glMatrixLoadTranspose3x3fNV;
GlMatrixMult3x2fNV glMatrixMult3x2fNV;
GlMatrixMult3x3fNV glMatrixMult3x3fNV;
GlMatrixMultTranspose3x3fNV glMatrixMultTranspose3x3fNV;
GlStencilThenCoverFillPathNV glStencilThenCoverFillPathNV;
GlStencilThenCoverStrokePathNV glStencilThenCoverStrokePathNV;
GlStencilThenCoverFillPathInstancedNV glStencilThenCoverFillPathInstancedNV;
GlStencilThenCoverStrokePathInstancedNV glStencilThenCoverStrokePathInstancedNV;
GlPathGlyphIndexRangeNV glPathGlyphIndexRangeNV;
GlPathGlyphIndexArrayNV glPathGlyphIndexArrayNV;
GlPathMemoryGlyphIndexArrayNV glPathMemoryGlyphIndexArrayNV;
GlProgramPathFragmentInputGenNV glProgramPathFragmentInputGenNV;
GlGetProgramResourcefvNV glGetProgramResourcefvNV;
GlFramebufferSampleLocationsfvNV glFramebufferSampleLocationsfvNV;
GlNamedFramebufferSampleLocationsfvNV glNamedFramebufferSampleLocationsfvNV;
GlResolveDepthValuesNV glResolveDepthValuesNV;
GlScissorExclusiveNV glScissorExclusiveNV;
GlScissorExclusiveArrayvNV glScissorExclusiveArrayvNV;
GlMakeBufferResidentNV glMakeBufferResidentNV;
GlMakeBufferNonResidentNV glMakeBufferNonResidentNV;
GlIsBufferResidentNV glIsBufferResidentNV;
GlMakeNamedBufferResidentNV glMakeNamedBufferResidentNV;
GlMakeNamedBufferNonResidentNV glMakeNamedBufferNonResidentNV;
GlIsNamedBufferResidentNV glIsNamedBufferResidentNV;
GlGetBufferParameterui64vNV glGetBufferParameterui64vNV;
GlGetNamedBufferParameterui64vNV glGetNamedBufferParameterui64vNV;
GlGetIntegerui64vNV glGetIntegerui64vNV;
GlUniformui64NV glUniformui64NV;
GlUniformui64vNV glUniformui64vNV;
GlGetUniformui64vNV glGetUniformui64vNV;
GlProgramUniformui64NV glProgramUniformui64NV;
GlProgramUniformui64vNV glProgramUniformui64vNV;
GlBindShadingRateImageNV glBindShadingRateImageNV;
GlGetShadingRateImagePaletteNV glGetShadingRateImagePaletteNV;
GlGetShadingRateSampleLocationivNV glGetShadingRateSampleLocationivNV;
GlShadingRateImageBarrierNV glShadingRateImageBarrierNV;
GlShadingRateImagePaletteNV glShadingRateImagePaletteNV;
GlShadingRateSampleOrderNV glShadingRateSampleOrderNV;
GlShadingRateSampleOrderCustomNV glShadingRateSampleOrderCustomNV;
GlTextureBarrierNV glTextureBarrierNV;
GlVertexAttribL1i64NV glVertexAttribL1i64NV;
GlVertexAttribL2i64NV glVertexAttribL2i64NV;
GlVertexAttribL3i64NV glVertexAttribL3i64NV;
GlVertexAttribL4i64NV glVertexAttribL4i64NV;
GlVertexAttribL1i64vNV glVertexAttribL1i64vNV;
GlVertexAttribL2i64vNV glVertexAttribL2i64vNV;
GlVertexAttribL3i64vNV glVertexAttribL3i64vNV;
GlVertexAttribL4i64vNV glVertexAttribL4i64vNV;
GlVertexAttribL1ui64NV glVertexAttribL1ui64NV;
GlVertexAttribL2ui64NV glVertexAttribL2ui64NV;
GlVertexAttribL3ui64NV glVertexAttribL3ui64NV;
GlVertexAttribL4ui64NV glVertexAttribL4ui64NV;
GlVertexAttribL1ui64vNV glVertexAttribL1ui64vNV;
GlVertexAttribL2ui64vNV glVertexAttribL2ui64vNV;
GlVertexAttribL3ui64vNV glVertexAttribL3ui64vNV;
GlVertexAttribL4ui64vNV glVertexAttribL4ui64vNV;
GlGetVertexAttribLi64vNV glGetVertexAttribLi64vNV;
GlGetVertexAttribLui64vNV glGetVertexAttribLui64vNV;
GlVertexAttribLFormatNV glVertexAttribLFormatNV;
GlBufferAddressRangeNV glBufferAddressRangeNV;
GlVertexFormatNV glVertexFormatNV;
GlNormalFormatNV glNormalFormatNV;
GlColorFormatNV glColorFormatNV;
GlIndexFormatNV glIndexFormatNV;
GlTexCoordFormatNV glTexCoordFormatNV;
GlEdgeFlagFormatNV glEdgeFlagFormatNV;
GlSecondaryColorFormatNV glSecondaryColorFormatNV;
GlFogCoordFormatNV glFogCoordFormatNV;
GlVertexAttribFormatNV glVertexAttribFormatNV;
GlVertexAttribIFormatNV glVertexAttribIFormatNV;
GlGetIntegerui64i_vNV glGetIntegerui64i_vNV;
GlViewportSwizzleNV glViewportSwizzleNV;
GlFramebufferTextureMultiviewOVR glFramebufferTextureMultiviewOVR;

void initOpenGL() {
  var gl = loadLibrary();
  glCullFace = gl.lookupFunction<GlCullFaceNative, GlCullFace>('glCullFace');
  glFrontFace = gl.lookupFunction<GlFrontFaceNative, GlFrontFace>('glFrontFace');
  glHint = gl.lookupFunction<GlHintNative, GlHint>('glHint');
  glLineWidth = gl.lookupFunction<GlLineWidthNative, GlLineWidth>('glLineWidth');
  glPointSize = gl.lookupFunction<GlPointSizeNative, GlPointSize>('glPointSize');
  glPolygonMode = gl.lookupFunction<GlPolygonModeNative, GlPolygonMode>('glPolygonMode');
  glScissor = gl.lookupFunction<GlScissorNative, GlScissor>('glScissor');
  glTexParameterf = gl.lookupFunction<GlTexParameterfNative, GlTexParameterf>('glTexParameterf');
  glTexParameterfv = gl.lookupFunction<GlTexParameterfvNative, GlTexParameterfv>('glTexParameterfv');
  glTexParameteri = gl.lookupFunction<GlTexParameteriNative, GlTexParameteri>('glTexParameteri');
  glTexParameteriv = gl.lookupFunction<GlTexParameterivNative, GlTexParameteriv>('glTexParameteriv');
  glTexImage1D = gl.lookupFunction<GlTexImage1DNative, GlTexImage1D>('glTexImage1D');
  glTexImage2D = gl.lookupFunction<GlTexImage2DNative, GlTexImage2D>('glTexImage2D');
  glDrawBuffer = gl.lookupFunction<GlDrawBufferNative, GlDrawBuffer>('glDrawBuffer');
  glClear = gl.lookupFunction<GlClearNative, GlClear>('glClear');
  glClearColor = gl.lookupFunction<GlClearColorNative, GlClearColor>('glClearColor');
  glClearStencil = gl.lookupFunction<GlClearStencilNative, GlClearStencil>('glClearStencil');
  glClearDepth = gl.lookupFunction<GlClearDepthNative, GlClearDepth>('glClearDepth');
  glStencilMask = gl.lookupFunction<GlStencilMaskNative, GlStencilMask>('glStencilMask');
  glColorMask = gl.lookupFunction<GlColorMaskNative, GlColorMask>('glColorMask');
  glDepthMask = gl.lookupFunction<GlDepthMaskNative, GlDepthMask>('glDepthMask');
  glDisable = gl.lookupFunction<GlDisableNative, GlDisable>('glDisable');
  glEnable = gl.lookupFunction<GlEnableNative, GlEnable>('glEnable');
  glFinish = gl.lookupFunction<GlFinishNative, GlFinish>('glFinish');
  glFlush = gl.lookupFunction<GlFlushNative, GlFlush>('glFlush');
  glBlendFunc = gl.lookupFunction<GlBlendFuncNative, GlBlendFunc>('glBlendFunc');
  glLogicOp = gl.lookupFunction<GlLogicOpNative, GlLogicOp>('glLogicOp');
  glStencilFunc = gl.lookupFunction<GlStencilFuncNative, GlStencilFunc>('glStencilFunc');
  glStencilOp = gl.lookupFunction<GlStencilOpNative, GlStencilOp>('glStencilOp');
  glDepthFunc = gl.lookupFunction<GlDepthFuncNative, GlDepthFunc>('glDepthFunc');
  glPixelStoref = gl.lookupFunction<GlPixelStorefNative, GlPixelStoref>('glPixelStoref');
  glPixelStorei = gl.lookupFunction<GlPixelStoreiNative, GlPixelStorei>('glPixelStorei');
  glReadBuffer = gl.lookupFunction<GlReadBufferNative, GlReadBuffer>('glReadBuffer');
  glReadPixels = gl.lookupFunction<GlReadPixelsNative, GlReadPixels>('glReadPixels');
  glGetBooleanv = gl.lookupFunction<GlGetBooleanvNative, GlGetBooleanv>('glGetBooleanv');
  glGetDoublev = gl.lookupFunction<GlGetDoublevNative, GlGetDoublev>('glGetDoublev');
  glGetError = gl.lookupFunction<GlGetErrorNative, GlGetError>('glGetError');
  glGetFloatv = gl.lookupFunction<GlGetFloatvNative, GlGetFloatv>('glGetFloatv');
  glGetIntegerv = gl.lookupFunction<GlGetIntegervNative, GlGetIntegerv>('glGetIntegerv');
  glGetString = gl.lookupFunction<GlGetStringNative, GlGetString>('glGetString');
  glGetTexImage = gl.lookupFunction<GlGetTexImageNative, GlGetTexImage>('glGetTexImage');
  glGetTexParameterfv = gl.lookupFunction<GlGetTexParameterfvNative, GlGetTexParameterfv>('glGetTexParameterfv');
  glGetTexParameteriv = gl.lookupFunction<GlGetTexParameterivNative, GlGetTexParameteriv>('glGetTexParameteriv');
  glGetTexLevelParameterfv = gl.lookupFunction<GlGetTexLevelParameterfvNative, GlGetTexLevelParameterfv>('glGetTexLevelParameterfv');
  glGetTexLevelParameteriv = gl.lookupFunction<GlGetTexLevelParameterivNative, GlGetTexLevelParameteriv>('glGetTexLevelParameteriv');
  glIsEnabled = gl.lookupFunction<GlIsEnabledNative, GlIsEnabled>('glIsEnabled');
  glDepthRange = gl.lookupFunction<GlDepthRangeNative, GlDepthRange>('glDepthRange');
  glViewport = gl.lookupFunction<GlViewportNative, GlViewport>('glViewport');
  glDrawArrays = gl.lookupFunction<GlDrawArraysNative, GlDrawArrays>('glDrawArrays');
  glDrawElements = gl.lookupFunction<GlDrawElementsNative, GlDrawElements>('glDrawElements');
  glGetPointerv = gl.lookupFunction<GlGetPointervNative, GlGetPointerv>('glGetPointerv');
  glPolygonOffset = gl.lookupFunction<GlPolygonOffsetNative, GlPolygonOffset>('glPolygonOffset');
  glCopyTexImage1D = gl.lookupFunction<GlCopyTexImage1DNative, GlCopyTexImage1D>('glCopyTexImage1D');
  glCopyTexImage2D = gl.lookupFunction<GlCopyTexImage2DNative, GlCopyTexImage2D>('glCopyTexImage2D');
  glCopyTexSubImage1D = gl.lookupFunction<GlCopyTexSubImage1DNative, GlCopyTexSubImage1D>('glCopyTexSubImage1D');
  glCopyTexSubImage2D = gl.lookupFunction<GlCopyTexSubImage2DNative, GlCopyTexSubImage2D>('glCopyTexSubImage2D');
  glTexSubImage1D = gl.lookupFunction<GlTexSubImage1DNative, GlTexSubImage1D>('glTexSubImage1D');
  glTexSubImage2D = gl.lookupFunction<GlTexSubImage2DNative, GlTexSubImage2D>('glTexSubImage2D');
  glBindTexture = gl.lookupFunction<GlBindTextureNative, GlBindTexture>('glBindTexture');
  glDeleteTextures = gl.lookupFunction<GlDeleteTexturesNative, GlDeleteTextures>('glDeleteTextures');
  glGenTextures = gl.lookupFunction<GlGenTexturesNative, GlGenTextures>('glGenTextures');
  glIsTexture = gl.lookupFunction<GlIsTextureNative, GlIsTexture>('glIsTexture');
  glDrawRangeElements = fromAddress<Pointer<NativeFunction<GlDrawRangeElementsNative>>>(glGetProcAddress(CString.fromUtf8('glDrawRangeElements'))).asFunction<GlDrawRangeElements>();
  glTexImage3D = fromAddress<Pointer<NativeFunction<GlTexImage3DNative>>>(glGetProcAddress(CString.fromUtf8('glTexImage3D'))).asFunction<GlTexImage3D>();
  glTexSubImage3D = fromAddress<Pointer<NativeFunction<GlTexSubImage3DNative>>>(glGetProcAddress(CString.fromUtf8('glTexSubImage3D'))).asFunction<GlTexSubImage3D>();
  glCopyTexSubImage3D = fromAddress<Pointer<NativeFunction<GlCopyTexSubImage3DNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTexSubImage3D'))).asFunction<GlCopyTexSubImage3D>();
  glActiveTexture = fromAddress<Pointer<NativeFunction<GlActiveTextureNative>>>(glGetProcAddress(CString.fromUtf8('glActiveTexture'))).asFunction<GlActiveTexture>();
  glSampleCoverage = fromAddress<Pointer<NativeFunction<GlSampleCoverageNative>>>(glGetProcAddress(CString.fromUtf8('glSampleCoverage'))).asFunction<GlSampleCoverage>();
  glCompressedTexImage3D = fromAddress<Pointer<NativeFunction<GlCompressedTexImage3DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTexImage3D'))).asFunction<GlCompressedTexImage3D>();
  glCompressedTexImage2D = fromAddress<Pointer<NativeFunction<GlCompressedTexImage2DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTexImage2D'))).asFunction<GlCompressedTexImage2D>();
  glCompressedTexImage1D = fromAddress<Pointer<NativeFunction<GlCompressedTexImage1DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTexImage1D'))).asFunction<GlCompressedTexImage1D>();
  glCompressedTexSubImage3D = fromAddress<Pointer<NativeFunction<GlCompressedTexSubImage3DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTexSubImage3D'))).asFunction<GlCompressedTexSubImage3D>();
  glCompressedTexSubImage2D = fromAddress<Pointer<NativeFunction<GlCompressedTexSubImage2DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTexSubImage2D'))).asFunction<GlCompressedTexSubImage2D>();
  glCompressedTexSubImage1D = fromAddress<Pointer<NativeFunction<GlCompressedTexSubImage1DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTexSubImage1D'))).asFunction<GlCompressedTexSubImage1D>();
  glGetCompressedTexImage = fromAddress<Pointer<NativeFunction<GlGetCompressedTexImageNative>>>(glGetProcAddress(CString.fromUtf8('glGetCompressedTexImage'))).asFunction<GlGetCompressedTexImage>();
  glBlendFuncSeparate = fromAddress<Pointer<NativeFunction<GlBlendFuncSeparateNative>>>(glGetProcAddress(CString.fromUtf8('glBlendFuncSeparate'))).asFunction<GlBlendFuncSeparate>();
  glMultiDrawArrays = fromAddress<Pointer<NativeFunction<GlMultiDrawArraysNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawArrays'))).asFunction<GlMultiDrawArrays>();
  glMultiDrawElements = fromAddress<Pointer<NativeFunction<GlMultiDrawElementsNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawElements'))).asFunction<GlMultiDrawElements>();
  glPointParameterf = fromAddress<Pointer<NativeFunction<GlPointParameterfNative>>>(glGetProcAddress(CString.fromUtf8('glPointParameterf'))).asFunction<GlPointParameterf>();
  glPointParameterfv = fromAddress<Pointer<NativeFunction<GlPointParameterfvNative>>>(glGetProcAddress(CString.fromUtf8('glPointParameterfv'))).asFunction<GlPointParameterfv>();
  glPointParameteri = fromAddress<Pointer<NativeFunction<GlPointParameteriNative>>>(glGetProcAddress(CString.fromUtf8('glPointParameteri'))).asFunction<GlPointParameteri>();
  glPointParameteriv = fromAddress<Pointer<NativeFunction<GlPointParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glPointParameteriv'))).asFunction<GlPointParameteriv>();
  glBlendColor = fromAddress<Pointer<NativeFunction<GlBlendColorNative>>>(glGetProcAddress(CString.fromUtf8('glBlendColor'))).asFunction<GlBlendColor>();
  glBlendEquation = fromAddress<Pointer<NativeFunction<GlBlendEquationNative>>>(glGetProcAddress(CString.fromUtf8('glBlendEquation'))).asFunction<GlBlendEquation>();
  glGenQueries = fromAddress<Pointer<NativeFunction<GlGenQueriesNative>>>(glGetProcAddress(CString.fromUtf8('glGenQueries'))).asFunction<GlGenQueries>();
  glDeleteQueries = fromAddress<Pointer<NativeFunction<GlDeleteQueriesNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteQueries'))).asFunction<GlDeleteQueries>();
  glIsQuery = fromAddress<Pointer<NativeFunction<GlIsQueryNative>>>(glGetProcAddress(CString.fromUtf8('glIsQuery'))).asFunction<GlIsQuery>();
  glBeginQuery = fromAddress<Pointer<NativeFunction<GlBeginQueryNative>>>(glGetProcAddress(CString.fromUtf8('glBeginQuery'))).asFunction<GlBeginQuery>();
  glEndQuery = fromAddress<Pointer<NativeFunction<GlEndQueryNative>>>(glGetProcAddress(CString.fromUtf8('glEndQuery'))).asFunction<GlEndQuery>();
  glGetQueryiv = fromAddress<Pointer<NativeFunction<GlGetQueryivNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryiv'))).asFunction<GlGetQueryiv>();
  glGetQueryObjectiv = fromAddress<Pointer<NativeFunction<GlGetQueryObjectivNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryObjectiv'))).asFunction<GlGetQueryObjectiv>();
  glGetQueryObjectuiv = fromAddress<Pointer<NativeFunction<GlGetQueryObjectuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryObjectuiv'))).asFunction<GlGetQueryObjectuiv>();
  glBindBuffer = fromAddress<Pointer<NativeFunction<GlBindBufferNative>>>(glGetProcAddress(CString.fromUtf8('glBindBuffer'))).asFunction<GlBindBuffer>();
  glDeleteBuffers = fromAddress<Pointer<NativeFunction<GlDeleteBuffersNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteBuffers'))).asFunction<GlDeleteBuffers>();
  glGenBuffers = fromAddress<Pointer<NativeFunction<GlGenBuffersNative>>>(glGetProcAddress(CString.fromUtf8('glGenBuffers'))).asFunction<GlGenBuffers>();
  glIsBuffer = fromAddress<Pointer<NativeFunction<GlIsBufferNative>>>(glGetProcAddress(CString.fromUtf8('glIsBuffer'))).asFunction<GlIsBuffer>();
  glBufferData = fromAddress<Pointer<NativeFunction<GlBufferDataNative>>>(glGetProcAddress(CString.fromUtf8('glBufferData'))).asFunction<GlBufferData>();
  glBufferSubData = fromAddress<Pointer<NativeFunction<GlBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glBufferSubData'))).asFunction<GlBufferSubData>();
  glGetBufferSubData = fromAddress<Pointer<NativeFunction<GlGetBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glGetBufferSubData'))).asFunction<GlGetBufferSubData>();
  glMapBuffer = fromAddress<Pointer<NativeFunction<GlMapBufferNative>>>(glGetProcAddress(CString.fromUtf8('glMapBuffer'))).asFunction<GlMapBuffer>();
  glUnmapBuffer = fromAddress<Pointer<NativeFunction<GlUnmapBufferNative>>>(glGetProcAddress(CString.fromUtf8('glUnmapBuffer'))).asFunction<GlUnmapBuffer>();
  glGetBufferParameteriv = fromAddress<Pointer<NativeFunction<GlGetBufferParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetBufferParameteriv'))).asFunction<GlGetBufferParameteriv>();
  glGetBufferPointerv = fromAddress<Pointer<NativeFunction<GlGetBufferPointervNative>>>(glGetProcAddress(CString.fromUtf8('glGetBufferPointerv'))).asFunction<GlGetBufferPointerv>();
  glBlendEquationSeparate = fromAddress<Pointer<NativeFunction<GlBlendEquationSeparateNative>>>(glGetProcAddress(CString.fromUtf8('glBlendEquationSeparate'))).asFunction<GlBlendEquationSeparate>();
  glDrawBuffers = fromAddress<Pointer<NativeFunction<GlDrawBuffersNative>>>(glGetProcAddress(CString.fromUtf8('glDrawBuffers'))).asFunction<GlDrawBuffers>();
  glStencilOpSeparate = fromAddress<Pointer<NativeFunction<GlStencilOpSeparateNative>>>(glGetProcAddress(CString.fromUtf8('glStencilOpSeparate'))).asFunction<GlStencilOpSeparate>();
  glStencilFuncSeparate = fromAddress<Pointer<NativeFunction<GlStencilFuncSeparateNative>>>(glGetProcAddress(CString.fromUtf8('glStencilFuncSeparate'))).asFunction<GlStencilFuncSeparate>();
  glStencilMaskSeparate = fromAddress<Pointer<NativeFunction<GlStencilMaskSeparateNative>>>(glGetProcAddress(CString.fromUtf8('glStencilMaskSeparate'))).asFunction<GlStencilMaskSeparate>();
  glAttachShader = fromAddress<Pointer<NativeFunction<GlAttachShaderNative>>>(glGetProcAddress(CString.fromUtf8('glAttachShader'))).asFunction<GlAttachShader>();
  glBindAttribLocation = fromAddress<Pointer<NativeFunction<GlBindAttribLocationNative>>>(glGetProcAddress(CString.fromUtf8('glBindAttribLocation'))).asFunction<GlBindAttribLocation>();
  glCompileShader = fromAddress<Pointer<NativeFunction<GlCompileShaderNative>>>(glGetProcAddress(CString.fromUtf8('glCompileShader'))).asFunction<GlCompileShader>();
  glCreateProgram = fromAddress<Pointer<NativeFunction<GlCreateProgramNative>>>(glGetProcAddress(CString.fromUtf8('glCreateProgram'))).asFunction<GlCreateProgram>();
  glCreateShader = fromAddress<Pointer<NativeFunction<GlCreateShaderNative>>>(glGetProcAddress(CString.fromUtf8('glCreateShader'))).asFunction<GlCreateShader>();
  glDeleteProgram = fromAddress<Pointer<NativeFunction<GlDeleteProgramNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteProgram'))).asFunction<GlDeleteProgram>();
  glDeleteShader = fromAddress<Pointer<NativeFunction<GlDeleteShaderNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteShader'))).asFunction<GlDeleteShader>();
  glDetachShader = fromAddress<Pointer<NativeFunction<GlDetachShaderNative>>>(glGetProcAddress(CString.fromUtf8('glDetachShader'))).asFunction<GlDetachShader>();
  glDisableVertexAttribArray = fromAddress<Pointer<NativeFunction<GlDisableVertexAttribArrayNative>>>(glGetProcAddress(CString.fromUtf8('glDisableVertexAttribArray'))).asFunction<GlDisableVertexAttribArray>();
  glEnableVertexAttribArray = fromAddress<Pointer<NativeFunction<GlEnableVertexAttribArrayNative>>>(glGetProcAddress(CString.fromUtf8('glEnableVertexAttribArray'))).asFunction<GlEnableVertexAttribArray>();
  glGetActiveAttrib = fromAddress<Pointer<NativeFunction<GlGetActiveAttribNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveAttrib'))).asFunction<GlGetActiveAttrib>();
  glGetActiveUniform = fromAddress<Pointer<NativeFunction<GlGetActiveUniformNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveUniform'))).asFunction<GlGetActiveUniform>();
  glGetAttachedShaders = fromAddress<Pointer<NativeFunction<GlGetAttachedShadersNative>>>(glGetProcAddress(CString.fromUtf8('glGetAttachedShaders'))).asFunction<GlGetAttachedShaders>();
  glGetAttribLocation = fromAddress<Pointer<NativeFunction<GlGetAttribLocationNative>>>(glGetProcAddress(CString.fromUtf8('glGetAttribLocation'))).asFunction<GlGetAttribLocation>();
  glGetProgramiv = fromAddress<Pointer<NativeFunction<GlGetProgramivNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramiv'))).asFunction<GlGetProgramiv>();
  glGetProgramInfoLog = fromAddress<Pointer<NativeFunction<GlGetProgramInfoLogNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramInfoLog'))).asFunction<GlGetProgramInfoLog>();
  glGetShaderiv = fromAddress<Pointer<NativeFunction<GlGetShaderivNative>>>(glGetProcAddress(CString.fromUtf8('glGetShaderiv'))).asFunction<GlGetShaderiv>();
  glGetShaderInfoLog = fromAddress<Pointer<NativeFunction<GlGetShaderInfoLogNative>>>(glGetProcAddress(CString.fromUtf8('glGetShaderInfoLog'))).asFunction<GlGetShaderInfoLog>();
  glGetShaderSource = fromAddress<Pointer<NativeFunction<GlGetShaderSourceNative>>>(glGetProcAddress(CString.fromUtf8('glGetShaderSource'))).asFunction<GlGetShaderSource>();
  glGetUniformLocation = fromAddress<Pointer<NativeFunction<GlGetUniformLocationNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformLocation'))).asFunction<GlGetUniformLocation>();
  glGetUniformfv = fromAddress<Pointer<NativeFunction<GlGetUniformfvNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformfv'))).asFunction<GlGetUniformfv>();
  glGetUniformiv = fromAddress<Pointer<NativeFunction<GlGetUniformivNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformiv'))).asFunction<GlGetUniformiv>();
  glGetVertexAttribdv = fromAddress<Pointer<NativeFunction<GlGetVertexAttribdvNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribdv'))).asFunction<GlGetVertexAttribdv>();
  glGetVertexAttribfv = fromAddress<Pointer<NativeFunction<GlGetVertexAttribfvNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribfv'))).asFunction<GlGetVertexAttribfv>();
  glGetVertexAttribiv = fromAddress<Pointer<NativeFunction<GlGetVertexAttribivNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribiv'))).asFunction<GlGetVertexAttribiv>();
  glGetVertexAttribPointerv = fromAddress<Pointer<NativeFunction<GlGetVertexAttribPointervNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribPointerv'))).asFunction<GlGetVertexAttribPointerv>();
  glIsProgram = fromAddress<Pointer<NativeFunction<GlIsProgramNative>>>(glGetProcAddress(CString.fromUtf8('glIsProgram'))).asFunction<GlIsProgram>();
  glIsShader = fromAddress<Pointer<NativeFunction<GlIsShaderNative>>>(glGetProcAddress(CString.fromUtf8('glIsShader'))).asFunction<GlIsShader>();
  glLinkProgram = fromAddress<Pointer<NativeFunction<GlLinkProgramNative>>>(glGetProcAddress(CString.fromUtf8('glLinkProgram'))).asFunction<GlLinkProgram>();
  glShaderSource = fromAddress<Pointer<NativeFunction<GlShaderSourceNative>>>(glGetProcAddress(CString.fromUtf8('glShaderSource'))).asFunction<GlShaderSource>();
  glUseProgram = fromAddress<Pointer<NativeFunction<GlUseProgramNative>>>(glGetProcAddress(CString.fromUtf8('glUseProgram'))).asFunction<GlUseProgram>();
  glUniform1f = fromAddress<Pointer<NativeFunction<GlUniform1fNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1f'))).asFunction<GlUniform1f>();
  glUniform2f = fromAddress<Pointer<NativeFunction<GlUniform2fNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2f'))).asFunction<GlUniform2f>();
  glUniform3f = fromAddress<Pointer<NativeFunction<GlUniform3fNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3f'))).asFunction<GlUniform3f>();
  glUniform4f = fromAddress<Pointer<NativeFunction<GlUniform4fNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4f'))).asFunction<GlUniform4f>();
  glUniform1i = fromAddress<Pointer<NativeFunction<GlUniform1iNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1i'))).asFunction<GlUniform1i>();
  glUniform2i = fromAddress<Pointer<NativeFunction<GlUniform2iNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2i'))).asFunction<GlUniform2i>();
  glUniform3i = fromAddress<Pointer<NativeFunction<GlUniform3iNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3i'))).asFunction<GlUniform3i>();
  glUniform4i = fromAddress<Pointer<NativeFunction<GlUniform4iNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4i'))).asFunction<GlUniform4i>();
  glUniform1fv = fromAddress<Pointer<NativeFunction<GlUniform1fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1fv'))).asFunction<GlUniform1fv>();
  glUniform2fv = fromAddress<Pointer<NativeFunction<GlUniform2fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2fv'))).asFunction<GlUniform2fv>();
  glUniform3fv = fromAddress<Pointer<NativeFunction<GlUniform3fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3fv'))).asFunction<GlUniform3fv>();
  glUniform4fv = fromAddress<Pointer<NativeFunction<GlUniform4fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4fv'))).asFunction<GlUniform4fv>();
  glUniform1iv = fromAddress<Pointer<NativeFunction<GlUniform1ivNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1iv'))).asFunction<GlUniform1iv>();
  glUniform2iv = fromAddress<Pointer<NativeFunction<GlUniform2ivNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2iv'))).asFunction<GlUniform2iv>();
  glUniform3iv = fromAddress<Pointer<NativeFunction<GlUniform3ivNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3iv'))).asFunction<GlUniform3iv>();
  glUniform4iv = fromAddress<Pointer<NativeFunction<GlUniform4ivNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4iv'))).asFunction<GlUniform4iv>();
  glUniformMatrix2fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix2fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix2fv'))).asFunction<GlUniformMatrix2fv>();
  glUniformMatrix3fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix3fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix3fv'))).asFunction<GlUniformMatrix3fv>();
  glUniformMatrix4fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix4fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix4fv'))).asFunction<GlUniformMatrix4fv>();
  glValidateProgram = fromAddress<Pointer<NativeFunction<GlValidateProgramNative>>>(glGetProcAddress(CString.fromUtf8('glValidateProgram'))).asFunction<GlValidateProgram>();
  glVertexAttrib1d = fromAddress<Pointer<NativeFunction<GlVertexAttrib1dNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib1d'))).asFunction<GlVertexAttrib1d>();
  glVertexAttrib1dv = fromAddress<Pointer<NativeFunction<GlVertexAttrib1dvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib1dv'))).asFunction<GlVertexAttrib1dv>();
  glVertexAttrib1f = fromAddress<Pointer<NativeFunction<GlVertexAttrib1fNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib1f'))).asFunction<GlVertexAttrib1f>();
  glVertexAttrib1fv = fromAddress<Pointer<NativeFunction<GlVertexAttrib1fvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib1fv'))).asFunction<GlVertexAttrib1fv>();
  glVertexAttrib1s = fromAddress<Pointer<NativeFunction<GlVertexAttrib1sNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib1s'))).asFunction<GlVertexAttrib1s>();
  glVertexAttrib1sv = fromAddress<Pointer<NativeFunction<GlVertexAttrib1svNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib1sv'))).asFunction<GlVertexAttrib1sv>();
  glVertexAttrib2d = fromAddress<Pointer<NativeFunction<GlVertexAttrib2dNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib2d'))).asFunction<GlVertexAttrib2d>();
  glVertexAttrib2dv = fromAddress<Pointer<NativeFunction<GlVertexAttrib2dvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib2dv'))).asFunction<GlVertexAttrib2dv>();
  glVertexAttrib2f = fromAddress<Pointer<NativeFunction<GlVertexAttrib2fNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib2f'))).asFunction<GlVertexAttrib2f>();
  glVertexAttrib2fv = fromAddress<Pointer<NativeFunction<GlVertexAttrib2fvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib2fv'))).asFunction<GlVertexAttrib2fv>();
  glVertexAttrib2s = fromAddress<Pointer<NativeFunction<GlVertexAttrib2sNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib2s'))).asFunction<GlVertexAttrib2s>();
  glVertexAttrib2sv = fromAddress<Pointer<NativeFunction<GlVertexAttrib2svNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib2sv'))).asFunction<GlVertexAttrib2sv>();
  glVertexAttrib3d = fromAddress<Pointer<NativeFunction<GlVertexAttrib3dNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib3d'))).asFunction<GlVertexAttrib3d>();
  glVertexAttrib3dv = fromAddress<Pointer<NativeFunction<GlVertexAttrib3dvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib3dv'))).asFunction<GlVertexAttrib3dv>();
  glVertexAttrib3f = fromAddress<Pointer<NativeFunction<GlVertexAttrib3fNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib3f'))).asFunction<GlVertexAttrib3f>();
  glVertexAttrib3fv = fromAddress<Pointer<NativeFunction<GlVertexAttrib3fvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib3fv'))).asFunction<GlVertexAttrib3fv>();
  glVertexAttrib3s = fromAddress<Pointer<NativeFunction<GlVertexAttrib3sNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib3s'))).asFunction<GlVertexAttrib3s>();
  glVertexAttrib3sv = fromAddress<Pointer<NativeFunction<GlVertexAttrib3svNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib3sv'))).asFunction<GlVertexAttrib3sv>();
  glVertexAttrib4Nbv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4NbvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4Nbv'))).asFunction<GlVertexAttrib4Nbv>();
  glVertexAttrib4Niv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4NivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4Niv'))).asFunction<GlVertexAttrib4Niv>();
  glVertexAttrib4Nsv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4NsvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4Nsv'))).asFunction<GlVertexAttrib4Nsv>();
  glVertexAttrib4Nub = fromAddress<Pointer<NativeFunction<GlVertexAttrib4NubNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4Nub'))).asFunction<GlVertexAttrib4Nub>();
  glVertexAttrib4Nubv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4NubvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4Nubv'))).asFunction<GlVertexAttrib4Nubv>();
  glVertexAttrib4Nuiv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4NuivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4Nuiv'))).asFunction<GlVertexAttrib4Nuiv>();
  glVertexAttrib4Nusv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4NusvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4Nusv'))).asFunction<GlVertexAttrib4Nusv>();
  glVertexAttrib4bv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4bvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4bv'))).asFunction<GlVertexAttrib4bv>();
  glVertexAttrib4d = fromAddress<Pointer<NativeFunction<GlVertexAttrib4dNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4d'))).asFunction<GlVertexAttrib4d>();
  glVertexAttrib4dv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4dvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4dv'))).asFunction<GlVertexAttrib4dv>();
  glVertexAttrib4f = fromAddress<Pointer<NativeFunction<GlVertexAttrib4fNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4f'))).asFunction<GlVertexAttrib4f>();
  glVertexAttrib4fv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4fvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4fv'))).asFunction<GlVertexAttrib4fv>();
  glVertexAttrib4iv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4ivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4iv'))).asFunction<GlVertexAttrib4iv>();
  glVertexAttrib4s = fromAddress<Pointer<NativeFunction<GlVertexAttrib4sNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4s'))).asFunction<GlVertexAttrib4s>();
  glVertexAttrib4sv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4svNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4sv'))).asFunction<GlVertexAttrib4sv>();
  glVertexAttrib4ubv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4ubvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4ubv'))).asFunction<GlVertexAttrib4ubv>();
  glVertexAttrib4uiv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4uiv'))).asFunction<GlVertexAttrib4uiv>();
  glVertexAttrib4usv = fromAddress<Pointer<NativeFunction<GlVertexAttrib4usvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttrib4usv'))).asFunction<GlVertexAttrib4usv>();
  glVertexAttribPointer = fromAddress<Pointer<NativeFunction<GlVertexAttribPointerNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribPointer'))).asFunction<GlVertexAttribPointer>();
  glUniformMatrix2x3fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix2x3fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix2x3fv'))).asFunction<GlUniformMatrix2x3fv>();
  glUniformMatrix3x2fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix3x2fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix3x2fv'))).asFunction<GlUniformMatrix3x2fv>();
  glUniformMatrix2x4fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix2x4fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix2x4fv'))).asFunction<GlUniformMatrix2x4fv>();
  glUniformMatrix4x2fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix4x2fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix4x2fv'))).asFunction<GlUniformMatrix4x2fv>();
  glUniformMatrix3x4fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix3x4fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix3x4fv'))).asFunction<GlUniformMatrix3x4fv>();
  glUniformMatrix4x3fv = fromAddress<Pointer<NativeFunction<GlUniformMatrix4x3fvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix4x3fv'))).asFunction<GlUniformMatrix4x3fv>();
  glColorMaski = fromAddress<Pointer<NativeFunction<GlColorMaskiNative>>>(glGetProcAddress(CString.fromUtf8('glColorMaski'))).asFunction<GlColorMaski>();
  glGetBooleani_v = fromAddress<Pointer<NativeFunction<GlGetBooleani_vNative>>>(glGetProcAddress(CString.fromUtf8('glGetBooleani_v'))).asFunction<GlGetBooleani_v>();
  glGetIntegeri_v = fromAddress<Pointer<NativeFunction<GlGetIntegeri_vNative>>>(glGetProcAddress(CString.fromUtf8('glGetIntegeri_v'))).asFunction<GlGetIntegeri_v>();
  glEnablei = fromAddress<Pointer<NativeFunction<GlEnableiNative>>>(glGetProcAddress(CString.fromUtf8('glEnablei'))).asFunction<GlEnablei>();
  glDisablei = fromAddress<Pointer<NativeFunction<GlDisableiNative>>>(glGetProcAddress(CString.fromUtf8('glDisablei'))).asFunction<GlDisablei>();
  glIsEnabledi = fromAddress<Pointer<NativeFunction<GlIsEnablediNative>>>(glGetProcAddress(CString.fromUtf8('glIsEnabledi'))).asFunction<GlIsEnabledi>();
  glBeginTransformFeedback = fromAddress<Pointer<NativeFunction<GlBeginTransformFeedbackNative>>>(glGetProcAddress(CString.fromUtf8('glBeginTransformFeedback'))).asFunction<GlBeginTransformFeedback>();
  glEndTransformFeedback = fromAddress<Pointer<NativeFunction<GlEndTransformFeedbackNative>>>(glGetProcAddress(CString.fromUtf8('glEndTransformFeedback'))).asFunction<GlEndTransformFeedback>();
  glBindBufferRange = fromAddress<Pointer<NativeFunction<GlBindBufferRangeNative>>>(glGetProcAddress(CString.fromUtf8('glBindBufferRange'))).asFunction<GlBindBufferRange>();
  glBindBufferBase = fromAddress<Pointer<NativeFunction<GlBindBufferBaseNative>>>(glGetProcAddress(CString.fromUtf8('glBindBufferBase'))).asFunction<GlBindBufferBase>();
  glTransformFeedbackVaryings = fromAddress<Pointer<NativeFunction<GlTransformFeedbackVaryingsNative>>>(glGetProcAddress(CString.fromUtf8('glTransformFeedbackVaryings'))).asFunction<GlTransformFeedbackVaryings>();
  glGetTransformFeedbackVarying = fromAddress<Pointer<NativeFunction<GlGetTransformFeedbackVaryingNative>>>(glGetProcAddress(CString.fromUtf8('glGetTransformFeedbackVarying'))).asFunction<GlGetTransformFeedbackVarying>();
  glClampColor = fromAddress<Pointer<NativeFunction<GlClampColorNative>>>(glGetProcAddress(CString.fromUtf8('glClampColor'))).asFunction<GlClampColor>();
  glBeginConditionalRender = fromAddress<Pointer<NativeFunction<GlBeginConditionalRenderNative>>>(glGetProcAddress(CString.fromUtf8('glBeginConditionalRender'))).asFunction<GlBeginConditionalRender>();
  glEndConditionalRender = fromAddress<Pointer<NativeFunction<GlEndConditionalRenderNative>>>(glGetProcAddress(CString.fromUtf8('glEndConditionalRender'))).asFunction<GlEndConditionalRender>();
  glVertexAttribIPointer = fromAddress<Pointer<NativeFunction<GlVertexAttribIPointerNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribIPointer'))).asFunction<GlVertexAttribIPointer>();
  glGetVertexAttribIiv = fromAddress<Pointer<NativeFunction<GlGetVertexAttribIivNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribIiv'))).asFunction<GlGetVertexAttribIiv>();
  glGetVertexAttribIuiv = fromAddress<Pointer<NativeFunction<GlGetVertexAttribIuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribIuiv'))).asFunction<GlGetVertexAttribIuiv>();
  glVertexAttribI1i = fromAddress<Pointer<NativeFunction<GlVertexAttribI1iNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI1i'))).asFunction<GlVertexAttribI1i>();
  glVertexAttribI2i = fromAddress<Pointer<NativeFunction<GlVertexAttribI2iNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI2i'))).asFunction<GlVertexAttribI2i>();
  glVertexAttribI3i = fromAddress<Pointer<NativeFunction<GlVertexAttribI3iNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI3i'))).asFunction<GlVertexAttribI3i>();
  glVertexAttribI4i = fromAddress<Pointer<NativeFunction<GlVertexAttribI4iNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI4i'))).asFunction<GlVertexAttribI4i>();
  glVertexAttribI1ui = fromAddress<Pointer<NativeFunction<GlVertexAttribI1uiNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI1ui'))).asFunction<GlVertexAttribI1ui>();
  glVertexAttribI2ui = fromAddress<Pointer<NativeFunction<GlVertexAttribI2uiNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI2ui'))).asFunction<GlVertexAttribI2ui>();
  glVertexAttribI3ui = fromAddress<Pointer<NativeFunction<GlVertexAttribI3uiNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI3ui'))).asFunction<GlVertexAttribI3ui>();
  glVertexAttribI4ui = fromAddress<Pointer<NativeFunction<GlVertexAttribI4uiNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI4ui'))).asFunction<GlVertexAttribI4ui>();
  glVertexAttribI1iv = fromAddress<Pointer<NativeFunction<GlVertexAttribI1ivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI1iv'))).asFunction<GlVertexAttribI1iv>();
  glVertexAttribI2iv = fromAddress<Pointer<NativeFunction<GlVertexAttribI2ivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI2iv'))).asFunction<GlVertexAttribI2iv>();
  glVertexAttribI3iv = fromAddress<Pointer<NativeFunction<GlVertexAttribI3ivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI3iv'))).asFunction<GlVertexAttribI3iv>();
  glVertexAttribI4iv = fromAddress<Pointer<NativeFunction<GlVertexAttribI4ivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI4iv'))).asFunction<GlVertexAttribI4iv>();
  glVertexAttribI1uiv = fromAddress<Pointer<NativeFunction<GlVertexAttribI1uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI1uiv'))).asFunction<GlVertexAttribI1uiv>();
  glVertexAttribI2uiv = fromAddress<Pointer<NativeFunction<GlVertexAttribI2uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI2uiv'))).asFunction<GlVertexAttribI2uiv>();
  glVertexAttribI3uiv = fromAddress<Pointer<NativeFunction<GlVertexAttribI3uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI3uiv'))).asFunction<GlVertexAttribI3uiv>();
  glVertexAttribI4uiv = fromAddress<Pointer<NativeFunction<GlVertexAttribI4uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI4uiv'))).asFunction<GlVertexAttribI4uiv>();
  glVertexAttribI4bv = fromAddress<Pointer<NativeFunction<GlVertexAttribI4bvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI4bv'))).asFunction<GlVertexAttribI4bv>();
  glVertexAttribI4sv = fromAddress<Pointer<NativeFunction<GlVertexAttribI4svNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI4sv'))).asFunction<GlVertexAttribI4sv>();
  glVertexAttribI4ubv = fromAddress<Pointer<NativeFunction<GlVertexAttribI4ubvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI4ubv'))).asFunction<GlVertexAttribI4ubv>();
  glVertexAttribI4usv = fromAddress<Pointer<NativeFunction<GlVertexAttribI4usvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribI4usv'))).asFunction<GlVertexAttribI4usv>();
  glGetUniformuiv = fromAddress<Pointer<NativeFunction<GlGetUniformuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformuiv'))).asFunction<GlGetUniformuiv>();
  glBindFragDataLocation = fromAddress<Pointer<NativeFunction<GlBindFragDataLocationNative>>>(glGetProcAddress(CString.fromUtf8('glBindFragDataLocation'))).asFunction<GlBindFragDataLocation>();
  glGetFragDataLocation = fromAddress<Pointer<NativeFunction<GlGetFragDataLocationNative>>>(glGetProcAddress(CString.fromUtf8('glGetFragDataLocation'))).asFunction<GlGetFragDataLocation>();
  glUniform1ui = fromAddress<Pointer<NativeFunction<GlUniform1uiNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1ui'))).asFunction<GlUniform1ui>();
  glUniform2ui = fromAddress<Pointer<NativeFunction<GlUniform2uiNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2ui'))).asFunction<GlUniform2ui>();
  glUniform3ui = fromAddress<Pointer<NativeFunction<GlUniform3uiNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3ui'))).asFunction<GlUniform3ui>();
  glUniform4ui = fromAddress<Pointer<NativeFunction<GlUniform4uiNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4ui'))).asFunction<GlUniform4ui>();
  glUniform1uiv = fromAddress<Pointer<NativeFunction<GlUniform1uivNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1uiv'))).asFunction<GlUniform1uiv>();
  glUniform2uiv = fromAddress<Pointer<NativeFunction<GlUniform2uivNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2uiv'))).asFunction<GlUniform2uiv>();
  glUniform3uiv = fromAddress<Pointer<NativeFunction<GlUniform3uivNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3uiv'))).asFunction<GlUniform3uiv>();
  glUniform4uiv = fromAddress<Pointer<NativeFunction<GlUniform4uivNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4uiv'))).asFunction<GlUniform4uiv>();
  glTexParameterIiv = fromAddress<Pointer<NativeFunction<GlTexParameterIivNative>>>(glGetProcAddress(CString.fromUtf8('glTexParameterIiv'))).asFunction<GlTexParameterIiv>();
  glTexParameterIuiv = fromAddress<Pointer<NativeFunction<GlTexParameterIuivNative>>>(glGetProcAddress(CString.fromUtf8('glTexParameterIuiv'))).asFunction<GlTexParameterIuiv>();
  glGetTexParameterIiv = fromAddress<Pointer<NativeFunction<GlGetTexParameterIivNative>>>(glGetProcAddress(CString.fromUtf8('glGetTexParameterIiv'))).asFunction<GlGetTexParameterIiv>();
  glGetTexParameterIuiv = fromAddress<Pointer<NativeFunction<GlGetTexParameterIuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetTexParameterIuiv'))).asFunction<GlGetTexParameterIuiv>();
  glClearBufferiv = fromAddress<Pointer<NativeFunction<GlClearBufferivNative>>>(glGetProcAddress(CString.fromUtf8('glClearBufferiv'))).asFunction<GlClearBufferiv>();
  glClearBufferuiv = fromAddress<Pointer<NativeFunction<GlClearBufferuivNative>>>(glGetProcAddress(CString.fromUtf8('glClearBufferuiv'))).asFunction<GlClearBufferuiv>();
  glClearBufferfv = fromAddress<Pointer<NativeFunction<GlClearBufferfvNative>>>(glGetProcAddress(CString.fromUtf8('glClearBufferfv'))).asFunction<GlClearBufferfv>();
  glClearBufferfi = fromAddress<Pointer<NativeFunction<GlClearBufferfiNative>>>(glGetProcAddress(CString.fromUtf8('glClearBufferfi'))).asFunction<GlClearBufferfi>();
  glGetStringi = fromAddress<Pointer<NativeFunction<GlGetStringiNative>>>(glGetProcAddress(CString.fromUtf8('glGetStringi'))).asFunction<GlGetStringi>();
  glIsRenderbuffer = fromAddress<Pointer<NativeFunction<GlIsRenderbufferNative>>>(glGetProcAddress(CString.fromUtf8('glIsRenderbuffer'))).asFunction<GlIsRenderbuffer>();
  glBindRenderbuffer = fromAddress<Pointer<NativeFunction<GlBindRenderbufferNative>>>(glGetProcAddress(CString.fromUtf8('glBindRenderbuffer'))).asFunction<GlBindRenderbuffer>();
  glDeleteRenderbuffers = fromAddress<Pointer<NativeFunction<GlDeleteRenderbuffersNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteRenderbuffers'))).asFunction<GlDeleteRenderbuffers>();
  glGenRenderbuffers = fromAddress<Pointer<NativeFunction<GlGenRenderbuffersNative>>>(glGetProcAddress(CString.fromUtf8('glGenRenderbuffers'))).asFunction<GlGenRenderbuffers>();
  glRenderbufferStorage = fromAddress<Pointer<NativeFunction<GlRenderbufferStorageNative>>>(glGetProcAddress(CString.fromUtf8('glRenderbufferStorage'))).asFunction<GlRenderbufferStorage>();
  glGetRenderbufferParameteriv = fromAddress<Pointer<NativeFunction<GlGetRenderbufferParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetRenderbufferParameteriv'))).asFunction<GlGetRenderbufferParameteriv>();
  glIsFramebuffer = fromAddress<Pointer<NativeFunction<GlIsFramebufferNative>>>(glGetProcAddress(CString.fromUtf8('glIsFramebuffer'))).asFunction<GlIsFramebuffer>();
  glBindFramebuffer = fromAddress<Pointer<NativeFunction<GlBindFramebufferNative>>>(glGetProcAddress(CString.fromUtf8('glBindFramebuffer'))).asFunction<GlBindFramebuffer>();
  glDeleteFramebuffers = fromAddress<Pointer<NativeFunction<GlDeleteFramebuffersNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteFramebuffers'))).asFunction<GlDeleteFramebuffers>();
  glGenFramebuffers = fromAddress<Pointer<NativeFunction<GlGenFramebuffersNative>>>(glGetProcAddress(CString.fromUtf8('glGenFramebuffers'))).asFunction<GlGenFramebuffers>();
  glCheckFramebufferStatus = fromAddress<Pointer<NativeFunction<GlCheckFramebufferStatusNative>>>(glGetProcAddress(CString.fromUtf8('glCheckFramebufferStatus'))).asFunction<GlCheckFramebufferStatus>();
  glFramebufferTexture1D = fromAddress<Pointer<NativeFunction<GlFramebufferTexture1DNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTexture1D'))).asFunction<GlFramebufferTexture1D>();
  glFramebufferTexture2D = fromAddress<Pointer<NativeFunction<GlFramebufferTexture2DNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTexture2D'))).asFunction<GlFramebufferTexture2D>();
  glFramebufferTexture3D = fromAddress<Pointer<NativeFunction<GlFramebufferTexture3DNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTexture3D'))).asFunction<GlFramebufferTexture3D>();
  glFramebufferRenderbuffer = fromAddress<Pointer<NativeFunction<GlFramebufferRenderbufferNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferRenderbuffer'))).asFunction<GlFramebufferRenderbuffer>();
  glGetFramebufferAttachmentParameteriv = fromAddress<Pointer<NativeFunction<GlGetFramebufferAttachmentParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetFramebufferAttachmentParameteriv'))).asFunction<GlGetFramebufferAttachmentParameteriv>();
  glGenerateMipmap = fromAddress<Pointer<NativeFunction<GlGenerateMipmapNative>>>(glGetProcAddress(CString.fromUtf8('glGenerateMipmap'))).asFunction<GlGenerateMipmap>();
  glBlitFramebuffer = fromAddress<Pointer<NativeFunction<GlBlitFramebufferNative>>>(glGetProcAddress(CString.fromUtf8('glBlitFramebuffer'))).asFunction<GlBlitFramebuffer>();
  glRenderbufferStorageMultisample = fromAddress<Pointer<NativeFunction<GlRenderbufferStorageMultisampleNative>>>(glGetProcAddress(CString.fromUtf8('glRenderbufferStorageMultisample'))).asFunction<GlRenderbufferStorageMultisample>();
  glFramebufferTextureLayer = fromAddress<Pointer<NativeFunction<GlFramebufferTextureLayerNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTextureLayer'))).asFunction<GlFramebufferTextureLayer>();
  glMapBufferRange = fromAddress<Pointer<NativeFunction<GlMapBufferRangeNative>>>(glGetProcAddress(CString.fromUtf8('glMapBufferRange'))).asFunction<GlMapBufferRange>();
  glFlushMappedBufferRange = fromAddress<Pointer<NativeFunction<GlFlushMappedBufferRangeNative>>>(glGetProcAddress(CString.fromUtf8('glFlushMappedBufferRange'))).asFunction<GlFlushMappedBufferRange>();
  glBindVertexArray = fromAddress<Pointer<NativeFunction<GlBindVertexArrayNative>>>(glGetProcAddress(CString.fromUtf8('glBindVertexArray'))).asFunction<GlBindVertexArray>();
  glDeleteVertexArrays = fromAddress<Pointer<NativeFunction<GlDeleteVertexArraysNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteVertexArrays'))).asFunction<GlDeleteVertexArrays>();
  glGenVertexArrays = fromAddress<Pointer<NativeFunction<GlGenVertexArraysNative>>>(glGetProcAddress(CString.fromUtf8('glGenVertexArrays'))).asFunction<GlGenVertexArrays>();
  glIsVertexArray = fromAddress<Pointer<NativeFunction<GlIsVertexArrayNative>>>(glGetProcAddress(CString.fromUtf8('glIsVertexArray'))).asFunction<GlIsVertexArray>();
  glDrawArraysInstanced = fromAddress<Pointer<NativeFunction<GlDrawArraysInstancedNative>>>(glGetProcAddress(CString.fromUtf8('glDrawArraysInstanced'))).asFunction<GlDrawArraysInstanced>();
  glDrawElementsInstanced = fromAddress<Pointer<NativeFunction<GlDrawElementsInstancedNative>>>(glGetProcAddress(CString.fromUtf8('glDrawElementsInstanced'))).asFunction<GlDrawElementsInstanced>();
  glTexBuffer = fromAddress<Pointer<NativeFunction<GlTexBufferNative>>>(glGetProcAddress(CString.fromUtf8('glTexBuffer'))).asFunction<GlTexBuffer>();
  glPrimitiveRestartIndex = fromAddress<Pointer<NativeFunction<GlPrimitiveRestartIndexNative>>>(glGetProcAddress(CString.fromUtf8('glPrimitiveRestartIndex'))).asFunction<GlPrimitiveRestartIndex>();
  glCopyBufferSubData = fromAddress<Pointer<NativeFunction<GlCopyBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glCopyBufferSubData'))).asFunction<GlCopyBufferSubData>();
  glGetUniformIndices = fromAddress<Pointer<NativeFunction<GlGetUniformIndicesNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformIndices'))).asFunction<GlGetUniformIndices>();
  glGetActiveUniformsiv = fromAddress<Pointer<NativeFunction<GlGetActiveUniformsivNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveUniformsiv'))).asFunction<GlGetActiveUniformsiv>();
  glGetActiveUniformName = fromAddress<Pointer<NativeFunction<GlGetActiveUniformNameNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveUniformName'))).asFunction<GlGetActiveUniformName>();
  glGetUniformBlockIndex = fromAddress<Pointer<NativeFunction<GlGetUniformBlockIndexNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformBlockIndex'))).asFunction<GlGetUniformBlockIndex>();
  glGetActiveUniformBlockiv = fromAddress<Pointer<NativeFunction<GlGetActiveUniformBlockivNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveUniformBlockiv'))).asFunction<GlGetActiveUniformBlockiv>();
  glGetActiveUniformBlockName = fromAddress<Pointer<NativeFunction<GlGetActiveUniformBlockNameNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveUniformBlockName'))).asFunction<GlGetActiveUniformBlockName>();
  glUniformBlockBinding = fromAddress<Pointer<NativeFunction<GlUniformBlockBindingNative>>>(glGetProcAddress(CString.fromUtf8('glUniformBlockBinding'))).asFunction<GlUniformBlockBinding>();
  glDrawElementsBaseVertex = fromAddress<Pointer<NativeFunction<GlDrawElementsBaseVertexNative>>>(glGetProcAddress(CString.fromUtf8('glDrawElementsBaseVertex'))).asFunction<GlDrawElementsBaseVertex>();
  glDrawRangeElementsBaseVertex = fromAddress<Pointer<NativeFunction<GlDrawRangeElementsBaseVertexNative>>>(glGetProcAddress(CString.fromUtf8('glDrawRangeElementsBaseVertex'))).asFunction<GlDrawRangeElementsBaseVertex>();
  glDrawElementsInstancedBaseVertex = fromAddress<Pointer<NativeFunction<GlDrawElementsInstancedBaseVertexNative>>>(glGetProcAddress(CString.fromUtf8('glDrawElementsInstancedBaseVertex'))).asFunction<GlDrawElementsInstancedBaseVertex>();
  glMultiDrawElementsBaseVertex = fromAddress<Pointer<NativeFunction<GlMultiDrawElementsBaseVertexNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawElementsBaseVertex'))).asFunction<GlMultiDrawElementsBaseVertex>();
  glProvokingVertex = fromAddress<Pointer<NativeFunction<GlProvokingVertexNative>>>(glGetProcAddress(CString.fromUtf8('glProvokingVertex'))).asFunction<GlProvokingVertex>();
  glFenceSync = fromAddress<Pointer<NativeFunction<GlFenceSyncNative>>>(glGetProcAddress(CString.fromUtf8('glFenceSync'))).asFunction<GlFenceSync>();
  glIsSync = fromAddress<Pointer<NativeFunction<GlIsSyncNative>>>(glGetProcAddress(CString.fromUtf8('glIsSync'))).asFunction<GlIsSync>();
  glDeleteSync = fromAddress<Pointer<NativeFunction<GlDeleteSyncNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteSync'))).asFunction<GlDeleteSync>();
  glClientWaitSync = fromAddress<Pointer<NativeFunction<GlClientWaitSyncNative>>>(glGetProcAddress(CString.fromUtf8('glClientWaitSync'))).asFunction<GlClientWaitSync>();
  glWaitSync = fromAddress<Pointer<NativeFunction<GlWaitSyncNative>>>(glGetProcAddress(CString.fromUtf8('glWaitSync'))).asFunction<GlWaitSync>();
  glGetInteger64v = fromAddress<Pointer<NativeFunction<GlGetInteger64vNative>>>(glGetProcAddress(CString.fromUtf8('glGetInteger64v'))).asFunction<GlGetInteger64v>();
  glGetSynciv = fromAddress<Pointer<NativeFunction<GlGetSyncivNative>>>(glGetProcAddress(CString.fromUtf8('glGetSynciv'))).asFunction<GlGetSynciv>();
  glGetInteger64i_v = fromAddress<Pointer<NativeFunction<GlGetInteger64i_vNative>>>(glGetProcAddress(CString.fromUtf8('glGetInteger64i_v'))).asFunction<GlGetInteger64i_v>();
  glGetBufferParameteri64v = fromAddress<Pointer<NativeFunction<GlGetBufferParameteri64vNative>>>(glGetProcAddress(CString.fromUtf8('glGetBufferParameteri64v'))).asFunction<GlGetBufferParameteri64v>();
  glFramebufferTexture = fromAddress<Pointer<NativeFunction<GlFramebufferTextureNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTexture'))).asFunction<GlFramebufferTexture>();
  glTexImage2DMultisample = fromAddress<Pointer<NativeFunction<GlTexImage2DMultisampleNative>>>(glGetProcAddress(CString.fromUtf8('glTexImage2DMultisample'))).asFunction<GlTexImage2DMultisample>();
  glTexImage3DMultisample = fromAddress<Pointer<NativeFunction<GlTexImage3DMultisampleNative>>>(glGetProcAddress(CString.fromUtf8('glTexImage3DMultisample'))).asFunction<GlTexImage3DMultisample>();
  glGetMultisamplefv = fromAddress<Pointer<NativeFunction<GlGetMultisamplefvNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultisamplefv'))).asFunction<GlGetMultisamplefv>();
  glSampleMaski = fromAddress<Pointer<NativeFunction<GlSampleMaskiNative>>>(glGetProcAddress(CString.fromUtf8('glSampleMaski'))).asFunction<GlSampleMaski>();
  glBindFragDataLocationIndexed = fromAddress<Pointer<NativeFunction<GlBindFragDataLocationIndexedNative>>>(glGetProcAddress(CString.fromUtf8('glBindFragDataLocationIndexed'))).asFunction<GlBindFragDataLocationIndexed>();
  glGetFragDataIndex = fromAddress<Pointer<NativeFunction<GlGetFragDataIndexNative>>>(glGetProcAddress(CString.fromUtf8('glGetFragDataIndex'))).asFunction<GlGetFragDataIndex>();
  glGenSamplers = fromAddress<Pointer<NativeFunction<GlGenSamplersNative>>>(glGetProcAddress(CString.fromUtf8('glGenSamplers'))).asFunction<GlGenSamplers>();
  glDeleteSamplers = fromAddress<Pointer<NativeFunction<GlDeleteSamplersNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteSamplers'))).asFunction<GlDeleteSamplers>();
  glIsSampler = fromAddress<Pointer<NativeFunction<GlIsSamplerNative>>>(glGetProcAddress(CString.fromUtf8('glIsSampler'))).asFunction<GlIsSampler>();
  glBindSampler = fromAddress<Pointer<NativeFunction<GlBindSamplerNative>>>(glGetProcAddress(CString.fromUtf8('glBindSampler'))).asFunction<GlBindSampler>();
  glSamplerParameteri = fromAddress<Pointer<NativeFunction<GlSamplerParameteriNative>>>(glGetProcAddress(CString.fromUtf8('glSamplerParameteri'))).asFunction<GlSamplerParameteri>();
  glSamplerParameteriv = fromAddress<Pointer<NativeFunction<GlSamplerParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glSamplerParameteriv'))).asFunction<GlSamplerParameteriv>();
  glSamplerParameterf = fromAddress<Pointer<NativeFunction<GlSamplerParameterfNative>>>(glGetProcAddress(CString.fromUtf8('glSamplerParameterf'))).asFunction<GlSamplerParameterf>();
  glSamplerParameterfv = fromAddress<Pointer<NativeFunction<GlSamplerParameterfvNative>>>(glGetProcAddress(CString.fromUtf8('glSamplerParameterfv'))).asFunction<GlSamplerParameterfv>();
  glSamplerParameterIiv = fromAddress<Pointer<NativeFunction<GlSamplerParameterIivNative>>>(glGetProcAddress(CString.fromUtf8('glSamplerParameterIiv'))).asFunction<GlSamplerParameterIiv>();
  glSamplerParameterIuiv = fromAddress<Pointer<NativeFunction<GlSamplerParameterIuivNative>>>(glGetProcAddress(CString.fromUtf8('glSamplerParameterIuiv'))).asFunction<GlSamplerParameterIuiv>();
  glGetSamplerParameteriv = fromAddress<Pointer<NativeFunction<GlGetSamplerParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetSamplerParameteriv'))).asFunction<GlGetSamplerParameteriv>();
  glGetSamplerParameterIiv = fromAddress<Pointer<NativeFunction<GlGetSamplerParameterIivNative>>>(glGetProcAddress(CString.fromUtf8('glGetSamplerParameterIiv'))).asFunction<GlGetSamplerParameterIiv>();
  glGetSamplerParameterfv = fromAddress<Pointer<NativeFunction<GlGetSamplerParameterfvNative>>>(glGetProcAddress(CString.fromUtf8('glGetSamplerParameterfv'))).asFunction<GlGetSamplerParameterfv>();
  glGetSamplerParameterIuiv = fromAddress<Pointer<NativeFunction<GlGetSamplerParameterIuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetSamplerParameterIuiv'))).asFunction<GlGetSamplerParameterIuiv>();
  glQueryCounter = fromAddress<Pointer<NativeFunction<GlQueryCounterNative>>>(glGetProcAddress(CString.fromUtf8('glQueryCounter'))).asFunction<GlQueryCounter>();
  glGetQueryObjecti64v = fromAddress<Pointer<NativeFunction<GlGetQueryObjecti64vNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryObjecti64v'))).asFunction<GlGetQueryObjecti64v>();
  glGetQueryObjectui64v = fromAddress<Pointer<NativeFunction<GlGetQueryObjectui64vNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryObjectui64v'))).asFunction<GlGetQueryObjectui64v>();
  glVertexAttribDivisor = fromAddress<Pointer<NativeFunction<GlVertexAttribDivisorNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribDivisor'))).asFunction<GlVertexAttribDivisor>();
  glVertexAttribP1ui = fromAddress<Pointer<NativeFunction<GlVertexAttribP1uiNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribP1ui'))).asFunction<GlVertexAttribP1ui>();
  glVertexAttribP1uiv = fromAddress<Pointer<NativeFunction<GlVertexAttribP1uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribP1uiv'))).asFunction<GlVertexAttribP1uiv>();
  glVertexAttribP2ui = fromAddress<Pointer<NativeFunction<GlVertexAttribP2uiNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribP2ui'))).asFunction<GlVertexAttribP2ui>();
  glVertexAttribP2uiv = fromAddress<Pointer<NativeFunction<GlVertexAttribP2uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribP2uiv'))).asFunction<GlVertexAttribP2uiv>();
  glVertexAttribP3ui = fromAddress<Pointer<NativeFunction<GlVertexAttribP3uiNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribP3ui'))).asFunction<GlVertexAttribP3ui>();
  glVertexAttribP3uiv = fromAddress<Pointer<NativeFunction<GlVertexAttribP3uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribP3uiv'))).asFunction<GlVertexAttribP3uiv>();
  glVertexAttribP4ui = fromAddress<Pointer<NativeFunction<GlVertexAttribP4uiNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribP4ui'))).asFunction<GlVertexAttribP4ui>();
  glVertexAttribP4uiv = fromAddress<Pointer<NativeFunction<GlVertexAttribP4uivNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribP4uiv'))).asFunction<GlVertexAttribP4uiv>();
  glMinSampleShading = fromAddress<Pointer<NativeFunction<GlMinSampleShadingNative>>>(glGetProcAddress(CString.fromUtf8('glMinSampleShading'))).asFunction<GlMinSampleShading>();
  glBlendEquationi = fromAddress<Pointer<NativeFunction<GlBlendEquationiNative>>>(glGetProcAddress(CString.fromUtf8('glBlendEquationi'))).asFunction<GlBlendEquationi>();
  glBlendEquationSeparatei = fromAddress<Pointer<NativeFunction<GlBlendEquationSeparateiNative>>>(glGetProcAddress(CString.fromUtf8('glBlendEquationSeparatei'))).asFunction<GlBlendEquationSeparatei>();
  glBlendFunci = fromAddress<Pointer<NativeFunction<GlBlendFunciNative>>>(glGetProcAddress(CString.fromUtf8('glBlendFunci'))).asFunction<GlBlendFunci>();
  glBlendFuncSeparatei = fromAddress<Pointer<NativeFunction<GlBlendFuncSeparateiNative>>>(glGetProcAddress(CString.fromUtf8('glBlendFuncSeparatei'))).asFunction<GlBlendFuncSeparatei>();
  glDrawArraysIndirect = fromAddress<Pointer<NativeFunction<GlDrawArraysIndirectNative>>>(glGetProcAddress(CString.fromUtf8('glDrawArraysIndirect'))).asFunction<GlDrawArraysIndirect>();
  glDrawElementsIndirect = fromAddress<Pointer<NativeFunction<GlDrawElementsIndirectNative>>>(glGetProcAddress(CString.fromUtf8('glDrawElementsIndirect'))).asFunction<GlDrawElementsIndirect>();
  glUniform1d = fromAddress<Pointer<NativeFunction<GlUniform1dNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1d'))).asFunction<GlUniform1d>();
  glUniform2d = fromAddress<Pointer<NativeFunction<GlUniform2dNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2d'))).asFunction<GlUniform2d>();
  glUniform3d = fromAddress<Pointer<NativeFunction<GlUniform3dNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3d'))).asFunction<GlUniform3d>();
  glUniform4d = fromAddress<Pointer<NativeFunction<GlUniform4dNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4d'))).asFunction<GlUniform4d>();
  glUniform1dv = fromAddress<Pointer<NativeFunction<GlUniform1dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1dv'))).asFunction<GlUniform1dv>();
  glUniform2dv = fromAddress<Pointer<NativeFunction<GlUniform2dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2dv'))).asFunction<GlUniform2dv>();
  glUniform3dv = fromAddress<Pointer<NativeFunction<GlUniform3dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3dv'))).asFunction<GlUniform3dv>();
  glUniform4dv = fromAddress<Pointer<NativeFunction<GlUniform4dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4dv'))).asFunction<GlUniform4dv>();
  glUniformMatrix2dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix2dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix2dv'))).asFunction<GlUniformMatrix2dv>();
  glUniformMatrix3dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix3dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix3dv'))).asFunction<GlUniformMatrix3dv>();
  glUniformMatrix4dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix4dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix4dv'))).asFunction<GlUniformMatrix4dv>();
  glUniformMatrix2x3dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix2x3dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix2x3dv'))).asFunction<GlUniformMatrix2x3dv>();
  glUniformMatrix2x4dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix2x4dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix2x4dv'))).asFunction<GlUniformMatrix2x4dv>();
  glUniformMatrix3x2dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix3x2dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix3x2dv'))).asFunction<GlUniformMatrix3x2dv>();
  glUniformMatrix3x4dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix3x4dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix3x4dv'))).asFunction<GlUniformMatrix3x4dv>();
  glUniformMatrix4x2dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix4x2dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix4x2dv'))).asFunction<GlUniformMatrix4x2dv>();
  glUniformMatrix4x3dv = fromAddress<Pointer<NativeFunction<GlUniformMatrix4x3dvNative>>>(glGetProcAddress(CString.fromUtf8('glUniformMatrix4x3dv'))).asFunction<GlUniformMatrix4x3dv>();
  glGetUniformdv = fromAddress<Pointer<NativeFunction<GlGetUniformdvNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformdv'))).asFunction<GlGetUniformdv>();
  glGetSubroutineUniformLocation = fromAddress<Pointer<NativeFunction<GlGetSubroutineUniformLocationNative>>>(glGetProcAddress(CString.fromUtf8('glGetSubroutineUniformLocation'))).asFunction<GlGetSubroutineUniformLocation>();
  glGetSubroutineIndex = fromAddress<Pointer<NativeFunction<GlGetSubroutineIndexNative>>>(glGetProcAddress(CString.fromUtf8('glGetSubroutineIndex'))).asFunction<GlGetSubroutineIndex>();
  glGetActiveSubroutineUniformiv = fromAddress<Pointer<NativeFunction<GlGetActiveSubroutineUniformivNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveSubroutineUniformiv'))).asFunction<GlGetActiveSubroutineUniformiv>();
  glGetActiveSubroutineUniformName = fromAddress<Pointer<NativeFunction<GlGetActiveSubroutineUniformNameNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveSubroutineUniformName'))).asFunction<GlGetActiveSubroutineUniformName>();
  glGetActiveSubroutineName = fromAddress<Pointer<NativeFunction<GlGetActiveSubroutineNameNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveSubroutineName'))).asFunction<GlGetActiveSubroutineName>();
  glUniformSubroutinesuiv = fromAddress<Pointer<NativeFunction<GlUniformSubroutinesuivNative>>>(glGetProcAddress(CString.fromUtf8('glUniformSubroutinesuiv'))).asFunction<GlUniformSubroutinesuiv>();
  glGetUniformSubroutineuiv = fromAddress<Pointer<NativeFunction<GlGetUniformSubroutineuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformSubroutineuiv'))).asFunction<GlGetUniformSubroutineuiv>();
  glGetProgramStageiv = fromAddress<Pointer<NativeFunction<GlGetProgramStageivNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramStageiv'))).asFunction<GlGetProgramStageiv>();
  glPatchParameteri = fromAddress<Pointer<NativeFunction<GlPatchParameteriNative>>>(glGetProcAddress(CString.fromUtf8('glPatchParameteri'))).asFunction<GlPatchParameteri>();
  glPatchParameterfv = fromAddress<Pointer<NativeFunction<GlPatchParameterfvNative>>>(glGetProcAddress(CString.fromUtf8('glPatchParameterfv'))).asFunction<GlPatchParameterfv>();
  glBindTransformFeedback = fromAddress<Pointer<NativeFunction<GlBindTransformFeedbackNative>>>(glGetProcAddress(CString.fromUtf8('glBindTransformFeedback'))).asFunction<GlBindTransformFeedback>();
  glDeleteTransformFeedbacks = fromAddress<Pointer<NativeFunction<GlDeleteTransformFeedbacksNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteTransformFeedbacks'))).asFunction<GlDeleteTransformFeedbacks>();
  glGenTransformFeedbacks = fromAddress<Pointer<NativeFunction<GlGenTransformFeedbacksNative>>>(glGetProcAddress(CString.fromUtf8('glGenTransformFeedbacks'))).asFunction<GlGenTransformFeedbacks>();
  glIsTransformFeedback = fromAddress<Pointer<NativeFunction<GlIsTransformFeedbackNative>>>(glGetProcAddress(CString.fromUtf8('glIsTransformFeedback'))).asFunction<GlIsTransformFeedback>();
  glPauseTransformFeedback = fromAddress<Pointer<NativeFunction<GlPauseTransformFeedbackNative>>>(glGetProcAddress(CString.fromUtf8('glPauseTransformFeedback'))).asFunction<GlPauseTransformFeedback>();
  glResumeTransformFeedback = fromAddress<Pointer<NativeFunction<GlResumeTransformFeedbackNative>>>(glGetProcAddress(CString.fromUtf8('glResumeTransformFeedback'))).asFunction<GlResumeTransformFeedback>();
  glDrawTransformFeedback = fromAddress<Pointer<NativeFunction<GlDrawTransformFeedbackNative>>>(glGetProcAddress(CString.fromUtf8('glDrawTransformFeedback'))).asFunction<GlDrawTransformFeedback>();
  glDrawTransformFeedbackStream = fromAddress<Pointer<NativeFunction<GlDrawTransformFeedbackStreamNative>>>(glGetProcAddress(CString.fromUtf8('glDrawTransformFeedbackStream'))).asFunction<GlDrawTransformFeedbackStream>();
  glBeginQueryIndexed = fromAddress<Pointer<NativeFunction<GlBeginQueryIndexedNative>>>(glGetProcAddress(CString.fromUtf8('glBeginQueryIndexed'))).asFunction<GlBeginQueryIndexed>();
  glEndQueryIndexed = fromAddress<Pointer<NativeFunction<GlEndQueryIndexedNative>>>(glGetProcAddress(CString.fromUtf8('glEndQueryIndexed'))).asFunction<GlEndQueryIndexed>();
  glGetQueryIndexediv = fromAddress<Pointer<NativeFunction<GlGetQueryIndexedivNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryIndexediv'))).asFunction<GlGetQueryIndexediv>();
  glReleaseShaderCompiler = fromAddress<Pointer<NativeFunction<GlReleaseShaderCompilerNative>>>(glGetProcAddress(CString.fromUtf8('glReleaseShaderCompiler'))).asFunction<GlReleaseShaderCompiler>();
  glShaderBinary = fromAddress<Pointer<NativeFunction<GlShaderBinaryNative>>>(glGetProcAddress(CString.fromUtf8('glShaderBinary'))).asFunction<GlShaderBinary>();
  glGetShaderPrecisionFormat = fromAddress<Pointer<NativeFunction<GlGetShaderPrecisionFormatNative>>>(glGetProcAddress(CString.fromUtf8('glGetShaderPrecisionFormat'))).asFunction<GlGetShaderPrecisionFormat>();
  glDepthRangef = fromAddress<Pointer<NativeFunction<GlDepthRangefNative>>>(glGetProcAddress(CString.fromUtf8('glDepthRangef'))).asFunction<GlDepthRangef>();
  glClearDepthf = fromAddress<Pointer<NativeFunction<GlClearDepthfNative>>>(glGetProcAddress(CString.fromUtf8('glClearDepthf'))).asFunction<GlClearDepthf>();
  glGetProgramBinary = fromAddress<Pointer<NativeFunction<GlGetProgramBinaryNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramBinary'))).asFunction<GlGetProgramBinary>();
  glProgramBinary = fromAddress<Pointer<NativeFunction<GlProgramBinaryNative>>>(glGetProcAddress(CString.fromUtf8('glProgramBinary'))).asFunction<GlProgramBinary>();
  glProgramParameteri = fromAddress<Pointer<NativeFunction<GlProgramParameteriNative>>>(glGetProcAddress(CString.fromUtf8('glProgramParameteri'))).asFunction<GlProgramParameteri>();
  glUseProgramStages = fromAddress<Pointer<NativeFunction<GlUseProgramStagesNative>>>(glGetProcAddress(CString.fromUtf8('glUseProgramStages'))).asFunction<GlUseProgramStages>();
  glActiveShaderProgram = fromAddress<Pointer<NativeFunction<GlActiveShaderProgramNative>>>(glGetProcAddress(CString.fromUtf8('glActiveShaderProgram'))).asFunction<GlActiveShaderProgram>();
  glCreateShaderProgramv = fromAddress<Pointer<NativeFunction<GlCreateShaderProgramvNative>>>(glGetProcAddress(CString.fromUtf8('glCreateShaderProgramv'))).asFunction<GlCreateShaderProgramv>();
  glBindProgramPipeline = fromAddress<Pointer<NativeFunction<GlBindProgramPipelineNative>>>(glGetProcAddress(CString.fromUtf8('glBindProgramPipeline'))).asFunction<GlBindProgramPipeline>();
  glDeleteProgramPipelines = fromAddress<Pointer<NativeFunction<GlDeleteProgramPipelinesNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteProgramPipelines'))).asFunction<GlDeleteProgramPipelines>();
  glGenProgramPipelines = fromAddress<Pointer<NativeFunction<GlGenProgramPipelinesNative>>>(glGetProcAddress(CString.fromUtf8('glGenProgramPipelines'))).asFunction<GlGenProgramPipelines>();
  glIsProgramPipeline = fromAddress<Pointer<NativeFunction<GlIsProgramPipelineNative>>>(glGetProcAddress(CString.fromUtf8('glIsProgramPipeline'))).asFunction<GlIsProgramPipeline>();
  glGetProgramPipelineiv = fromAddress<Pointer<NativeFunction<GlGetProgramPipelineivNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramPipelineiv'))).asFunction<GlGetProgramPipelineiv>();
  glProgramUniform1i = fromAddress<Pointer<NativeFunction<GlProgramUniform1iNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1i'))).asFunction<GlProgramUniform1i>();
  glProgramUniform1iv = fromAddress<Pointer<NativeFunction<GlProgramUniform1ivNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1iv'))).asFunction<GlProgramUniform1iv>();
  glProgramUniform1f = fromAddress<Pointer<NativeFunction<GlProgramUniform1fNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1f'))).asFunction<GlProgramUniform1f>();
  glProgramUniform1fv = fromAddress<Pointer<NativeFunction<GlProgramUniform1fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1fv'))).asFunction<GlProgramUniform1fv>();
  glProgramUniform1d = fromAddress<Pointer<NativeFunction<GlProgramUniform1dNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1d'))).asFunction<GlProgramUniform1d>();
  glProgramUniform1dv = fromAddress<Pointer<NativeFunction<GlProgramUniform1dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1dv'))).asFunction<GlProgramUniform1dv>();
  glProgramUniform1ui = fromAddress<Pointer<NativeFunction<GlProgramUniform1uiNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1ui'))).asFunction<GlProgramUniform1ui>();
  glProgramUniform1uiv = fromAddress<Pointer<NativeFunction<GlProgramUniform1uivNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1uiv'))).asFunction<GlProgramUniform1uiv>();
  glProgramUniform2i = fromAddress<Pointer<NativeFunction<GlProgramUniform2iNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2i'))).asFunction<GlProgramUniform2i>();
  glProgramUniform2iv = fromAddress<Pointer<NativeFunction<GlProgramUniform2ivNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2iv'))).asFunction<GlProgramUniform2iv>();
  glProgramUniform2f = fromAddress<Pointer<NativeFunction<GlProgramUniform2fNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2f'))).asFunction<GlProgramUniform2f>();
  glProgramUniform2fv = fromAddress<Pointer<NativeFunction<GlProgramUniform2fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2fv'))).asFunction<GlProgramUniform2fv>();
  glProgramUniform2d = fromAddress<Pointer<NativeFunction<GlProgramUniform2dNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2d'))).asFunction<GlProgramUniform2d>();
  glProgramUniform2dv = fromAddress<Pointer<NativeFunction<GlProgramUniform2dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2dv'))).asFunction<GlProgramUniform2dv>();
  glProgramUniform2ui = fromAddress<Pointer<NativeFunction<GlProgramUniform2uiNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2ui'))).asFunction<GlProgramUniform2ui>();
  glProgramUniform2uiv = fromAddress<Pointer<NativeFunction<GlProgramUniform2uivNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2uiv'))).asFunction<GlProgramUniform2uiv>();
  glProgramUniform3i = fromAddress<Pointer<NativeFunction<GlProgramUniform3iNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3i'))).asFunction<GlProgramUniform3i>();
  glProgramUniform3iv = fromAddress<Pointer<NativeFunction<GlProgramUniform3ivNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3iv'))).asFunction<GlProgramUniform3iv>();
  glProgramUniform3f = fromAddress<Pointer<NativeFunction<GlProgramUniform3fNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3f'))).asFunction<GlProgramUniform3f>();
  glProgramUniform3fv = fromAddress<Pointer<NativeFunction<GlProgramUniform3fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3fv'))).asFunction<GlProgramUniform3fv>();
  glProgramUniform3d = fromAddress<Pointer<NativeFunction<GlProgramUniform3dNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3d'))).asFunction<GlProgramUniform3d>();
  glProgramUniform3dv = fromAddress<Pointer<NativeFunction<GlProgramUniform3dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3dv'))).asFunction<GlProgramUniform3dv>();
  glProgramUniform3ui = fromAddress<Pointer<NativeFunction<GlProgramUniform3uiNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3ui'))).asFunction<GlProgramUniform3ui>();
  glProgramUniform3uiv = fromAddress<Pointer<NativeFunction<GlProgramUniform3uivNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3uiv'))).asFunction<GlProgramUniform3uiv>();
  glProgramUniform4i = fromAddress<Pointer<NativeFunction<GlProgramUniform4iNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4i'))).asFunction<GlProgramUniform4i>();
  glProgramUniform4iv = fromAddress<Pointer<NativeFunction<GlProgramUniform4ivNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4iv'))).asFunction<GlProgramUniform4iv>();
  glProgramUniform4f = fromAddress<Pointer<NativeFunction<GlProgramUniform4fNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4f'))).asFunction<GlProgramUniform4f>();
  glProgramUniform4fv = fromAddress<Pointer<NativeFunction<GlProgramUniform4fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4fv'))).asFunction<GlProgramUniform4fv>();
  glProgramUniform4d = fromAddress<Pointer<NativeFunction<GlProgramUniform4dNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4d'))).asFunction<GlProgramUniform4d>();
  glProgramUniform4dv = fromAddress<Pointer<NativeFunction<GlProgramUniform4dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4dv'))).asFunction<GlProgramUniform4dv>();
  glProgramUniform4ui = fromAddress<Pointer<NativeFunction<GlProgramUniform4uiNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4ui'))).asFunction<GlProgramUniform4ui>();
  glProgramUniform4uiv = fromAddress<Pointer<NativeFunction<GlProgramUniform4uivNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4uiv'))).asFunction<GlProgramUniform4uiv>();
  glProgramUniformMatrix2fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2fv'))).asFunction<GlProgramUniformMatrix2fv>();
  glProgramUniformMatrix3fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3fv'))).asFunction<GlProgramUniformMatrix3fv>();
  glProgramUniformMatrix4fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4fv'))).asFunction<GlProgramUniformMatrix4fv>();
  glProgramUniformMatrix2dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2dv'))).asFunction<GlProgramUniformMatrix2dv>();
  glProgramUniformMatrix3dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3dv'))).asFunction<GlProgramUniformMatrix3dv>();
  glProgramUniformMatrix4dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4dv'))).asFunction<GlProgramUniformMatrix4dv>();
  glProgramUniformMatrix2x3fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2x3fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2x3fv'))).asFunction<GlProgramUniformMatrix2x3fv>();
  glProgramUniformMatrix3x2fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3x2fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3x2fv'))).asFunction<GlProgramUniformMatrix3x2fv>();
  glProgramUniformMatrix2x4fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2x4fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2x4fv'))).asFunction<GlProgramUniformMatrix2x4fv>();
  glProgramUniformMatrix4x2fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4x2fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4x2fv'))).asFunction<GlProgramUniformMatrix4x2fv>();
  glProgramUniformMatrix3x4fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3x4fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3x4fv'))).asFunction<GlProgramUniformMatrix3x4fv>();
  glProgramUniformMatrix4x3fv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4x3fvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4x3fv'))).asFunction<GlProgramUniformMatrix4x3fv>();
  glProgramUniformMatrix2x3dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2x3dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2x3dv'))).asFunction<GlProgramUniformMatrix2x3dv>();
  glProgramUniformMatrix3x2dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3x2dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3x2dv'))).asFunction<GlProgramUniformMatrix3x2dv>();
  glProgramUniformMatrix2x4dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2x4dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2x4dv'))).asFunction<GlProgramUniformMatrix2x4dv>();
  glProgramUniformMatrix4x2dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4x2dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4x2dv'))).asFunction<GlProgramUniformMatrix4x2dv>();
  glProgramUniformMatrix3x4dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3x4dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3x4dv'))).asFunction<GlProgramUniformMatrix3x4dv>();
  glProgramUniformMatrix4x3dv = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4x3dvNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4x3dv'))).asFunction<GlProgramUniformMatrix4x3dv>();
  glValidateProgramPipeline = fromAddress<Pointer<NativeFunction<GlValidateProgramPipelineNative>>>(glGetProcAddress(CString.fromUtf8('glValidateProgramPipeline'))).asFunction<GlValidateProgramPipeline>();
  glGetProgramPipelineInfoLog = fromAddress<Pointer<NativeFunction<GlGetProgramPipelineInfoLogNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramPipelineInfoLog'))).asFunction<GlGetProgramPipelineInfoLog>();
  glVertexAttribL1d = fromAddress<Pointer<NativeFunction<GlVertexAttribL1dNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL1d'))).asFunction<GlVertexAttribL1d>();
  glVertexAttribL2d = fromAddress<Pointer<NativeFunction<GlVertexAttribL2dNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL2d'))).asFunction<GlVertexAttribL2d>();
  glVertexAttribL3d = fromAddress<Pointer<NativeFunction<GlVertexAttribL3dNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL3d'))).asFunction<GlVertexAttribL3d>();
  glVertexAttribL4d = fromAddress<Pointer<NativeFunction<GlVertexAttribL4dNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL4d'))).asFunction<GlVertexAttribL4d>();
  glVertexAttribL1dv = fromAddress<Pointer<NativeFunction<GlVertexAttribL1dvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL1dv'))).asFunction<GlVertexAttribL1dv>();
  glVertexAttribL2dv = fromAddress<Pointer<NativeFunction<GlVertexAttribL2dvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL2dv'))).asFunction<GlVertexAttribL2dv>();
  glVertexAttribL3dv = fromAddress<Pointer<NativeFunction<GlVertexAttribL3dvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL3dv'))).asFunction<GlVertexAttribL3dv>();
  glVertexAttribL4dv = fromAddress<Pointer<NativeFunction<GlVertexAttribL4dvNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL4dv'))).asFunction<GlVertexAttribL4dv>();
  glVertexAttribLPointer = fromAddress<Pointer<NativeFunction<GlVertexAttribLPointerNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribLPointer'))).asFunction<GlVertexAttribLPointer>();
  glGetVertexAttribLdv = fromAddress<Pointer<NativeFunction<GlGetVertexAttribLdvNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribLdv'))).asFunction<GlGetVertexAttribLdv>();
  glViewportArrayv = fromAddress<Pointer<NativeFunction<GlViewportArrayvNative>>>(glGetProcAddress(CString.fromUtf8('glViewportArrayv'))).asFunction<GlViewportArrayv>();
  glViewportIndexedf = fromAddress<Pointer<NativeFunction<GlViewportIndexedfNative>>>(glGetProcAddress(CString.fromUtf8('glViewportIndexedf'))).asFunction<GlViewportIndexedf>();
  glViewportIndexedfv = fromAddress<Pointer<NativeFunction<GlViewportIndexedfvNative>>>(glGetProcAddress(CString.fromUtf8('glViewportIndexedfv'))).asFunction<GlViewportIndexedfv>();
  glScissorArrayv = fromAddress<Pointer<NativeFunction<GlScissorArrayvNative>>>(glGetProcAddress(CString.fromUtf8('glScissorArrayv'))).asFunction<GlScissorArrayv>();
  glScissorIndexed = fromAddress<Pointer<NativeFunction<GlScissorIndexedNative>>>(glGetProcAddress(CString.fromUtf8('glScissorIndexed'))).asFunction<GlScissorIndexed>();
  glScissorIndexedv = fromAddress<Pointer<NativeFunction<GlScissorIndexedvNative>>>(glGetProcAddress(CString.fromUtf8('glScissorIndexedv'))).asFunction<GlScissorIndexedv>();
  glDepthRangeArrayv = fromAddress<Pointer<NativeFunction<GlDepthRangeArrayvNative>>>(glGetProcAddress(CString.fromUtf8('glDepthRangeArrayv'))).asFunction<GlDepthRangeArrayv>();
  glDepthRangeIndexed = fromAddress<Pointer<NativeFunction<GlDepthRangeIndexedNative>>>(glGetProcAddress(CString.fromUtf8('glDepthRangeIndexed'))).asFunction<GlDepthRangeIndexed>();
  glGetFloati_v = fromAddress<Pointer<NativeFunction<GlGetFloati_vNative>>>(glGetProcAddress(CString.fromUtf8('glGetFloati_v'))).asFunction<GlGetFloati_v>();
  glGetDoublei_v = fromAddress<Pointer<NativeFunction<GlGetDoublei_vNative>>>(glGetProcAddress(CString.fromUtf8('glGetDoublei_v'))).asFunction<GlGetDoublei_v>();
  glDrawArraysInstancedBaseInstance = fromAddress<Pointer<NativeFunction<GlDrawArraysInstancedBaseInstanceNative>>>(glGetProcAddress(CString.fromUtf8('glDrawArraysInstancedBaseInstance'))).asFunction<GlDrawArraysInstancedBaseInstance>();
  glDrawElementsInstancedBaseInstance = fromAddress<Pointer<NativeFunction<GlDrawElementsInstancedBaseInstanceNative>>>(glGetProcAddress(CString.fromUtf8('glDrawElementsInstancedBaseInstance'))).asFunction<GlDrawElementsInstancedBaseInstance>();
  glDrawElementsInstancedBaseVertexBaseInstance = fromAddress<Pointer<NativeFunction<GlDrawElementsInstancedBaseVertexBaseInstanceNative>>>(glGetProcAddress(CString.fromUtf8('glDrawElementsInstancedBaseVertexBaseInstance'))).asFunction<GlDrawElementsInstancedBaseVertexBaseInstance>();
  glGetInternalformativ = fromAddress<Pointer<NativeFunction<GlGetInternalformativNative>>>(glGetProcAddress(CString.fromUtf8('glGetInternalformativ'))).asFunction<GlGetInternalformativ>();
  glGetActiveAtomicCounterBufferiv = fromAddress<Pointer<NativeFunction<GlGetActiveAtomicCounterBufferivNative>>>(glGetProcAddress(CString.fromUtf8('glGetActiveAtomicCounterBufferiv'))).asFunction<GlGetActiveAtomicCounterBufferiv>();
  glBindImageTexture = fromAddress<Pointer<NativeFunction<GlBindImageTextureNative>>>(glGetProcAddress(CString.fromUtf8('glBindImageTexture'))).asFunction<GlBindImageTexture>();
  glMemoryBarrier = fromAddress<Pointer<NativeFunction<GlMemoryBarrierNative>>>(glGetProcAddress(CString.fromUtf8('glMemoryBarrier'))).asFunction<GlMemoryBarrier>();
  glTexStorage1D = fromAddress<Pointer<NativeFunction<GlTexStorage1DNative>>>(glGetProcAddress(CString.fromUtf8('glTexStorage1D'))).asFunction<GlTexStorage1D>();
  glTexStorage2D = fromAddress<Pointer<NativeFunction<GlTexStorage2DNative>>>(glGetProcAddress(CString.fromUtf8('glTexStorage2D'))).asFunction<GlTexStorage2D>();
  glTexStorage3D = fromAddress<Pointer<NativeFunction<GlTexStorage3DNative>>>(glGetProcAddress(CString.fromUtf8('glTexStorage3D'))).asFunction<GlTexStorage3D>();
  glDrawTransformFeedbackInstanced = fromAddress<Pointer<NativeFunction<GlDrawTransformFeedbackInstancedNative>>>(glGetProcAddress(CString.fromUtf8('glDrawTransformFeedbackInstanced'))).asFunction<GlDrawTransformFeedbackInstanced>();
  glDrawTransformFeedbackStreamInstanced = fromAddress<Pointer<NativeFunction<GlDrawTransformFeedbackStreamInstancedNative>>>(glGetProcAddress(CString.fromUtf8('glDrawTransformFeedbackStreamInstanced'))).asFunction<GlDrawTransformFeedbackStreamInstanced>();
  glClearBufferData = fromAddress<Pointer<NativeFunction<GlClearBufferDataNative>>>(glGetProcAddress(CString.fromUtf8('glClearBufferData'))).asFunction<GlClearBufferData>();
  glClearBufferSubData = fromAddress<Pointer<NativeFunction<GlClearBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glClearBufferSubData'))).asFunction<GlClearBufferSubData>();
  glDispatchCompute = fromAddress<Pointer<NativeFunction<GlDispatchComputeNative>>>(glGetProcAddress(CString.fromUtf8('glDispatchCompute'))).asFunction<GlDispatchCompute>();
  glDispatchComputeIndirect = fromAddress<Pointer<NativeFunction<GlDispatchComputeIndirectNative>>>(glGetProcAddress(CString.fromUtf8('glDispatchComputeIndirect'))).asFunction<GlDispatchComputeIndirect>();
  glCopyImageSubData = fromAddress<Pointer<NativeFunction<GlCopyImageSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glCopyImageSubData'))).asFunction<GlCopyImageSubData>();
  glFramebufferParameteri = fromAddress<Pointer<NativeFunction<GlFramebufferParameteriNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferParameteri'))).asFunction<GlFramebufferParameteri>();
  glGetFramebufferParameteriv = fromAddress<Pointer<NativeFunction<GlGetFramebufferParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetFramebufferParameteriv'))).asFunction<GlGetFramebufferParameteriv>();
  glGetInternalformati64v = fromAddress<Pointer<NativeFunction<GlGetInternalformati64vNative>>>(glGetProcAddress(CString.fromUtf8('glGetInternalformati64v'))).asFunction<GlGetInternalformati64v>();
  glInvalidateTexSubImage = fromAddress<Pointer<NativeFunction<GlInvalidateTexSubImageNative>>>(glGetProcAddress(CString.fromUtf8('glInvalidateTexSubImage'))).asFunction<GlInvalidateTexSubImage>();
  glInvalidateTexImage = fromAddress<Pointer<NativeFunction<GlInvalidateTexImageNative>>>(glGetProcAddress(CString.fromUtf8('glInvalidateTexImage'))).asFunction<GlInvalidateTexImage>();
  glInvalidateBufferSubData = fromAddress<Pointer<NativeFunction<GlInvalidateBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glInvalidateBufferSubData'))).asFunction<GlInvalidateBufferSubData>();
  glInvalidateBufferData = fromAddress<Pointer<NativeFunction<GlInvalidateBufferDataNative>>>(glGetProcAddress(CString.fromUtf8('glInvalidateBufferData'))).asFunction<GlInvalidateBufferData>();
  glInvalidateFramebuffer = fromAddress<Pointer<NativeFunction<GlInvalidateFramebufferNative>>>(glGetProcAddress(CString.fromUtf8('glInvalidateFramebuffer'))).asFunction<GlInvalidateFramebuffer>();
  glInvalidateSubFramebuffer = fromAddress<Pointer<NativeFunction<GlInvalidateSubFramebufferNative>>>(glGetProcAddress(CString.fromUtf8('glInvalidateSubFramebuffer'))).asFunction<GlInvalidateSubFramebuffer>();
  glMultiDrawArraysIndirect = fromAddress<Pointer<NativeFunction<GlMultiDrawArraysIndirectNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawArraysIndirect'))).asFunction<GlMultiDrawArraysIndirect>();
  glMultiDrawElementsIndirect = fromAddress<Pointer<NativeFunction<GlMultiDrawElementsIndirectNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawElementsIndirect'))).asFunction<GlMultiDrawElementsIndirect>();
  glGetProgramInterfaceiv = fromAddress<Pointer<NativeFunction<GlGetProgramInterfaceivNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramInterfaceiv'))).asFunction<GlGetProgramInterfaceiv>();
  glGetProgramResourceIndex = fromAddress<Pointer<NativeFunction<GlGetProgramResourceIndexNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramResourceIndex'))).asFunction<GlGetProgramResourceIndex>();
  glGetProgramResourceName = fromAddress<Pointer<NativeFunction<GlGetProgramResourceNameNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramResourceName'))).asFunction<GlGetProgramResourceName>();
  glGetProgramResourceiv = fromAddress<Pointer<NativeFunction<GlGetProgramResourceivNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramResourceiv'))).asFunction<GlGetProgramResourceiv>();
  glGetProgramResourceLocation = fromAddress<Pointer<NativeFunction<GlGetProgramResourceLocationNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramResourceLocation'))).asFunction<GlGetProgramResourceLocation>();
  glGetProgramResourceLocationIndex = fromAddress<Pointer<NativeFunction<GlGetProgramResourceLocationIndexNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramResourceLocationIndex'))).asFunction<GlGetProgramResourceLocationIndex>();
  glShaderStorageBlockBinding = fromAddress<Pointer<NativeFunction<GlShaderStorageBlockBindingNative>>>(glGetProcAddress(CString.fromUtf8('glShaderStorageBlockBinding'))).asFunction<GlShaderStorageBlockBinding>();
  glTexBufferRange = fromAddress<Pointer<NativeFunction<GlTexBufferRangeNative>>>(glGetProcAddress(CString.fromUtf8('glTexBufferRange'))).asFunction<GlTexBufferRange>();
  glTexStorage2DMultisample = fromAddress<Pointer<NativeFunction<GlTexStorage2DMultisampleNative>>>(glGetProcAddress(CString.fromUtf8('glTexStorage2DMultisample'))).asFunction<GlTexStorage2DMultisample>();
  glTexStorage3DMultisample = fromAddress<Pointer<NativeFunction<GlTexStorage3DMultisampleNative>>>(glGetProcAddress(CString.fromUtf8('glTexStorage3DMultisample'))).asFunction<GlTexStorage3DMultisample>();
  glTextureView = fromAddress<Pointer<NativeFunction<GlTextureViewNative>>>(glGetProcAddress(CString.fromUtf8('glTextureView'))).asFunction<GlTextureView>();
  glBindVertexBuffer = fromAddress<Pointer<NativeFunction<GlBindVertexBufferNative>>>(glGetProcAddress(CString.fromUtf8('glBindVertexBuffer'))).asFunction<GlBindVertexBuffer>();
  glVertexAttribFormat = fromAddress<Pointer<NativeFunction<GlVertexAttribFormatNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribFormat'))).asFunction<GlVertexAttribFormat>();
  glVertexAttribIFormat = fromAddress<Pointer<NativeFunction<GlVertexAttribIFormatNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribIFormat'))).asFunction<GlVertexAttribIFormat>();
  glVertexAttribLFormat = fromAddress<Pointer<NativeFunction<GlVertexAttribLFormatNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribLFormat'))).asFunction<GlVertexAttribLFormat>();
  glVertexAttribBinding = fromAddress<Pointer<NativeFunction<GlVertexAttribBindingNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribBinding'))).asFunction<GlVertexAttribBinding>();
  glVertexBindingDivisor = fromAddress<Pointer<NativeFunction<GlVertexBindingDivisorNative>>>(glGetProcAddress(CString.fromUtf8('glVertexBindingDivisor'))).asFunction<GlVertexBindingDivisor>();
  glDebugMessageControl = fromAddress<Pointer<NativeFunction<GlDebugMessageControlNative>>>(glGetProcAddress(CString.fromUtf8('glDebugMessageControl'))).asFunction<GlDebugMessageControl>();
  glDebugMessageInsert = fromAddress<Pointer<NativeFunction<GlDebugMessageInsertNative>>>(glGetProcAddress(CString.fromUtf8('glDebugMessageInsert'))).asFunction<GlDebugMessageInsert>();
  glDebugMessageCallback = fromAddress<Pointer<NativeFunction<GlDebugMessageCallbackNative>>>(glGetProcAddress(CString.fromUtf8('glDebugMessageCallback'))).asFunction<GlDebugMessageCallback>();
  glGetDebugMessageLog = fromAddress<Pointer<NativeFunction<GlGetDebugMessageLogNative>>>(glGetProcAddress(CString.fromUtf8('glGetDebugMessageLog'))).asFunction<GlGetDebugMessageLog>();
  glPushDebugGroup = fromAddress<Pointer<NativeFunction<GlPushDebugGroupNative>>>(glGetProcAddress(CString.fromUtf8('glPushDebugGroup'))).asFunction<GlPushDebugGroup>();
  glPopDebugGroup = fromAddress<Pointer<NativeFunction<GlPopDebugGroupNative>>>(glGetProcAddress(CString.fromUtf8('glPopDebugGroup'))).asFunction<GlPopDebugGroup>();
  glObjectLabel = fromAddress<Pointer<NativeFunction<GlObjectLabelNative>>>(glGetProcAddress(CString.fromUtf8('glObjectLabel'))).asFunction<GlObjectLabel>();
  glGetObjectLabel = fromAddress<Pointer<NativeFunction<GlGetObjectLabelNative>>>(glGetProcAddress(CString.fromUtf8('glGetObjectLabel'))).asFunction<GlGetObjectLabel>();
  glObjectPtrLabel = fromAddress<Pointer<NativeFunction<GlObjectPtrLabelNative>>>(glGetProcAddress(CString.fromUtf8('glObjectPtrLabel'))).asFunction<GlObjectPtrLabel>();
  glGetObjectPtrLabel = fromAddress<Pointer<NativeFunction<GlGetObjectPtrLabelNative>>>(glGetProcAddress(CString.fromUtf8('glGetObjectPtrLabel'))).asFunction<GlGetObjectPtrLabel>();
  glBufferStorage = fromAddress<Pointer<NativeFunction<GlBufferStorageNative>>>(glGetProcAddress(CString.fromUtf8('glBufferStorage'))).asFunction<GlBufferStorage>();
  glClearTexImage = fromAddress<Pointer<NativeFunction<GlClearTexImageNative>>>(glGetProcAddress(CString.fromUtf8('glClearTexImage'))).asFunction<GlClearTexImage>();
  glClearTexSubImage = fromAddress<Pointer<NativeFunction<GlClearTexSubImageNative>>>(glGetProcAddress(CString.fromUtf8('glClearTexSubImage'))).asFunction<GlClearTexSubImage>();
  glBindBuffersBase = fromAddress<Pointer<NativeFunction<GlBindBuffersBaseNative>>>(glGetProcAddress(CString.fromUtf8('glBindBuffersBase'))).asFunction<GlBindBuffersBase>();
  glBindBuffersRange = fromAddress<Pointer<NativeFunction<GlBindBuffersRangeNative>>>(glGetProcAddress(CString.fromUtf8('glBindBuffersRange'))).asFunction<GlBindBuffersRange>();
  glBindTextures = fromAddress<Pointer<NativeFunction<GlBindTexturesNative>>>(glGetProcAddress(CString.fromUtf8('glBindTextures'))).asFunction<GlBindTextures>();
  glBindSamplers = fromAddress<Pointer<NativeFunction<GlBindSamplersNative>>>(glGetProcAddress(CString.fromUtf8('glBindSamplers'))).asFunction<GlBindSamplers>();
  glBindImageTextures = fromAddress<Pointer<NativeFunction<GlBindImageTexturesNative>>>(glGetProcAddress(CString.fromUtf8('glBindImageTextures'))).asFunction<GlBindImageTextures>();
  glBindVertexBuffers = fromAddress<Pointer<NativeFunction<GlBindVertexBuffersNative>>>(glGetProcAddress(CString.fromUtf8('glBindVertexBuffers'))).asFunction<GlBindVertexBuffers>();
  glClipControl = fromAddress<Pointer<NativeFunction<GlClipControlNative>>>(glGetProcAddress(CString.fromUtf8('glClipControl'))).asFunction<GlClipControl>();
  glCreateTransformFeedbacks = fromAddress<Pointer<NativeFunction<GlCreateTransformFeedbacksNative>>>(glGetProcAddress(CString.fromUtf8('glCreateTransformFeedbacks'))).asFunction<GlCreateTransformFeedbacks>();
  glTransformFeedbackBufferBase = fromAddress<Pointer<NativeFunction<GlTransformFeedbackBufferBaseNative>>>(glGetProcAddress(CString.fromUtf8('glTransformFeedbackBufferBase'))).asFunction<GlTransformFeedbackBufferBase>();
  glTransformFeedbackBufferRange = fromAddress<Pointer<NativeFunction<GlTransformFeedbackBufferRangeNative>>>(glGetProcAddress(CString.fromUtf8('glTransformFeedbackBufferRange'))).asFunction<GlTransformFeedbackBufferRange>();
  glGetTransformFeedbackiv = fromAddress<Pointer<NativeFunction<GlGetTransformFeedbackivNative>>>(glGetProcAddress(CString.fromUtf8('glGetTransformFeedbackiv'))).asFunction<GlGetTransformFeedbackiv>();
  glGetTransformFeedbacki_v = fromAddress<Pointer<NativeFunction<GlGetTransformFeedbacki_vNative>>>(glGetProcAddress(CString.fromUtf8('glGetTransformFeedbacki_v'))).asFunction<GlGetTransformFeedbacki_v>();
  glGetTransformFeedbacki64_v = fromAddress<Pointer<NativeFunction<GlGetTransformFeedbacki64_vNative>>>(glGetProcAddress(CString.fromUtf8('glGetTransformFeedbacki64_v'))).asFunction<GlGetTransformFeedbacki64_v>();
  glCreateBuffers = fromAddress<Pointer<NativeFunction<GlCreateBuffersNative>>>(glGetProcAddress(CString.fromUtf8('glCreateBuffers'))).asFunction<GlCreateBuffers>();
  glNamedBufferStorage = fromAddress<Pointer<NativeFunction<GlNamedBufferStorageNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferStorage'))).asFunction<GlNamedBufferStorage>();
  glNamedBufferData = fromAddress<Pointer<NativeFunction<GlNamedBufferDataNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferData'))).asFunction<GlNamedBufferData>();
  glNamedBufferSubData = fromAddress<Pointer<NativeFunction<GlNamedBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferSubData'))).asFunction<GlNamedBufferSubData>();
  glCopyNamedBufferSubData = fromAddress<Pointer<NativeFunction<GlCopyNamedBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glCopyNamedBufferSubData'))).asFunction<GlCopyNamedBufferSubData>();
  glClearNamedBufferData = fromAddress<Pointer<NativeFunction<GlClearNamedBufferDataNative>>>(glGetProcAddress(CString.fromUtf8('glClearNamedBufferData'))).asFunction<GlClearNamedBufferData>();
  glClearNamedBufferSubData = fromAddress<Pointer<NativeFunction<GlClearNamedBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glClearNamedBufferSubData'))).asFunction<GlClearNamedBufferSubData>();
  glMapNamedBuffer = fromAddress<Pointer<NativeFunction<GlMapNamedBufferNative>>>(glGetProcAddress(CString.fromUtf8('glMapNamedBuffer'))).asFunction<GlMapNamedBuffer>();
  glMapNamedBufferRange = fromAddress<Pointer<NativeFunction<GlMapNamedBufferRangeNative>>>(glGetProcAddress(CString.fromUtf8('glMapNamedBufferRange'))).asFunction<GlMapNamedBufferRange>();
  glUnmapNamedBuffer = fromAddress<Pointer<NativeFunction<GlUnmapNamedBufferNative>>>(glGetProcAddress(CString.fromUtf8('glUnmapNamedBuffer'))).asFunction<GlUnmapNamedBuffer>();
  glFlushMappedNamedBufferRange = fromAddress<Pointer<NativeFunction<GlFlushMappedNamedBufferRangeNative>>>(glGetProcAddress(CString.fromUtf8('glFlushMappedNamedBufferRange'))).asFunction<GlFlushMappedNamedBufferRange>();
  glGetNamedBufferParameteriv = fromAddress<Pointer<NativeFunction<GlGetNamedBufferParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedBufferParameteriv'))).asFunction<GlGetNamedBufferParameteriv>();
  glGetNamedBufferParameteri64v = fromAddress<Pointer<NativeFunction<GlGetNamedBufferParameteri64vNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedBufferParameteri64v'))).asFunction<GlGetNamedBufferParameteri64v>();
  glGetNamedBufferPointerv = fromAddress<Pointer<NativeFunction<GlGetNamedBufferPointervNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedBufferPointerv'))).asFunction<GlGetNamedBufferPointerv>();
  glGetNamedBufferSubData = fromAddress<Pointer<NativeFunction<GlGetNamedBufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedBufferSubData'))).asFunction<GlGetNamedBufferSubData>();
  glCreateFramebuffers = fromAddress<Pointer<NativeFunction<GlCreateFramebuffersNative>>>(glGetProcAddress(CString.fromUtf8('glCreateFramebuffers'))).asFunction<GlCreateFramebuffers>();
  glNamedFramebufferRenderbuffer = fromAddress<Pointer<NativeFunction<GlNamedFramebufferRenderbufferNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferRenderbuffer'))).asFunction<GlNamedFramebufferRenderbuffer>();
  glNamedFramebufferParameteri = fromAddress<Pointer<NativeFunction<GlNamedFramebufferParameteriNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferParameteri'))).asFunction<GlNamedFramebufferParameteri>();
  glNamedFramebufferTexture = fromAddress<Pointer<NativeFunction<GlNamedFramebufferTextureNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferTexture'))).asFunction<GlNamedFramebufferTexture>();
  glNamedFramebufferTextureLayer = fromAddress<Pointer<NativeFunction<GlNamedFramebufferTextureLayerNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferTextureLayer'))).asFunction<GlNamedFramebufferTextureLayer>();
  glNamedFramebufferDrawBuffer = fromAddress<Pointer<NativeFunction<GlNamedFramebufferDrawBufferNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferDrawBuffer'))).asFunction<GlNamedFramebufferDrawBuffer>();
  glNamedFramebufferDrawBuffers = fromAddress<Pointer<NativeFunction<GlNamedFramebufferDrawBuffersNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferDrawBuffers'))).asFunction<GlNamedFramebufferDrawBuffers>();
  glNamedFramebufferReadBuffer = fromAddress<Pointer<NativeFunction<GlNamedFramebufferReadBufferNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferReadBuffer'))).asFunction<GlNamedFramebufferReadBuffer>();
  glInvalidateNamedFramebufferData = fromAddress<Pointer<NativeFunction<GlInvalidateNamedFramebufferDataNative>>>(glGetProcAddress(CString.fromUtf8('glInvalidateNamedFramebufferData'))).asFunction<GlInvalidateNamedFramebufferData>();
  glInvalidateNamedFramebufferSubData = fromAddress<Pointer<NativeFunction<GlInvalidateNamedFramebufferSubDataNative>>>(glGetProcAddress(CString.fromUtf8('glInvalidateNamedFramebufferSubData'))).asFunction<GlInvalidateNamedFramebufferSubData>();
  glClearNamedFramebufferiv = fromAddress<Pointer<NativeFunction<GlClearNamedFramebufferivNative>>>(glGetProcAddress(CString.fromUtf8('glClearNamedFramebufferiv'))).asFunction<GlClearNamedFramebufferiv>();
  glClearNamedFramebufferuiv = fromAddress<Pointer<NativeFunction<GlClearNamedFramebufferuivNative>>>(glGetProcAddress(CString.fromUtf8('glClearNamedFramebufferuiv'))).asFunction<GlClearNamedFramebufferuiv>();
  glClearNamedFramebufferfv = fromAddress<Pointer<NativeFunction<GlClearNamedFramebufferfvNative>>>(glGetProcAddress(CString.fromUtf8('glClearNamedFramebufferfv'))).asFunction<GlClearNamedFramebufferfv>();
  glClearNamedFramebufferfi = fromAddress<Pointer<NativeFunction<GlClearNamedFramebufferfiNative>>>(glGetProcAddress(CString.fromUtf8('glClearNamedFramebufferfi'))).asFunction<GlClearNamedFramebufferfi>();
  glBlitNamedFramebuffer = fromAddress<Pointer<NativeFunction<GlBlitNamedFramebufferNative>>>(glGetProcAddress(CString.fromUtf8('glBlitNamedFramebuffer'))).asFunction<GlBlitNamedFramebuffer>();
  glCheckNamedFramebufferStatus = fromAddress<Pointer<NativeFunction<GlCheckNamedFramebufferStatusNative>>>(glGetProcAddress(CString.fromUtf8('glCheckNamedFramebufferStatus'))).asFunction<GlCheckNamedFramebufferStatus>();
  glGetNamedFramebufferParameteriv = fromAddress<Pointer<NativeFunction<GlGetNamedFramebufferParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedFramebufferParameteriv'))).asFunction<GlGetNamedFramebufferParameteriv>();
  glGetNamedFramebufferAttachmentParameteriv = fromAddress<Pointer<NativeFunction<GlGetNamedFramebufferAttachmentParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedFramebufferAttachmentParameteriv'))).asFunction<GlGetNamedFramebufferAttachmentParameteriv>();
  glCreateRenderbuffers = fromAddress<Pointer<NativeFunction<GlCreateRenderbuffersNative>>>(glGetProcAddress(CString.fromUtf8('glCreateRenderbuffers'))).asFunction<GlCreateRenderbuffers>();
  glNamedRenderbufferStorage = fromAddress<Pointer<NativeFunction<GlNamedRenderbufferStorageNative>>>(glGetProcAddress(CString.fromUtf8('glNamedRenderbufferStorage'))).asFunction<GlNamedRenderbufferStorage>();
  glNamedRenderbufferStorageMultisample = fromAddress<Pointer<NativeFunction<GlNamedRenderbufferStorageMultisampleNative>>>(glGetProcAddress(CString.fromUtf8('glNamedRenderbufferStorageMultisample'))).asFunction<GlNamedRenderbufferStorageMultisample>();
  glGetNamedRenderbufferParameteriv = fromAddress<Pointer<NativeFunction<GlGetNamedRenderbufferParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedRenderbufferParameteriv'))).asFunction<GlGetNamedRenderbufferParameteriv>();
  glCreateTextures = fromAddress<Pointer<NativeFunction<GlCreateTexturesNative>>>(glGetProcAddress(CString.fromUtf8('glCreateTextures'))).asFunction<GlCreateTextures>();
  glTextureBuffer = fromAddress<Pointer<NativeFunction<GlTextureBufferNative>>>(glGetProcAddress(CString.fromUtf8('glTextureBuffer'))).asFunction<GlTextureBuffer>();
  glTextureBufferRange = fromAddress<Pointer<NativeFunction<GlTextureBufferRangeNative>>>(glGetProcAddress(CString.fromUtf8('glTextureBufferRange'))).asFunction<GlTextureBufferRange>();
  glTextureStorage1D = fromAddress<Pointer<NativeFunction<GlTextureStorage1DNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage1D'))).asFunction<GlTextureStorage1D>();
  glTextureStorage2D = fromAddress<Pointer<NativeFunction<GlTextureStorage2DNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage2D'))).asFunction<GlTextureStorage2D>();
  glTextureStorage3D = fromAddress<Pointer<NativeFunction<GlTextureStorage3DNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage3D'))).asFunction<GlTextureStorage3D>();
  glTextureStorage2DMultisample = fromAddress<Pointer<NativeFunction<GlTextureStorage2DMultisampleNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage2DMultisample'))).asFunction<GlTextureStorage2DMultisample>();
  glTextureStorage3DMultisample = fromAddress<Pointer<NativeFunction<GlTextureStorage3DMultisampleNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage3DMultisample'))).asFunction<GlTextureStorage3DMultisample>();
  glTextureSubImage1D = fromAddress<Pointer<NativeFunction<GlTextureSubImage1DNative>>>(glGetProcAddress(CString.fromUtf8('glTextureSubImage1D'))).asFunction<GlTextureSubImage1D>();
  glTextureSubImage2D = fromAddress<Pointer<NativeFunction<GlTextureSubImage2DNative>>>(glGetProcAddress(CString.fromUtf8('glTextureSubImage2D'))).asFunction<GlTextureSubImage2D>();
  glTextureSubImage3D = fromAddress<Pointer<NativeFunction<GlTextureSubImage3DNative>>>(glGetProcAddress(CString.fromUtf8('glTextureSubImage3D'))).asFunction<GlTextureSubImage3D>();
  glCompressedTextureSubImage1D = fromAddress<Pointer<NativeFunction<GlCompressedTextureSubImage1DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureSubImage1D'))).asFunction<GlCompressedTextureSubImage1D>();
  glCompressedTextureSubImage2D = fromAddress<Pointer<NativeFunction<GlCompressedTextureSubImage2DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureSubImage2D'))).asFunction<GlCompressedTextureSubImage2D>();
  glCompressedTextureSubImage3D = fromAddress<Pointer<NativeFunction<GlCompressedTextureSubImage3DNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureSubImage3D'))).asFunction<GlCompressedTextureSubImage3D>();
  glCopyTextureSubImage1D = fromAddress<Pointer<NativeFunction<GlCopyTextureSubImage1DNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTextureSubImage1D'))).asFunction<GlCopyTextureSubImage1D>();
  glCopyTextureSubImage2D = fromAddress<Pointer<NativeFunction<GlCopyTextureSubImage2DNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTextureSubImage2D'))).asFunction<GlCopyTextureSubImage2D>();
  glCopyTextureSubImage3D = fromAddress<Pointer<NativeFunction<GlCopyTextureSubImage3DNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTextureSubImage3D'))).asFunction<GlCopyTextureSubImage3D>();
  glTextureParameterf = fromAddress<Pointer<NativeFunction<GlTextureParameterfNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterf'))).asFunction<GlTextureParameterf>();
  glTextureParameterfv = fromAddress<Pointer<NativeFunction<GlTextureParameterfvNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterfv'))).asFunction<GlTextureParameterfv>();
  glTextureParameteri = fromAddress<Pointer<NativeFunction<GlTextureParameteriNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameteri'))).asFunction<GlTextureParameteri>();
  glTextureParameterIiv = fromAddress<Pointer<NativeFunction<GlTextureParameterIivNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterIiv'))).asFunction<GlTextureParameterIiv>();
  glTextureParameterIuiv = fromAddress<Pointer<NativeFunction<GlTextureParameterIuivNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterIuiv'))).asFunction<GlTextureParameterIuiv>();
  glTextureParameteriv = fromAddress<Pointer<NativeFunction<GlTextureParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameteriv'))).asFunction<GlTextureParameteriv>();
  glGenerateTextureMipmap = fromAddress<Pointer<NativeFunction<GlGenerateTextureMipmapNative>>>(glGetProcAddress(CString.fromUtf8('glGenerateTextureMipmap'))).asFunction<GlGenerateTextureMipmap>();
  glBindTextureUnit = fromAddress<Pointer<NativeFunction<GlBindTextureUnitNative>>>(glGetProcAddress(CString.fromUtf8('glBindTextureUnit'))).asFunction<GlBindTextureUnit>();
  glGetTextureImage = fromAddress<Pointer<NativeFunction<GlGetTextureImageNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureImage'))).asFunction<GlGetTextureImage>();
  glGetCompressedTextureImage = fromAddress<Pointer<NativeFunction<GlGetCompressedTextureImageNative>>>(glGetProcAddress(CString.fromUtf8('glGetCompressedTextureImage'))).asFunction<GlGetCompressedTextureImage>();
  glGetTextureLevelParameterfv = fromAddress<Pointer<NativeFunction<GlGetTextureLevelParameterfvNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureLevelParameterfv'))).asFunction<GlGetTextureLevelParameterfv>();
  glGetTextureLevelParameteriv = fromAddress<Pointer<NativeFunction<GlGetTextureLevelParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureLevelParameteriv'))).asFunction<GlGetTextureLevelParameteriv>();
  glGetTextureParameterfv = fromAddress<Pointer<NativeFunction<GlGetTextureParameterfvNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureParameterfv'))).asFunction<GlGetTextureParameterfv>();
  glGetTextureParameterIiv = fromAddress<Pointer<NativeFunction<GlGetTextureParameterIivNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureParameterIiv'))).asFunction<GlGetTextureParameterIiv>();
  glGetTextureParameterIuiv = fromAddress<Pointer<NativeFunction<GlGetTextureParameterIuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureParameterIuiv'))).asFunction<GlGetTextureParameterIuiv>();
  glGetTextureParameteriv = fromAddress<Pointer<NativeFunction<GlGetTextureParameterivNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureParameteriv'))).asFunction<GlGetTextureParameteriv>();
  glCreateVertexArrays = fromAddress<Pointer<NativeFunction<GlCreateVertexArraysNative>>>(glGetProcAddress(CString.fromUtf8('glCreateVertexArrays'))).asFunction<GlCreateVertexArrays>();
  glDisableVertexArrayAttrib = fromAddress<Pointer<NativeFunction<GlDisableVertexArrayAttribNative>>>(glGetProcAddress(CString.fromUtf8('glDisableVertexArrayAttrib'))).asFunction<GlDisableVertexArrayAttrib>();
  glEnableVertexArrayAttrib = fromAddress<Pointer<NativeFunction<GlEnableVertexArrayAttribNative>>>(glGetProcAddress(CString.fromUtf8('glEnableVertexArrayAttrib'))).asFunction<GlEnableVertexArrayAttrib>();
  glVertexArrayElementBuffer = fromAddress<Pointer<NativeFunction<GlVertexArrayElementBufferNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayElementBuffer'))).asFunction<GlVertexArrayElementBuffer>();
  glVertexArrayVertexBuffer = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexBufferNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexBuffer'))).asFunction<GlVertexArrayVertexBuffer>();
  glVertexArrayVertexBuffers = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexBuffersNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexBuffers'))).asFunction<GlVertexArrayVertexBuffers>();
  glVertexArrayAttribBinding = fromAddress<Pointer<NativeFunction<GlVertexArrayAttribBindingNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayAttribBinding'))).asFunction<GlVertexArrayAttribBinding>();
  glVertexArrayAttribFormat = fromAddress<Pointer<NativeFunction<GlVertexArrayAttribFormatNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayAttribFormat'))).asFunction<GlVertexArrayAttribFormat>();
  glVertexArrayAttribIFormat = fromAddress<Pointer<NativeFunction<GlVertexArrayAttribIFormatNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayAttribIFormat'))).asFunction<GlVertexArrayAttribIFormat>();
  glVertexArrayAttribLFormat = fromAddress<Pointer<NativeFunction<GlVertexArrayAttribLFormatNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayAttribLFormat'))).asFunction<GlVertexArrayAttribLFormat>();
  glVertexArrayBindingDivisor = fromAddress<Pointer<NativeFunction<GlVertexArrayBindingDivisorNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayBindingDivisor'))).asFunction<GlVertexArrayBindingDivisor>();
  glGetVertexArrayiv = fromAddress<Pointer<NativeFunction<GlGetVertexArrayivNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexArrayiv'))).asFunction<GlGetVertexArrayiv>();
  glGetVertexArrayIndexediv = fromAddress<Pointer<NativeFunction<GlGetVertexArrayIndexedivNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexArrayIndexediv'))).asFunction<GlGetVertexArrayIndexediv>();
  glGetVertexArrayIndexed64iv = fromAddress<Pointer<NativeFunction<GlGetVertexArrayIndexed64ivNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexArrayIndexed64iv'))).asFunction<GlGetVertexArrayIndexed64iv>();
  glCreateSamplers = fromAddress<Pointer<NativeFunction<GlCreateSamplersNative>>>(glGetProcAddress(CString.fromUtf8('glCreateSamplers'))).asFunction<GlCreateSamplers>();
  glCreateProgramPipelines = fromAddress<Pointer<NativeFunction<GlCreateProgramPipelinesNative>>>(glGetProcAddress(CString.fromUtf8('glCreateProgramPipelines'))).asFunction<GlCreateProgramPipelines>();
  glCreateQueries = fromAddress<Pointer<NativeFunction<GlCreateQueriesNative>>>(glGetProcAddress(CString.fromUtf8('glCreateQueries'))).asFunction<GlCreateQueries>();
  glGetQueryBufferObjecti64v = fromAddress<Pointer<NativeFunction<GlGetQueryBufferObjecti64vNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryBufferObjecti64v'))).asFunction<GlGetQueryBufferObjecti64v>();
  glGetQueryBufferObjectiv = fromAddress<Pointer<NativeFunction<GlGetQueryBufferObjectivNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryBufferObjectiv'))).asFunction<GlGetQueryBufferObjectiv>();
  glGetQueryBufferObjectui64v = fromAddress<Pointer<NativeFunction<GlGetQueryBufferObjectui64vNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryBufferObjectui64v'))).asFunction<GlGetQueryBufferObjectui64v>();
  glGetQueryBufferObjectuiv = fromAddress<Pointer<NativeFunction<GlGetQueryBufferObjectuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetQueryBufferObjectuiv'))).asFunction<GlGetQueryBufferObjectuiv>();
  glMemoryBarrierByRegion = fromAddress<Pointer<NativeFunction<GlMemoryBarrierByRegionNative>>>(glGetProcAddress(CString.fromUtf8('glMemoryBarrierByRegion'))).asFunction<GlMemoryBarrierByRegion>();
  glGetTextureSubImage = fromAddress<Pointer<NativeFunction<GlGetTextureSubImageNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureSubImage'))).asFunction<GlGetTextureSubImage>();
  glGetCompressedTextureSubImage = fromAddress<Pointer<NativeFunction<GlGetCompressedTextureSubImageNative>>>(glGetProcAddress(CString.fromUtf8('glGetCompressedTextureSubImage'))).asFunction<GlGetCompressedTextureSubImage>();
  glGetGraphicsResetStatus = fromAddress<Pointer<NativeFunction<GlGetGraphicsResetStatusNative>>>(glGetProcAddress(CString.fromUtf8('glGetGraphicsResetStatus'))).asFunction<GlGetGraphicsResetStatus>();
  glGetnCompressedTexImage = fromAddress<Pointer<NativeFunction<GlGetnCompressedTexImageNative>>>(glGetProcAddress(CString.fromUtf8('glGetnCompressedTexImage'))).asFunction<GlGetnCompressedTexImage>();
  glGetnTexImage = fromAddress<Pointer<NativeFunction<GlGetnTexImageNative>>>(glGetProcAddress(CString.fromUtf8('glGetnTexImage'))).asFunction<GlGetnTexImage>();
  glGetnUniformdv = fromAddress<Pointer<NativeFunction<GlGetnUniformdvNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformdv'))).asFunction<GlGetnUniformdv>();
  glGetnUniformfv = fromAddress<Pointer<NativeFunction<GlGetnUniformfvNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformfv'))).asFunction<GlGetnUniformfv>();
  glGetnUniformiv = fromAddress<Pointer<NativeFunction<GlGetnUniformivNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformiv'))).asFunction<GlGetnUniformiv>();
  glGetnUniformuiv = fromAddress<Pointer<NativeFunction<GlGetnUniformuivNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformuiv'))).asFunction<GlGetnUniformuiv>();
  glReadnPixels = fromAddress<Pointer<NativeFunction<GlReadnPixelsNative>>>(glGetProcAddress(CString.fromUtf8('glReadnPixels'))).asFunction<GlReadnPixels>();
  glTextureBarrier = fromAddress<Pointer<NativeFunction<GlTextureBarrierNative>>>(glGetProcAddress(CString.fromUtf8('glTextureBarrier'))).asFunction<GlTextureBarrier>();
  glSpecializeShader = fromAddress<Pointer<NativeFunction<GlSpecializeShaderNative>>>(glGetProcAddress(CString.fromUtf8('glSpecializeShader'))).asFunction<GlSpecializeShader>();
  glMultiDrawArraysIndirectCount = fromAddress<Pointer<NativeFunction<GlMultiDrawArraysIndirectCountNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawArraysIndirectCount'))).asFunction<GlMultiDrawArraysIndirectCount>();
  glMultiDrawElementsIndirectCount = fromAddress<Pointer<NativeFunction<GlMultiDrawElementsIndirectCountNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawElementsIndirectCount'))).asFunction<GlMultiDrawElementsIndirectCount>();
  glPolygonOffsetClamp = fromAddress<Pointer<NativeFunction<GlPolygonOffsetClampNative>>>(glGetProcAddress(CString.fromUtf8('glPolygonOffsetClamp'))).asFunction<GlPolygonOffsetClamp>();
  glPrimitiveBoundingBoxARB = fromAddress<Pointer<NativeFunction<GlPrimitiveBoundingBoxARBNative>>>(glGetProcAddress(CString.fromUtf8('glPrimitiveBoundingBoxARB'))).asFunction<GlPrimitiveBoundingBoxARB>();
  glGetTextureHandleARB = fromAddress<Pointer<NativeFunction<GlGetTextureHandleARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureHandleARB'))).asFunction<GlGetTextureHandleARB>();
  glGetTextureSamplerHandleARB = fromAddress<Pointer<NativeFunction<GlGetTextureSamplerHandleARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureSamplerHandleARB'))).asFunction<GlGetTextureSamplerHandleARB>();
  glMakeTextureHandleResidentARB = fromAddress<Pointer<NativeFunction<GlMakeTextureHandleResidentARBNative>>>(glGetProcAddress(CString.fromUtf8('glMakeTextureHandleResidentARB'))).asFunction<GlMakeTextureHandleResidentARB>();
  glMakeTextureHandleNonResidentARB = fromAddress<Pointer<NativeFunction<GlMakeTextureHandleNonResidentARBNative>>>(glGetProcAddress(CString.fromUtf8('glMakeTextureHandleNonResidentARB'))).asFunction<GlMakeTextureHandleNonResidentARB>();
  glGetImageHandleARB = fromAddress<Pointer<NativeFunction<GlGetImageHandleARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetImageHandleARB'))).asFunction<GlGetImageHandleARB>();
  glMakeImageHandleResidentARB = fromAddress<Pointer<NativeFunction<GlMakeImageHandleResidentARBNative>>>(glGetProcAddress(CString.fromUtf8('glMakeImageHandleResidentARB'))).asFunction<GlMakeImageHandleResidentARB>();
  glMakeImageHandleNonResidentARB = fromAddress<Pointer<NativeFunction<GlMakeImageHandleNonResidentARBNative>>>(glGetProcAddress(CString.fromUtf8('glMakeImageHandleNonResidentARB'))).asFunction<GlMakeImageHandleNonResidentARB>();
  glUniformHandleui64ARB = fromAddress<Pointer<NativeFunction<GlUniformHandleui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniformHandleui64ARB'))).asFunction<GlUniformHandleui64ARB>();
  glUniformHandleui64vARB = fromAddress<Pointer<NativeFunction<GlUniformHandleui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniformHandleui64vARB'))).asFunction<GlUniformHandleui64vARB>();
  glProgramUniformHandleui64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniformHandleui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformHandleui64ARB'))).asFunction<GlProgramUniformHandleui64ARB>();
  glProgramUniformHandleui64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniformHandleui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformHandleui64vARB'))).asFunction<GlProgramUniformHandleui64vARB>();
  glIsTextureHandleResidentARB = fromAddress<Pointer<NativeFunction<GlIsTextureHandleResidentARBNative>>>(glGetProcAddress(CString.fromUtf8('glIsTextureHandleResidentARB'))).asFunction<GlIsTextureHandleResidentARB>();
  glIsImageHandleResidentARB = fromAddress<Pointer<NativeFunction<GlIsImageHandleResidentARBNative>>>(glGetProcAddress(CString.fromUtf8('glIsImageHandleResidentARB'))).asFunction<GlIsImageHandleResidentARB>();
  glVertexAttribL1ui64ARB = fromAddress<Pointer<NativeFunction<GlVertexAttribL1ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL1ui64ARB'))).asFunction<GlVertexAttribL1ui64ARB>();
  glVertexAttribL1ui64vARB = fromAddress<Pointer<NativeFunction<GlVertexAttribL1ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL1ui64vARB'))).asFunction<GlVertexAttribL1ui64vARB>();
  glGetVertexAttribLui64vARB = fromAddress<Pointer<NativeFunction<GlGetVertexAttribLui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribLui64vARB'))).asFunction<GlGetVertexAttribLui64vARB>();
  glCreateSyncFromCLeventARB = fromAddress<Pointer<NativeFunction<GlCreateSyncFromCLeventARBNative>>>(glGetProcAddress(CString.fromUtf8('glCreateSyncFromCLeventARB'))).asFunction<GlCreateSyncFromCLeventARB>();
  glDispatchComputeGroupSizeARB = fromAddress<Pointer<NativeFunction<GlDispatchComputeGroupSizeARBNative>>>(glGetProcAddress(CString.fromUtf8('glDispatchComputeGroupSizeARB'))).asFunction<GlDispatchComputeGroupSizeARB>();
  glDebugMessageControlARB = fromAddress<Pointer<NativeFunction<GlDebugMessageControlARBNative>>>(glGetProcAddress(CString.fromUtf8('glDebugMessageControlARB'))).asFunction<GlDebugMessageControlARB>();
  glDebugMessageInsertARB = fromAddress<Pointer<NativeFunction<GlDebugMessageInsertARBNative>>>(glGetProcAddress(CString.fromUtf8('glDebugMessageInsertARB'))).asFunction<GlDebugMessageInsertARB>();
  glDebugMessageCallbackARB = fromAddress<Pointer<NativeFunction<GlDebugMessageCallbackARBNative>>>(glGetProcAddress(CString.fromUtf8('glDebugMessageCallbackARB'))).asFunction<GlDebugMessageCallbackARB>();
  glGetDebugMessageLogARB = fromAddress<Pointer<NativeFunction<GlGetDebugMessageLogARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetDebugMessageLogARB'))).asFunction<GlGetDebugMessageLogARB>();
  glBlendEquationiARB = fromAddress<Pointer<NativeFunction<GlBlendEquationiARBNative>>>(glGetProcAddress(CString.fromUtf8('glBlendEquationiARB'))).asFunction<GlBlendEquationiARB>();
  glBlendEquationSeparateiARB = fromAddress<Pointer<NativeFunction<GlBlendEquationSeparateiARBNative>>>(glGetProcAddress(CString.fromUtf8('glBlendEquationSeparateiARB'))).asFunction<GlBlendEquationSeparateiARB>();
  glBlendFunciARB = fromAddress<Pointer<NativeFunction<GlBlendFunciARBNative>>>(glGetProcAddress(CString.fromUtf8('glBlendFunciARB'))).asFunction<GlBlendFunciARB>();
  glBlendFuncSeparateiARB = fromAddress<Pointer<NativeFunction<GlBlendFuncSeparateiARBNative>>>(glGetProcAddress(CString.fromUtf8('glBlendFuncSeparateiARB'))).asFunction<GlBlendFuncSeparateiARB>();
  glDrawArraysInstancedARB = fromAddress<Pointer<NativeFunction<GlDrawArraysInstancedARBNative>>>(glGetProcAddress(CString.fromUtf8('glDrawArraysInstancedARB'))).asFunction<GlDrawArraysInstancedARB>();
  glDrawElementsInstancedARB = fromAddress<Pointer<NativeFunction<GlDrawElementsInstancedARBNative>>>(glGetProcAddress(CString.fromUtf8('glDrawElementsInstancedARB'))).asFunction<GlDrawElementsInstancedARB>();
  glProgramParameteriARB = fromAddress<Pointer<NativeFunction<GlProgramParameteriARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramParameteriARB'))).asFunction<GlProgramParameteriARB>();
  glFramebufferTextureARB = fromAddress<Pointer<NativeFunction<GlFramebufferTextureARBNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTextureARB'))).asFunction<GlFramebufferTextureARB>();
  glFramebufferTextureLayerARB = fromAddress<Pointer<NativeFunction<GlFramebufferTextureLayerARBNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTextureLayerARB'))).asFunction<GlFramebufferTextureLayerARB>();
  glFramebufferTextureFaceARB = fromAddress<Pointer<NativeFunction<GlFramebufferTextureFaceARBNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTextureFaceARB'))).asFunction<GlFramebufferTextureFaceARB>();
  glSpecializeShaderARB = fromAddress<Pointer<NativeFunction<GlSpecializeShaderARBNative>>>(glGetProcAddress(CString.fromUtf8('glSpecializeShaderARB'))).asFunction<GlSpecializeShaderARB>();
  glUniform1i64ARB = fromAddress<Pointer<NativeFunction<GlUniform1i64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1i64ARB'))).asFunction<GlUniform1i64ARB>();
  glUniform2i64ARB = fromAddress<Pointer<NativeFunction<GlUniform2i64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2i64ARB'))).asFunction<GlUniform2i64ARB>();
  glUniform3i64ARB = fromAddress<Pointer<NativeFunction<GlUniform3i64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3i64ARB'))).asFunction<GlUniform3i64ARB>();
  glUniform4i64ARB = fromAddress<Pointer<NativeFunction<GlUniform4i64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4i64ARB'))).asFunction<GlUniform4i64ARB>();
  glUniform1i64vARB = fromAddress<Pointer<NativeFunction<GlUniform1i64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1i64vARB'))).asFunction<GlUniform1i64vARB>();
  glUniform2i64vARB = fromAddress<Pointer<NativeFunction<GlUniform2i64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2i64vARB'))).asFunction<GlUniform2i64vARB>();
  glUniform3i64vARB = fromAddress<Pointer<NativeFunction<GlUniform3i64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3i64vARB'))).asFunction<GlUniform3i64vARB>();
  glUniform4i64vARB = fromAddress<Pointer<NativeFunction<GlUniform4i64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4i64vARB'))).asFunction<GlUniform4i64vARB>();
  glUniform1ui64ARB = fromAddress<Pointer<NativeFunction<GlUniform1ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1ui64ARB'))).asFunction<GlUniform1ui64ARB>();
  glUniform2ui64ARB = fromAddress<Pointer<NativeFunction<GlUniform2ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2ui64ARB'))).asFunction<GlUniform2ui64ARB>();
  glUniform3ui64ARB = fromAddress<Pointer<NativeFunction<GlUniform3ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3ui64ARB'))).asFunction<GlUniform3ui64ARB>();
  glUniform4ui64ARB = fromAddress<Pointer<NativeFunction<GlUniform4ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4ui64ARB'))).asFunction<GlUniform4ui64ARB>();
  glUniform1ui64vARB = fromAddress<Pointer<NativeFunction<GlUniform1ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1ui64vARB'))).asFunction<GlUniform1ui64vARB>();
  glUniform2ui64vARB = fromAddress<Pointer<NativeFunction<GlUniform2ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2ui64vARB'))).asFunction<GlUniform2ui64vARB>();
  glUniform3ui64vARB = fromAddress<Pointer<NativeFunction<GlUniform3ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3ui64vARB'))).asFunction<GlUniform3ui64vARB>();
  glUniform4ui64vARB = fromAddress<Pointer<NativeFunction<GlUniform4ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4ui64vARB'))).asFunction<GlUniform4ui64vARB>();
  glGetUniformi64vARB = fromAddress<Pointer<NativeFunction<GlGetUniformi64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformi64vARB'))).asFunction<GlGetUniformi64vARB>();
  glGetUniformui64vARB = fromAddress<Pointer<NativeFunction<GlGetUniformui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformui64vARB'))).asFunction<GlGetUniformui64vARB>();
  glGetnUniformi64vARB = fromAddress<Pointer<NativeFunction<GlGetnUniformi64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformi64vARB'))).asFunction<GlGetnUniformi64vARB>();
  glGetnUniformui64vARB = fromAddress<Pointer<NativeFunction<GlGetnUniformui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformui64vARB'))).asFunction<GlGetnUniformui64vARB>();
  glProgramUniform1i64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniform1i64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1i64ARB'))).asFunction<GlProgramUniform1i64ARB>();
  glProgramUniform2i64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniform2i64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2i64ARB'))).asFunction<GlProgramUniform2i64ARB>();
  glProgramUniform3i64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniform3i64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3i64ARB'))).asFunction<GlProgramUniform3i64ARB>();
  glProgramUniform4i64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniform4i64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4i64ARB'))).asFunction<GlProgramUniform4i64ARB>();
  glProgramUniform1i64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniform1i64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1i64vARB'))).asFunction<GlProgramUniform1i64vARB>();
  glProgramUniform2i64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniform2i64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2i64vARB'))).asFunction<GlProgramUniform2i64vARB>();
  glProgramUniform3i64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniform3i64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3i64vARB'))).asFunction<GlProgramUniform3i64vARB>();
  glProgramUniform4i64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniform4i64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4i64vARB'))).asFunction<GlProgramUniform4i64vARB>();
  glProgramUniform1ui64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniform1ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1ui64ARB'))).asFunction<GlProgramUniform1ui64ARB>();
  glProgramUniform2ui64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniform2ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2ui64ARB'))).asFunction<GlProgramUniform2ui64ARB>();
  glProgramUniform3ui64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniform3ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3ui64ARB'))).asFunction<GlProgramUniform3ui64ARB>();
  glProgramUniform4ui64ARB = fromAddress<Pointer<NativeFunction<GlProgramUniform4ui64ARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4ui64ARB'))).asFunction<GlProgramUniform4ui64ARB>();
  glProgramUniform1ui64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniform1ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1ui64vARB'))).asFunction<GlProgramUniform1ui64vARB>();
  glProgramUniform2ui64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniform2ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2ui64vARB'))).asFunction<GlProgramUniform2ui64vARB>();
  glProgramUniform3ui64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniform3ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3ui64vARB'))).asFunction<GlProgramUniform3ui64vARB>();
  glProgramUniform4ui64vARB = fromAddress<Pointer<NativeFunction<GlProgramUniform4ui64vARBNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4ui64vARB'))).asFunction<GlProgramUniform4ui64vARB>();
  glMultiDrawArraysIndirectCountARB = fromAddress<Pointer<NativeFunction<GlMultiDrawArraysIndirectCountARBNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawArraysIndirectCountARB'))).asFunction<GlMultiDrawArraysIndirectCountARB>();
  glMultiDrawElementsIndirectCountARB = fromAddress<Pointer<NativeFunction<GlMultiDrawElementsIndirectCountARBNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawElementsIndirectCountARB'))).asFunction<GlMultiDrawElementsIndirectCountARB>();
  glVertexAttribDivisorARB = fromAddress<Pointer<NativeFunction<GlVertexAttribDivisorARBNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribDivisorARB'))).asFunction<GlVertexAttribDivisorARB>();
  glMaxShaderCompilerThreadsARB = fromAddress<Pointer<NativeFunction<GlMaxShaderCompilerThreadsARBNative>>>(glGetProcAddress(CString.fromUtf8('glMaxShaderCompilerThreadsARB'))).asFunction<GlMaxShaderCompilerThreadsARB>();
  glGetGraphicsResetStatusARB = fromAddress<Pointer<NativeFunction<GlGetGraphicsResetStatusARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetGraphicsResetStatusARB'))).asFunction<GlGetGraphicsResetStatusARB>();
  glGetnTexImageARB = fromAddress<Pointer<NativeFunction<GlGetnTexImageARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetnTexImageARB'))).asFunction<GlGetnTexImageARB>();
  glReadnPixelsARB = fromAddress<Pointer<NativeFunction<GlReadnPixelsARBNative>>>(glGetProcAddress(CString.fromUtf8('glReadnPixelsARB'))).asFunction<GlReadnPixelsARB>();
  glGetnCompressedTexImageARB = fromAddress<Pointer<NativeFunction<GlGetnCompressedTexImageARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetnCompressedTexImageARB'))).asFunction<GlGetnCompressedTexImageARB>();
  glGetnUniformfvARB = fromAddress<Pointer<NativeFunction<GlGetnUniformfvARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformfvARB'))).asFunction<GlGetnUniformfvARB>();
  glGetnUniformivARB = fromAddress<Pointer<NativeFunction<GlGetnUniformivARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformivARB'))).asFunction<GlGetnUniformivARB>();
  glGetnUniformuivARB = fromAddress<Pointer<NativeFunction<GlGetnUniformuivARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformuivARB'))).asFunction<GlGetnUniformuivARB>();
  glGetnUniformdvARB = fromAddress<Pointer<NativeFunction<GlGetnUniformdvARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetnUniformdvARB'))).asFunction<GlGetnUniformdvARB>();
  glFramebufferSampleLocationsfvARB = fromAddress<Pointer<NativeFunction<GlFramebufferSampleLocationsfvARBNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferSampleLocationsfvARB'))).asFunction<GlFramebufferSampleLocationsfvARB>();
  glNamedFramebufferSampleLocationsfvARB = fromAddress<Pointer<NativeFunction<GlNamedFramebufferSampleLocationsfvARBNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferSampleLocationsfvARB'))).asFunction<GlNamedFramebufferSampleLocationsfvARB>();
  glEvaluateDepthValuesARB = fromAddress<Pointer<NativeFunction<GlEvaluateDepthValuesARBNative>>>(glGetProcAddress(CString.fromUtf8('glEvaluateDepthValuesARB'))).asFunction<GlEvaluateDepthValuesARB>();
  glMinSampleShadingARB = fromAddress<Pointer<NativeFunction<GlMinSampleShadingARBNative>>>(glGetProcAddress(CString.fromUtf8('glMinSampleShadingARB'))).asFunction<GlMinSampleShadingARB>();
  glNamedStringARB = fromAddress<Pointer<NativeFunction<GlNamedStringARBNative>>>(glGetProcAddress(CString.fromUtf8('glNamedStringARB'))).asFunction<GlNamedStringARB>();
  glDeleteNamedStringARB = fromAddress<Pointer<NativeFunction<GlDeleteNamedStringARBNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteNamedStringARB'))).asFunction<GlDeleteNamedStringARB>();
  glCompileShaderIncludeARB = fromAddress<Pointer<NativeFunction<GlCompileShaderIncludeARBNative>>>(glGetProcAddress(CString.fromUtf8('glCompileShaderIncludeARB'))).asFunction<GlCompileShaderIncludeARB>();
  glIsNamedStringARB = fromAddress<Pointer<NativeFunction<GlIsNamedStringARBNative>>>(glGetProcAddress(CString.fromUtf8('glIsNamedStringARB'))).asFunction<GlIsNamedStringARB>();
  glGetNamedStringARB = fromAddress<Pointer<NativeFunction<GlGetNamedStringARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedStringARB'))).asFunction<GlGetNamedStringARB>();
  glGetNamedStringivARB = fromAddress<Pointer<NativeFunction<GlGetNamedStringivARBNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedStringivARB'))).asFunction<GlGetNamedStringivARB>();
  glBufferPageCommitmentARB = fromAddress<Pointer<NativeFunction<GlBufferPageCommitmentARBNative>>>(glGetProcAddress(CString.fromUtf8('glBufferPageCommitmentARB'))).asFunction<GlBufferPageCommitmentARB>();
  glNamedBufferPageCommitmentEXT = fromAddress<Pointer<NativeFunction<GlNamedBufferPageCommitmentEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferPageCommitmentEXT'))).asFunction<GlNamedBufferPageCommitmentEXT>();
  glNamedBufferPageCommitmentARB = fromAddress<Pointer<NativeFunction<GlNamedBufferPageCommitmentARBNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferPageCommitmentARB'))).asFunction<GlNamedBufferPageCommitmentARB>();
  glTexPageCommitmentARB = fromAddress<Pointer<NativeFunction<GlTexPageCommitmentARBNative>>>(glGetProcAddress(CString.fromUtf8('glTexPageCommitmentARB'))).asFunction<GlTexPageCommitmentARB>();
  glTexBufferARB = fromAddress<Pointer<NativeFunction<GlTexBufferARBNative>>>(glGetProcAddress(CString.fromUtf8('glTexBufferARB'))).asFunction<GlTexBufferARB>();
  glBlendBarrierKHR = fromAddress<Pointer<NativeFunction<GlBlendBarrierKHRNative>>>(glGetProcAddress(CString.fromUtf8('glBlendBarrierKHR'))).asFunction<GlBlendBarrierKHR>();
  glMaxShaderCompilerThreadsKHR = fromAddress<Pointer<NativeFunction<GlMaxShaderCompilerThreadsKHRNative>>>(glGetProcAddress(CString.fromUtf8('glMaxShaderCompilerThreadsKHR'))).asFunction<GlMaxShaderCompilerThreadsKHR>();
  glRenderbufferStorageMultisampleAdvancedAMD = fromAddress<Pointer<NativeFunction<GlRenderbufferStorageMultisampleAdvancedAMDNative>>>(glGetProcAddress(CString.fromUtf8('glRenderbufferStorageMultisampleAdvancedAMD'))).asFunction<GlRenderbufferStorageMultisampleAdvancedAMD>();
  glNamedRenderbufferStorageMultisampleAdvancedAMD = fromAddress<Pointer<NativeFunction<GlNamedRenderbufferStorageMultisampleAdvancedAMDNative>>>(glGetProcAddress(CString.fromUtf8('glNamedRenderbufferStorageMultisampleAdvancedAMD'))).asFunction<GlNamedRenderbufferStorageMultisampleAdvancedAMD>();
  glGetPerfMonitorGroupsAMD = fromAddress<Pointer<NativeFunction<GlGetPerfMonitorGroupsAMDNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfMonitorGroupsAMD'))).asFunction<GlGetPerfMonitorGroupsAMD>();
  glGetPerfMonitorCountersAMD = fromAddress<Pointer<NativeFunction<GlGetPerfMonitorCountersAMDNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfMonitorCountersAMD'))).asFunction<GlGetPerfMonitorCountersAMD>();
  glGetPerfMonitorGroupStringAMD = fromAddress<Pointer<NativeFunction<GlGetPerfMonitorGroupStringAMDNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfMonitorGroupStringAMD'))).asFunction<GlGetPerfMonitorGroupStringAMD>();
  glGetPerfMonitorCounterStringAMD = fromAddress<Pointer<NativeFunction<GlGetPerfMonitorCounterStringAMDNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfMonitorCounterStringAMD'))).asFunction<GlGetPerfMonitorCounterStringAMD>();
  glGetPerfMonitorCounterInfoAMD = fromAddress<Pointer<NativeFunction<GlGetPerfMonitorCounterInfoAMDNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfMonitorCounterInfoAMD'))).asFunction<GlGetPerfMonitorCounterInfoAMD>();
  glGenPerfMonitorsAMD = fromAddress<Pointer<NativeFunction<GlGenPerfMonitorsAMDNative>>>(glGetProcAddress(CString.fromUtf8('glGenPerfMonitorsAMD'))).asFunction<GlGenPerfMonitorsAMD>();
  glDeletePerfMonitorsAMD = fromAddress<Pointer<NativeFunction<GlDeletePerfMonitorsAMDNative>>>(glGetProcAddress(CString.fromUtf8('glDeletePerfMonitorsAMD'))).asFunction<GlDeletePerfMonitorsAMD>();
  glSelectPerfMonitorCountersAMD = fromAddress<Pointer<NativeFunction<GlSelectPerfMonitorCountersAMDNative>>>(glGetProcAddress(CString.fromUtf8('glSelectPerfMonitorCountersAMD'))).asFunction<GlSelectPerfMonitorCountersAMD>();
  glBeginPerfMonitorAMD = fromAddress<Pointer<NativeFunction<GlBeginPerfMonitorAMDNative>>>(glGetProcAddress(CString.fromUtf8('glBeginPerfMonitorAMD'))).asFunction<GlBeginPerfMonitorAMD>();
  glEndPerfMonitorAMD = fromAddress<Pointer<NativeFunction<GlEndPerfMonitorAMDNative>>>(glGetProcAddress(CString.fromUtf8('glEndPerfMonitorAMD'))).asFunction<GlEndPerfMonitorAMD>();
  glGetPerfMonitorCounterDataAMD = fromAddress<Pointer<NativeFunction<GlGetPerfMonitorCounterDataAMDNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfMonitorCounterDataAMD'))).asFunction<GlGetPerfMonitorCounterDataAMD>();
  glEGLImageTargetTexStorageEXT = fromAddress<Pointer<NativeFunction<GlEGLImageTargetTexStorageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glEGLImageTargetTexStorageEXT'))).asFunction<GlEGLImageTargetTexStorageEXT>();
  glEGLImageTargetTextureStorageEXT = fromAddress<Pointer<NativeFunction<GlEGLImageTargetTextureStorageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glEGLImageTargetTextureStorageEXT'))).asFunction<GlEGLImageTargetTextureStorageEXT>();
  glLabelObjectEXT = fromAddress<Pointer<NativeFunction<GlLabelObjectEXTNative>>>(glGetProcAddress(CString.fromUtf8('glLabelObjectEXT'))).asFunction<GlLabelObjectEXT>();
  glGetObjectLabelEXT = fromAddress<Pointer<NativeFunction<GlGetObjectLabelEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetObjectLabelEXT'))).asFunction<GlGetObjectLabelEXT>();
  glInsertEventMarkerEXT = fromAddress<Pointer<NativeFunction<GlInsertEventMarkerEXTNative>>>(glGetProcAddress(CString.fromUtf8('glInsertEventMarkerEXT'))).asFunction<GlInsertEventMarkerEXT>();
  glPushGroupMarkerEXT = fromAddress<Pointer<NativeFunction<GlPushGroupMarkerEXTNative>>>(glGetProcAddress(CString.fromUtf8('glPushGroupMarkerEXT'))).asFunction<GlPushGroupMarkerEXT>();
  glPopGroupMarkerEXT = fromAddress<Pointer<NativeFunction<GlPopGroupMarkerEXTNative>>>(glGetProcAddress(CString.fromUtf8('glPopGroupMarkerEXT'))).asFunction<GlPopGroupMarkerEXT>();
  glMatrixLoadfEXT = fromAddress<Pointer<NativeFunction<GlMatrixLoadfEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixLoadfEXT'))).asFunction<GlMatrixLoadfEXT>();
  glMatrixLoaddEXT = fromAddress<Pointer<NativeFunction<GlMatrixLoaddEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixLoaddEXT'))).asFunction<GlMatrixLoaddEXT>();
  glMatrixMultfEXT = fromAddress<Pointer<NativeFunction<GlMatrixMultfEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixMultfEXT'))).asFunction<GlMatrixMultfEXT>();
  glMatrixMultdEXT = fromAddress<Pointer<NativeFunction<GlMatrixMultdEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixMultdEXT'))).asFunction<GlMatrixMultdEXT>();
  glMatrixLoadIdentityEXT = fromAddress<Pointer<NativeFunction<GlMatrixLoadIdentityEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixLoadIdentityEXT'))).asFunction<GlMatrixLoadIdentityEXT>();
  glMatrixRotatefEXT = fromAddress<Pointer<NativeFunction<GlMatrixRotatefEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixRotatefEXT'))).asFunction<GlMatrixRotatefEXT>();
  glMatrixRotatedEXT = fromAddress<Pointer<NativeFunction<GlMatrixRotatedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixRotatedEXT'))).asFunction<GlMatrixRotatedEXT>();
  glMatrixScalefEXT = fromAddress<Pointer<NativeFunction<GlMatrixScalefEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixScalefEXT'))).asFunction<GlMatrixScalefEXT>();
  glMatrixScaledEXT = fromAddress<Pointer<NativeFunction<GlMatrixScaledEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixScaledEXT'))).asFunction<GlMatrixScaledEXT>();
  glMatrixTranslatefEXT = fromAddress<Pointer<NativeFunction<GlMatrixTranslatefEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixTranslatefEXT'))).asFunction<GlMatrixTranslatefEXT>();
  glMatrixTranslatedEXT = fromAddress<Pointer<NativeFunction<GlMatrixTranslatedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixTranslatedEXT'))).asFunction<GlMatrixTranslatedEXT>();
  glMatrixFrustumEXT = fromAddress<Pointer<NativeFunction<GlMatrixFrustumEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixFrustumEXT'))).asFunction<GlMatrixFrustumEXT>();
  glMatrixOrthoEXT = fromAddress<Pointer<NativeFunction<GlMatrixOrthoEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixOrthoEXT'))).asFunction<GlMatrixOrthoEXT>();
  glMatrixPopEXT = fromAddress<Pointer<NativeFunction<GlMatrixPopEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixPopEXT'))).asFunction<GlMatrixPopEXT>();
  glMatrixPushEXT = fromAddress<Pointer<NativeFunction<GlMatrixPushEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixPushEXT'))).asFunction<GlMatrixPushEXT>();
  glClientAttribDefaultEXT = fromAddress<Pointer<NativeFunction<GlClientAttribDefaultEXTNative>>>(glGetProcAddress(CString.fromUtf8('glClientAttribDefaultEXT'))).asFunction<GlClientAttribDefaultEXT>();
  glPushClientAttribDefaultEXT = fromAddress<Pointer<NativeFunction<GlPushClientAttribDefaultEXTNative>>>(glGetProcAddress(CString.fromUtf8('glPushClientAttribDefaultEXT'))).asFunction<GlPushClientAttribDefaultEXT>();
  glTextureParameterfEXT = fromAddress<Pointer<NativeFunction<GlTextureParameterfEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterfEXT'))).asFunction<GlTextureParameterfEXT>();
  glTextureParameterfvEXT = fromAddress<Pointer<NativeFunction<GlTextureParameterfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterfvEXT'))).asFunction<GlTextureParameterfvEXT>();
  glTextureParameteriEXT = fromAddress<Pointer<NativeFunction<GlTextureParameteriEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameteriEXT'))).asFunction<GlTextureParameteriEXT>();
  glTextureParameterivEXT = fromAddress<Pointer<NativeFunction<GlTextureParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterivEXT'))).asFunction<GlTextureParameterivEXT>();
  glTextureImage1DEXT = fromAddress<Pointer<NativeFunction<GlTextureImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureImage1DEXT'))).asFunction<GlTextureImage1DEXT>();
  glTextureImage2DEXT = fromAddress<Pointer<NativeFunction<GlTextureImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureImage2DEXT'))).asFunction<GlTextureImage2DEXT>();
  glTextureSubImage1DEXT = fromAddress<Pointer<NativeFunction<GlTextureSubImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureSubImage1DEXT'))).asFunction<GlTextureSubImage1DEXT>();
  glTextureSubImage2DEXT = fromAddress<Pointer<NativeFunction<GlTextureSubImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureSubImage2DEXT'))).asFunction<GlTextureSubImage2DEXT>();
  glCopyTextureImage1DEXT = fromAddress<Pointer<NativeFunction<GlCopyTextureImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTextureImage1DEXT'))).asFunction<GlCopyTextureImage1DEXT>();
  glCopyTextureImage2DEXT = fromAddress<Pointer<NativeFunction<GlCopyTextureImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTextureImage2DEXT'))).asFunction<GlCopyTextureImage2DEXT>();
  glCopyTextureSubImage1DEXT = fromAddress<Pointer<NativeFunction<GlCopyTextureSubImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTextureSubImage1DEXT'))).asFunction<GlCopyTextureSubImage1DEXT>();
  glCopyTextureSubImage2DEXT = fromAddress<Pointer<NativeFunction<GlCopyTextureSubImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTextureSubImage2DEXT'))).asFunction<GlCopyTextureSubImage2DEXT>();
  glGetTextureImageEXT = fromAddress<Pointer<NativeFunction<GlGetTextureImageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureImageEXT'))).asFunction<GlGetTextureImageEXT>();
  glGetTextureParameterfvEXT = fromAddress<Pointer<NativeFunction<GlGetTextureParameterfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureParameterfvEXT'))).asFunction<GlGetTextureParameterfvEXT>();
  glGetTextureParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetTextureParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureParameterivEXT'))).asFunction<GlGetTextureParameterivEXT>();
  glGetTextureLevelParameterfvEXT = fromAddress<Pointer<NativeFunction<GlGetTextureLevelParameterfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureLevelParameterfvEXT'))).asFunction<GlGetTextureLevelParameterfvEXT>();
  glGetTextureLevelParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetTextureLevelParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureLevelParameterivEXT'))).asFunction<GlGetTextureLevelParameterivEXT>();
  glTextureImage3DEXT = fromAddress<Pointer<NativeFunction<GlTextureImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureImage3DEXT'))).asFunction<GlTextureImage3DEXT>();
  glTextureSubImage3DEXT = fromAddress<Pointer<NativeFunction<GlTextureSubImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureSubImage3DEXT'))).asFunction<GlTextureSubImage3DEXT>();
  glCopyTextureSubImage3DEXT = fromAddress<Pointer<NativeFunction<GlCopyTextureSubImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyTextureSubImage3DEXT'))).asFunction<GlCopyTextureSubImage3DEXT>();
  glBindMultiTextureEXT = fromAddress<Pointer<NativeFunction<GlBindMultiTextureEXTNative>>>(glGetProcAddress(CString.fromUtf8('glBindMultiTextureEXT'))).asFunction<GlBindMultiTextureEXT>();
  glMultiTexCoordPointerEXT = fromAddress<Pointer<NativeFunction<GlMultiTexCoordPointerEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexCoordPointerEXT'))).asFunction<GlMultiTexCoordPointerEXT>();
  glMultiTexEnvfEXT = fromAddress<Pointer<NativeFunction<GlMultiTexEnvfEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexEnvfEXT'))).asFunction<GlMultiTexEnvfEXT>();
  glMultiTexEnvfvEXT = fromAddress<Pointer<NativeFunction<GlMultiTexEnvfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexEnvfvEXT'))).asFunction<GlMultiTexEnvfvEXT>();
  glMultiTexEnviEXT = fromAddress<Pointer<NativeFunction<GlMultiTexEnviEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexEnviEXT'))).asFunction<GlMultiTexEnviEXT>();
  glMultiTexEnvivEXT = fromAddress<Pointer<NativeFunction<GlMultiTexEnvivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexEnvivEXT'))).asFunction<GlMultiTexEnvivEXT>();
  glMultiTexGendEXT = fromAddress<Pointer<NativeFunction<GlMultiTexGendEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexGendEXT'))).asFunction<GlMultiTexGendEXT>();
  glMultiTexGendvEXT = fromAddress<Pointer<NativeFunction<GlMultiTexGendvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexGendvEXT'))).asFunction<GlMultiTexGendvEXT>();
  glMultiTexGenfEXT = fromAddress<Pointer<NativeFunction<GlMultiTexGenfEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexGenfEXT'))).asFunction<GlMultiTexGenfEXT>();
  glMultiTexGenfvEXT = fromAddress<Pointer<NativeFunction<GlMultiTexGenfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexGenfvEXT'))).asFunction<GlMultiTexGenfvEXT>();
  glMultiTexGeniEXT = fromAddress<Pointer<NativeFunction<GlMultiTexGeniEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexGeniEXT'))).asFunction<GlMultiTexGeniEXT>();
  glMultiTexGenivEXT = fromAddress<Pointer<NativeFunction<GlMultiTexGenivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexGenivEXT'))).asFunction<GlMultiTexGenivEXT>();
  glGetMultiTexEnvfvEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexEnvfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexEnvfvEXT'))).asFunction<GlGetMultiTexEnvfvEXT>();
  glGetMultiTexEnvivEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexEnvivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexEnvivEXT'))).asFunction<GlGetMultiTexEnvivEXT>();
  glGetMultiTexGendvEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexGendvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexGendvEXT'))).asFunction<GlGetMultiTexGendvEXT>();
  glGetMultiTexGenfvEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexGenfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexGenfvEXT'))).asFunction<GlGetMultiTexGenfvEXT>();
  glGetMultiTexGenivEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexGenivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexGenivEXT'))).asFunction<GlGetMultiTexGenivEXT>();
  glMultiTexParameteriEXT = fromAddress<Pointer<NativeFunction<GlMultiTexParameteriEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexParameteriEXT'))).asFunction<GlMultiTexParameteriEXT>();
  glMultiTexParameterivEXT = fromAddress<Pointer<NativeFunction<GlMultiTexParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexParameterivEXT'))).asFunction<GlMultiTexParameterivEXT>();
  glMultiTexParameterfEXT = fromAddress<Pointer<NativeFunction<GlMultiTexParameterfEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexParameterfEXT'))).asFunction<GlMultiTexParameterfEXT>();
  glMultiTexParameterfvEXT = fromAddress<Pointer<NativeFunction<GlMultiTexParameterfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexParameterfvEXT'))).asFunction<GlMultiTexParameterfvEXT>();
  glMultiTexImage1DEXT = fromAddress<Pointer<NativeFunction<GlMultiTexImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexImage1DEXT'))).asFunction<GlMultiTexImage1DEXT>();
  glMultiTexImage2DEXT = fromAddress<Pointer<NativeFunction<GlMultiTexImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexImage2DEXT'))).asFunction<GlMultiTexImage2DEXT>();
  glMultiTexSubImage1DEXT = fromAddress<Pointer<NativeFunction<GlMultiTexSubImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexSubImage1DEXT'))).asFunction<GlMultiTexSubImage1DEXT>();
  glMultiTexSubImage2DEXT = fromAddress<Pointer<NativeFunction<GlMultiTexSubImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexSubImage2DEXT'))).asFunction<GlMultiTexSubImage2DEXT>();
  glCopyMultiTexImage1DEXT = fromAddress<Pointer<NativeFunction<GlCopyMultiTexImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyMultiTexImage1DEXT'))).asFunction<GlCopyMultiTexImage1DEXT>();
  glCopyMultiTexImage2DEXT = fromAddress<Pointer<NativeFunction<GlCopyMultiTexImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyMultiTexImage2DEXT'))).asFunction<GlCopyMultiTexImage2DEXT>();
  glCopyMultiTexSubImage1DEXT = fromAddress<Pointer<NativeFunction<GlCopyMultiTexSubImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyMultiTexSubImage1DEXT'))).asFunction<GlCopyMultiTexSubImage1DEXT>();
  glCopyMultiTexSubImage2DEXT = fromAddress<Pointer<NativeFunction<GlCopyMultiTexSubImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyMultiTexSubImage2DEXT'))).asFunction<GlCopyMultiTexSubImage2DEXT>();
  glGetMultiTexImageEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexImageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexImageEXT'))).asFunction<GlGetMultiTexImageEXT>();
  glGetMultiTexParameterfvEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexParameterfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexParameterfvEXT'))).asFunction<GlGetMultiTexParameterfvEXT>();
  glGetMultiTexParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexParameterivEXT'))).asFunction<GlGetMultiTexParameterivEXT>();
  glGetMultiTexLevelParameterfvEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexLevelParameterfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexLevelParameterfvEXT'))).asFunction<GlGetMultiTexLevelParameterfvEXT>();
  glGetMultiTexLevelParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexLevelParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexLevelParameterivEXT'))).asFunction<GlGetMultiTexLevelParameterivEXT>();
  glMultiTexImage3DEXT = fromAddress<Pointer<NativeFunction<GlMultiTexImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexImage3DEXT'))).asFunction<GlMultiTexImage3DEXT>();
  glMultiTexSubImage3DEXT = fromAddress<Pointer<NativeFunction<GlMultiTexSubImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexSubImage3DEXT'))).asFunction<GlMultiTexSubImage3DEXT>();
  glCopyMultiTexSubImage3DEXT = fromAddress<Pointer<NativeFunction<GlCopyMultiTexSubImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCopyMultiTexSubImage3DEXT'))).asFunction<GlCopyMultiTexSubImage3DEXT>();
  glEnableClientStateIndexedEXT = fromAddress<Pointer<NativeFunction<GlEnableClientStateIndexedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glEnableClientStateIndexedEXT'))).asFunction<GlEnableClientStateIndexedEXT>();
  glDisableClientStateIndexedEXT = fromAddress<Pointer<NativeFunction<GlDisableClientStateIndexedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glDisableClientStateIndexedEXT'))).asFunction<GlDisableClientStateIndexedEXT>();
  glGetFloatIndexedvEXT = fromAddress<Pointer<NativeFunction<GlGetFloatIndexedvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetFloatIndexedvEXT'))).asFunction<GlGetFloatIndexedvEXT>();
  glGetDoubleIndexedvEXT = fromAddress<Pointer<NativeFunction<GlGetDoubleIndexedvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetDoubleIndexedvEXT'))).asFunction<GlGetDoubleIndexedvEXT>();
  glGetPointerIndexedvEXT = fromAddress<Pointer<NativeFunction<GlGetPointerIndexedvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetPointerIndexedvEXT'))).asFunction<GlGetPointerIndexedvEXT>();
  glEnableIndexedEXT = fromAddress<Pointer<NativeFunction<GlEnableIndexedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glEnableIndexedEXT'))).asFunction<GlEnableIndexedEXT>();
  glDisableIndexedEXT = fromAddress<Pointer<NativeFunction<GlDisableIndexedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glDisableIndexedEXT'))).asFunction<GlDisableIndexedEXT>();
  glIsEnabledIndexedEXT = fromAddress<Pointer<NativeFunction<GlIsEnabledIndexedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glIsEnabledIndexedEXT'))).asFunction<GlIsEnabledIndexedEXT>();
  glGetIntegerIndexedvEXT = fromAddress<Pointer<NativeFunction<GlGetIntegerIndexedvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetIntegerIndexedvEXT'))).asFunction<GlGetIntegerIndexedvEXT>();
  glGetBooleanIndexedvEXT = fromAddress<Pointer<NativeFunction<GlGetBooleanIndexedvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetBooleanIndexedvEXT'))).asFunction<GlGetBooleanIndexedvEXT>();
  glCompressedTextureImage3DEXT = fromAddress<Pointer<NativeFunction<GlCompressedTextureImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureImage3DEXT'))).asFunction<GlCompressedTextureImage3DEXT>();
  glCompressedTextureImage2DEXT = fromAddress<Pointer<NativeFunction<GlCompressedTextureImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureImage2DEXT'))).asFunction<GlCompressedTextureImage2DEXT>();
  glCompressedTextureImage1DEXT = fromAddress<Pointer<NativeFunction<GlCompressedTextureImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureImage1DEXT'))).asFunction<GlCompressedTextureImage1DEXT>();
  glCompressedTextureSubImage3DEXT = fromAddress<Pointer<NativeFunction<GlCompressedTextureSubImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureSubImage3DEXT'))).asFunction<GlCompressedTextureSubImage3DEXT>();
  glCompressedTextureSubImage2DEXT = fromAddress<Pointer<NativeFunction<GlCompressedTextureSubImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureSubImage2DEXT'))).asFunction<GlCompressedTextureSubImage2DEXT>();
  glCompressedTextureSubImage1DEXT = fromAddress<Pointer<NativeFunction<GlCompressedTextureSubImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedTextureSubImage1DEXT'))).asFunction<GlCompressedTextureSubImage1DEXT>();
  glGetCompressedTextureImageEXT = fromAddress<Pointer<NativeFunction<GlGetCompressedTextureImageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetCompressedTextureImageEXT'))).asFunction<GlGetCompressedTextureImageEXT>();
  glCompressedMultiTexImage3DEXT = fromAddress<Pointer<NativeFunction<GlCompressedMultiTexImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedMultiTexImage3DEXT'))).asFunction<GlCompressedMultiTexImage3DEXT>();
  glCompressedMultiTexImage2DEXT = fromAddress<Pointer<NativeFunction<GlCompressedMultiTexImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedMultiTexImage2DEXT'))).asFunction<GlCompressedMultiTexImage2DEXT>();
  glCompressedMultiTexImage1DEXT = fromAddress<Pointer<NativeFunction<GlCompressedMultiTexImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedMultiTexImage1DEXT'))).asFunction<GlCompressedMultiTexImage1DEXT>();
  glCompressedMultiTexSubImage3DEXT = fromAddress<Pointer<NativeFunction<GlCompressedMultiTexSubImage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedMultiTexSubImage3DEXT'))).asFunction<GlCompressedMultiTexSubImage3DEXT>();
  glCompressedMultiTexSubImage2DEXT = fromAddress<Pointer<NativeFunction<GlCompressedMultiTexSubImage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedMultiTexSubImage2DEXT'))).asFunction<GlCompressedMultiTexSubImage2DEXT>();
  glCompressedMultiTexSubImage1DEXT = fromAddress<Pointer<NativeFunction<GlCompressedMultiTexSubImage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCompressedMultiTexSubImage1DEXT'))).asFunction<GlCompressedMultiTexSubImage1DEXT>();
  glGetCompressedMultiTexImageEXT = fromAddress<Pointer<NativeFunction<GlGetCompressedMultiTexImageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetCompressedMultiTexImageEXT'))).asFunction<GlGetCompressedMultiTexImageEXT>();
  glMatrixLoadTransposefEXT = fromAddress<Pointer<NativeFunction<GlMatrixLoadTransposefEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixLoadTransposefEXT'))).asFunction<GlMatrixLoadTransposefEXT>();
  glMatrixLoadTransposedEXT = fromAddress<Pointer<NativeFunction<GlMatrixLoadTransposedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixLoadTransposedEXT'))).asFunction<GlMatrixLoadTransposedEXT>();
  glMatrixMultTransposefEXT = fromAddress<Pointer<NativeFunction<GlMatrixMultTransposefEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixMultTransposefEXT'))).asFunction<GlMatrixMultTransposefEXT>();
  glMatrixMultTransposedEXT = fromAddress<Pointer<NativeFunction<GlMatrixMultTransposedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixMultTransposedEXT'))).asFunction<GlMatrixMultTransposedEXT>();
  glNamedBufferDataEXT = fromAddress<Pointer<NativeFunction<GlNamedBufferDataEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferDataEXT'))).asFunction<GlNamedBufferDataEXT>();
  glNamedBufferSubDataEXT = fromAddress<Pointer<NativeFunction<GlNamedBufferSubDataEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferSubDataEXT'))).asFunction<GlNamedBufferSubDataEXT>();
  glMapNamedBufferEXT = fromAddress<Pointer<NativeFunction<GlMapNamedBufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMapNamedBufferEXT'))).asFunction<GlMapNamedBufferEXT>();
  glUnmapNamedBufferEXT = fromAddress<Pointer<NativeFunction<GlUnmapNamedBufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glUnmapNamedBufferEXT'))).asFunction<GlUnmapNamedBufferEXT>();
  glGetNamedBufferParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetNamedBufferParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedBufferParameterivEXT'))).asFunction<GlGetNamedBufferParameterivEXT>();
  glGetNamedBufferPointervEXT = fromAddress<Pointer<NativeFunction<GlGetNamedBufferPointervEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedBufferPointervEXT'))).asFunction<GlGetNamedBufferPointervEXT>();
  glGetNamedBufferSubDataEXT = fromAddress<Pointer<NativeFunction<GlGetNamedBufferSubDataEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedBufferSubDataEXT'))).asFunction<GlGetNamedBufferSubDataEXT>();
  glProgramUniform1fEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform1fEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1fEXT'))).asFunction<GlProgramUniform1fEXT>();
  glProgramUniform2fEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform2fEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2fEXT'))).asFunction<GlProgramUniform2fEXT>();
  glProgramUniform3fEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform3fEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3fEXT'))).asFunction<GlProgramUniform3fEXT>();
  glProgramUniform4fEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform4fEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4fEXT'))).asFunction<GlProgramUniform4fEXT>();
  glProgramUniform1iEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform1iEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1iEXT'))).asFunction<GlProgramUniform1iEXT>();
  glProgramUniform2iEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform2iEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2iEXT'))).asFunction<GlProgramUniform2iEXT>();
  glProgramUniform3iEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform3iEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3iEXT'))).asFunction<GlProgramUniform3iEXT>();
  glProgramUniform4iEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform4iEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4iEXT'))).asFunction<GlProgramUniform4iEXT>();
  glProgramUniform1fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform1fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1fvEXT'))).asFunction<GlProgramUniform1fvEXT>();
  glProgramUniform2fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform2fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2fvEXT'))).asFunction<GlProgramUniform2fvEXT>();
  glProgramUniform3fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform3fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3fvEXT'))).asFunction<GlProgramUniform3fvEXT>();
  glProgramUniform4fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform4fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4fvEXT'))).asFunction<GlProgramUniform4fvEXT>();
  glProgramUniform1ivEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform1ivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1ivEXT'))).asFunction<GlProgramUniform1ivEXT>();
  glProgramUniform2ivEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform2ivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2ivEXT'))).asFunction<GlProgramUniform2ivEXT>();
  glProgramUniform3ivEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform3ivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3ivEXT'))).asFunction<GlProgramUniform3ivEXT>();
  glProgramUniform4ivEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform4ivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4ivEXT'))).asFunction<GlProgramUniform4ivEXT>();
  glProgramUniformMatrix2fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2fvEXT'))).asFunction<GlProgramUniformMatrix2fvEXT>();
  glProgramUniformMatrix3fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3fvEXT'))).asFunction<GlProgramUniformMatrix3fvEXT>();
  glProgramUniformMatrix4fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4fvEXT'))).asFunction<GlProgramUniformMatrix4fvEXT>();
  glProgramUniformMatrix2x3fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2x3fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2x3fvEXT'))).asFunction<GlProgramUniformMatrix2x3fvEXT>();
  glProgramUniformMatrix3x2fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3x2fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3x2fvEXT'))).asFunction<GlProgramUniformMatrix3x2fvEXT>();
  glProgramUniformMatrix2x4fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2x4fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2x4fvEXT'))).asFunction<GlProgramUniformMatrix2x4fvEXT>();
  glProgramUniformMatrix4x2fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4x2fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4x2fvEXT'))).asFunction<GlProgramUniformMatrix4x2fvEXT>();
  glProgramUniformMatrix3x4fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3x4fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3x4fvEXT'))).asFunction<GlProgramUniformMatrix3x4fvEXT>();
  glProgramUniformMatrix4x3fvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4x3fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4x3fvEXT'))).asFunction<GlProgramUniformMatrix4x3fvEXT>();
  glTextureBufferEXT = fromAddress<Pointer<NativeFunction<GlTextureBufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureBufferEXT'))).asFunction<GlTextureBufferEXT>();
  glMultiTexBufferEXT = fromAddress<Pointer<NativeFunction<GlMultiTexBufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexBufferEXT'))).asFunction<GlMultiTexBufferEXT>();
  glTextureParameterIivEXT = fromAddress<Pointer<NativeFunction<GlTextureParameterIivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterIivEXT'))).asFunction<GlTextureParameterIivEXT>();
  glTextureParameterIuivEXT = fromAddress<Pointer<NativeFunction<GlTextureParameterIuivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureParameterIuivEXT'))).asFunction<GlTextureParameterIuivEXT>();
  glGetTextureParameterIivEXT = fromAddress<Pointer<NativeFunction<GlGetTextureParameterIivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureParameterIivEXT'))).asFunction<GlGetTextureParameterIivEXT>();
  glGetTextureParameterIuivEXT = fromAddress<Pointer<NativeFunction<GlGetTextureParameterIuivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureParameterIuivEXT'))).asFunction<GlGetTextureParameterIuivEXT>();
  glMultiTexParameterIivEXT = fromAddress<Pointer<NativeFunction<GlMultiTexParameterIivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexParameterIivEXT'))).asFunction<GlMultiTexParameterIivEXT>();
  glMultiTexParameterIuivEXT = fromAddress<Pointer<NativeFunction<GlMultiTexParameterIuivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexParameterIuivEXT'))).asFunction<GlMultiTexParameterIuivEXT>();
  glGetMultiTexParameterIivEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexParameterIivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexParameterIivEXT'))).asFunction<GlGetMultiTexParameterIivEXT>();
  glGetMultiTexParameterIuivEXT = fromAddress<Pointer<NativeFunction<GlGetMultiTexParameterIuivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetMultiTexParameterIuivEXT'))).asFunction<GlGetMultiTexParameterIuivEXT>();
  glProgramUniform1uiEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform1uiEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1uiEXT'))).asFunction<GlProgramUniform1uiEXT>();
  glProgramUniform2uiEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform2uiEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2uiEXT'))).asFunction<GlProgramUniform2uiEXT>();
  glProgramUniform3uiEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform3uiEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3uiEXT'))).asFunction<GlProgramUniform3uiEXT>();
  glProgramUniform4uiEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform4uiEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4uiEXT'))).asFunction<GlProgramUniform4uiEXT>();
  glProgramUniform1uivEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform1uivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1uivEXT'))).asFunction<GlProgramUniform1uivEXT>();
  glProgramUniform2uivEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform2uivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2uivEXT'))).asFunction<GlProgramUniform2uivEXT>();
  glProgramUniform3uivEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform3uivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3uivEXT'))).asFunction<GlProgramUniform3uivEXT>();
  glProgramUniform4uivEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform4uivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4uivEXT'))).asFunction<GlProgramUniform4uivEXT>();
  glNamedProgramLocalParameters4fvEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameters4fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameters4fvEXT'))).asFunction<GlNamedProgramLocalParameters4fvEXT>();
  glNamedProgramLocalParameterI4iEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameterI4iEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameterI4iEXT'))).asFunction<GlNamedProgramLocalParameterI4iEXT>();
  glNamedProgramLocalParameterI4ivEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameterI4ivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameterI4ivEXT'))).asFunction<GlNamedProgramLocalParameterI4ivEXT>();
  glNamedProgramLocalParametersI4ivEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParametersI4ivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParametersI4ivEXT'))).asFunction<GlNamedProgramLocalParametersI4ivEXT>();
  glNamedProgramLocalParameterI4uiEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameterI4uiEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameterI4uiEXT'))).asFunction<GlNamedProgramLocalParameterI4uiEXT>();
  glNamedProgramLocalParameterI4uivEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameterI4uivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameterI4uivEXT'))).asFunction<GlNamedProgramLocalParameterI4uivEXT>();
  glNamedProgramLocalParametersI4uivEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParametersI4uivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParametersI4uivEXT'))).asFunction<GlNamedProgramLocalParametersI4uivEXT>();
  glGetNamedProgramLocalParameterIivEXT = fromAddress<Pointer<NativeFunction<GlGetNamedProgramLocalParameterIivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedProgramLocalParameterIivEXT'))).asFunction<GlGetNamedProgramLocalParameterIivEXT>();
  glGetNamedProgramLocalParameterIuivEXT = fromAddress<Pointer<NativeFunction<GlGetNamedProgramLocalParameterIuivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedProgramLocalParameterIuivEXT'))).asFunction<GlGetNamedProgramLocalParameterIuivEXT>();
  glEnableClientStateiEXT = fromAddress<Pointer<NativeFunction<GlEnableClientStateiEXTNative>>>(glGetProcAddress(CString.fromUtf8('glEnableClientStateiEXT'))).asFunction<GlEnableClientStateiEXT>();
  glDisableClientStateiEXT = fromAddress<Pointer<NativeFunction<GlDisableClientStateiEXTNative>>>(glGetProcAddress(CString.fromUtf8('glDisableClientStateiEXT'))).asFunction<GlDisableClientStateiEXT>();
  glGetFloati_vEXT = fromAddress<Pointer<NativeFunction<GlGetFloati_vEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetFloati_vEXT'))).asFunction<GlGetFloati_vEXT>();
  glGetDoublei_vEXT = fromAddress<Pointer<NativeFunction<GlGetDoublei_vEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetDoublei_vEXT'))).asFunction<GlGetDoublei_vEXT>();
  glGetPointeri_vEXT = fromAddress<Pointer<NativeFunction<GlGetPointeri_vEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetPointeri_vEXT'))).asFunction<GlGetPointeri_vEXT>();
  glNamedProgramStringEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramStringEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramStringEXT'))).asFunction<GlNamedProgramStringEXT>();
  glNamedProgramLocalParameter4dEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameter4dEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameter4dEXT'))).asFunction<GlNamedProgramLocalParameter4dEXT>();
  glNamedProgramLocalParameter4dvEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameter4dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameter4dvEXT'))).asFunction<GlNamedProgramLocalParameter4dvEXT>();
  glNamedProgramLocalParameter4fEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameter4fEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameter4fEXT'))).asFunction<GlNamedProgramLocalParameter4fEXT>();
  glNamedProgramLocalParameter4fvEXT = fromAddress<Pointer<NativeFunction<GlNamedProgramLocalParameter4fvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedProgramLocalParameter4fvEXT'))).asFunction<GlNamedProgramLocalParameter4fvEXT>();
  glGetNamedProgramLocalParameterdvEXT = fromAddress<Pointer<NativeFunction<GlGetNamedProgramLocalParameterdvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedProgramLocalParameterdvEXT'))).asFunction<GlGetNamedProgramLocalParameterdvEXT>();
  glGetNamedProgramLocalParameterfvEXT = fromAddress<Pointer<NativeFunction<GlGetNamedProgramLocalParameterfvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedProgramLocalParameterfvEXT'))).asFunction<GlGetNamedProgramLocalParameterfvEXT>();
  glGetNamedProgramivEXT = fromAddress<Pointer<NativeFunction<GlGetNamedProgramivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedProgramivEXT'))).asFunction<GlGetNamedProgramivEXT>();
  glGetNamedProgramStringEXT = fromAddress<Pointer<NativeFunction<GlGetNamedProgramStringEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedProgramStringEXT'))).asFunction<GlGetNamedProgramStringEXT>();
  glNamedRenderbufferStorageEXT = fromAddress<Pointer<NativeFunction<GlNamedRenderbufferStorageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedRenderbufferStorageEXT'))).asFunction<GlNamedRenderbufferStorageEXT>();
  glGetNamedRenderbufferParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetNamedRenderbufferParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedRenderbufferParameterivEXT'))).asFunction<GlGetNamedRenderbufferParameterivEXT>();
  glNamedRenderbufferStorageMultisampleEXT = fromAddress<Pointer<NativeFunction<GlNamedRenderbufferStorageMultisampleEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedRenderbufferStorageMultisampleEXT'))).asFunction<GlNamedRenderbufferStorageMultisampleEXT>();
  glNamedRenderbufferStorageMultisampleCoverageEXT = fromAddress<Pointer<NativeFunction<GlNamedRenderbufferStorageMultisampleCoverageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedRenderbufferStorageMultisampleCoverageEXT'))).asFunction<GlNamedRenderbufferStorageMultisampleCoverageEXT>();
  glCheckNamedFramebufferStatusEXT = fromAddress<Pointer<NativeFunction<GlCheckNamedFramebufferStatusEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCheckNamedFramebufferStatusEXT'))).asFunction<GlCheckNamedFramebufferStatusEXT>();
  glNamedFramebufferTexture1DEXT = fromAddress<Pointer<NativeFunction<GlNamedFramebufferTexture1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferTexture1DEXT'))).asFunction<GlNamedFramebufferTexture1DEXT>();
  glNamedFramebufferTexture2DEXT = fromAddress<Pointer<NativeFunction<GlNamedFramebufferTexture2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferTexture2DEXT'))).asFunction<GlNamedFramebufferTexture2DEXT>();
  glNamedFramebufferTexture3DEXT = fromAddress<Pointer<NativeFunction<GlNamedFramebufferTexture3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferTexture3DEXT'))).asFunction<GlNamedFramebufferTexture3DEXT>();
  glNamedFramebufferRenderbufferEXT = fromAddress<Pointer<NativeFunction<GlNamedFramebufferRenderbufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferRenderbufferEXT'))).asFunction<GlNamedFramebufferRenderbufferEXT>();
  glGetNamedFramebufferAttachmentParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetNamedFramebufferAttachmentParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedFramebufferAttachmentParameterivEXT'))).asFunction<GlGetNamedFramebufferAttachmentParameterivEXT>();
  glGenerateTextureMipmapEXT = fromAddress<Pointer<NativeFunction<GlGenerateTextureMipmapEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGenerateTextureMipmapEXT'))).asFunction<GlGenerateTextureMipmapEXT>();
  glGenerateMultiTexMipmapEXT = fromAddress<Pointer<NativeFunction<GlGenerateMultiTexMipmapEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGenerateMultiTexMipmapEXT'))).asFunction<GlGenerateMultiTexMipmapEXT>();
  glFramebufferDrawBufferEXT = fromAddress<Pointer<NativeFunction<GlFramebufferDrawBufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferDrawBufferEXT'))).asFunction<GlFramebufferDrawBufferEXT>();
  glFramebufferDrawBuffersEXT = fromAddress<Pointer<NativeFunction<GlFramebufferDrawBuffersEXTNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferDrawBuffersEXT'))).asFunction<GlFramebufferDrawBuffersEXT>();
  glFramebufferReadBufferEXT = fromAddress<Pointer<NativeFunction<GlFramebufferReadBufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferReadBufferEXT'))).asFunction<GlFramebufferReadBufferEXT>();
  glGetFramebufferParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetFramebufferParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetFramebufferParameterivEXT'))).asFunction<GlGetFramebufferParameterivEXT>();
  glNamedCopyBufferSubDataEXT = fromAddress<Pointer<NativeFunction<GlNamedCopyBufferSubDataEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedCopyBufferSubDataEXT'))).asFunction<GlNamedCopyBufferSubDataEXT>();
  glNamedFramebufferTextureEXT = fromAddress<Pointer<NativeFunction<GlNamedFramebufferTextureEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferTextureEXT'))).asFunction<GlNamedFramebufferTextureEXT>();
  glNamedFramebufferTextureLayerEXT = fromAddress<Pointer<NativeFunction<GlNamedFramebufferTextureLayerEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferTextureLayerEXT'))).asFunction<GlNamedFramebufferTextureLayerEXT>();
  glNamedFramebufferTextureFaceEXT = fromAddress<Pointer<NativeFunction<GlNamedFramebufferTextureFaceEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferTextureFaceEXT'))).asFunction<GlNamedFramebufferTextureFaceEXT>();
  glTextureRenderbufferEXT = fromAddress<Pointer<NativeFunction<GlTextureRenderbufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureRenderbufferEXT'))).asFunction<GlTextureRenderbufferEXT>();
  glMultiTexRenderbufferEXT = fromAddress<Pointer<NativeFunction<GlMultiTexRenderbufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMultiTexRenderbufferEXT'))).asFunction<GlMultiTexRenderbufferEXT>();
  glVertexArrayVertexOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexOffsetEXT'))).asFunction<GlVertexArrayVertexOffsetEXT>();
  glVertexArrayColorOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayColorOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayColorOffsetEXT'))).asFunction<GlVertexArrayColorOffsetEXT>();
  glVertexArrayEdgeFlagOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayEdgeFlagOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayEdgeFlagOffsetEXT'))).asFunction<GlVertexArrayEdgeFlagOffsetEXT>();
  glVertexArrayIndexOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayIndexOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayIndexOffsetEXT'))).asFunction<GlVertexArrayIndexOffsetEXT>();
  glVertexArrayNormalOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayNormalOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayNormalOffsetEXT'))).asFunction<GlVertexArrayNormalOffsetEXT>();
  glVertexArrayTexCoordOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayTexCoordOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayTexCoordOffsetEXT'))).asFunction<GlVertexArrayTexCoordOffsetEXT>();
  glVertexArrayMultiTexCoordOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayMultiTexCoordOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayMultiTexCoordOffsetEXT'))).asFunction<GlVertexArrayMultiTexCoordOffsetEXT>();
  glVertexArrayFogCoordOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayFogCoordOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayFogCoordOffsetEXT'))).asFunction<GlVertexArrayFogCoordOffsetEXT>();
  glVertexArraySecondaryColorOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArraySecondaryColorOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArraySecondaryColorOffsetEXT'))).asFunction<GlVertexArraySecondaryColorOffsetEXT>();
  glVertexArrayVertexAttribOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexAttribOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexAttribOffsetEXT'))).asFunction<GlVertexArrayVertexAttribOffsetEXT>();
  glVertexArrayVertexAttribIOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexAttribIOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexAttribIOffsetEXT'))).asFunction<GlVertexArrayVertexAttribIOffsetEXT>();
  glEnableVertexArrayEXT = fromAddress<Pointer<NativeFunction<GlEnableVertexArrayEXTNative>>>(glGetProcAddress(CString.fromUtf8('glEnableVertexArrayEXT'))).asFunction<GlEnableVertexArrayEXT>();
  glDisableVertexArrayEXT = fromAddress<Pointer<NativeFunction<GlDisableVertexArrayEXTNative>>>(glGetProcAddress(CString.fromUtf8('glDisableVertexArrayEXT'))).asFunction<GlDisableVertexArrayEXT>();
  glEnableVertexArrayAttribEXT = fromAddress<Pointer<NativeFunction<GlEnableVertexArrayAttribEXTNative>>>(glGetProcAddress(CString.fromUtf8('glEnableVertexArrayAttribEXT'))).asFunction<GlEnableVertexArrayAttribEXT>();
  glDisableVertexArrayAttribEXT = fromAddress<Pointer<NativeFunction<GlDisableVertexArrayAttribEXTNative>>>(glGetProcAddress(CString.fromUtf8('glDisableVertexArrayAttribEXT'))).asFunction<GlDisableVertexArrayAttribEXT>();
  glGetVertexArrayIntegervEXT = fromAddress<Pointer<NativeFunction<GlGetVertexArrayIntegervEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexArrayIntegervEXT'))).asFunction<GlGetVertexArrayIntegervEXT>();
  glGetVertexArrayPointervEXT = fromAddress<Pointer<NativeFunction<GlGetVertexArrayPointervEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexArrayPointervEXT'))).asFunction<GlGetVertexArrayPointervEXT>();
  glGetVertexArrayIntegeri_vEXT = fromAddress<Pointer<NativeFunction<GlGetVertexArrayIntegeri_vEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexArrayIntegeri_vEXT'))).asFunction<GlGetVertexArrayIntegeri_vEXT>();
  glGetVertexArrayPointeri_vEXT = fromAddress<Pointer<NativeFunction<GlGetVertexArrayPointeri_vEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexArrayPointeri_vEXT'))).asFunction<GlGetVertexArrayPointeri_vEXT>();
  glMapNamedBufferRangeEXT = fromAddress<Pointer<NativeFunction<GlMapNamedBufferRangeEXTNative>>>(glGetProcAddress(CString.fromUtf8('glMapNamedBufferRangeEXT'))).asFunction<GlMapNamedBufferRangeEXT>();
  glFlushMappedNamedBufferRangeEXT = fromAddress<Pointer<NativeFunction<GlFlushMappedNamedBufferRangeEXTNative>>>(glGetProcAddress(CString.fromUtf8('glFlushMappedNamedBufferRangeEXT'))).asFunction<GlFlushMappedNamedBufferRangeEXT>();
  glNamedBufferStorageEXT = fromAddress<Pointer<NativeFunction<GlNamedBufferStorageEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferStorageEXT'))).asFunction<GlNamedBufferStorageEXT>();
  glClearNamedBufferDataEXT = fromAddress<Pointer<NativeFunction<GlClearNamedBufferDataEXTNative>>>(glGetProcAddress(CString.fromUtf8('glClearNamedBufferDataEXT'))).asFunction<GlClearNamedBufferDataEXT>();
  glClearNamedBufferSubDataEXT = fromAddress<Pointer<NativeFunction<GlClearNamedBufferSubDataEXTNative>>>(glGetProcAddress(CString.fromUtf8('glClearNamedBufferSubDataEXT'))).asFunction<GlClearNamedBufferSubDataEXT>();
  glNamedFramebufferParameteriEXT = fromAddress<Pointer<NativeFunction<GlNamedFramebufferParameteriEXTNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferParameteriEXT'))).asFunction<GlNamedFramebufferParameteriEXT>();
  glGetNamedFramebufferParameterivEXT = fromAddress<Pointer<NativeFunction<GlGetNamedFramebufferParameterivEXTNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedFramebufferParameterivEXT'))).asFunction<GlGetNamedFramebufferParameterivEXT>();
  glProgramUniform1dEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform1dEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1dEXT'))).asFunction<GlProgramUniform1dEXT>();
  glProgramUniform2dEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform2dEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2dEXT'))).asFunction<GlProgramUniform2dEXT>();
  glProgramUniform3dEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform3dEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3dEXT'))).asFunction<GlProgramUniform3dEXT>();
  glProgramUniform4dEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform4dEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4dEXT'))).asFunction<GlProgramUniform4dEXT>();
  glProgramUniform1dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform1dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1dvEXT'))).asFunction<GlProgramUniform1dvEXT>();
  glProgramUniform2dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform2dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2dvEXT'))).asFunction<GlProgramUniform2dvEXT>();
  glProgramUniform3dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform3dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3dvEXT'))).asFunction<GlProgramUniform3dvEXT>();
  glProgramUniform4dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniform4dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4dvEXT'))).asFunction<GlProgramUniform4dvEXT>();
  glProgramUniformMatrix2dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2dvEXT'))).asFunction<GlProgramUniformMatrix2dvEXT>();
  glProgramUniformMatrix3dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3dvEXT'))).asFunction<GlProgramUniformMatrix3dvEXT>();
  glProgramUniformMatrix4dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4dvEXT'))).asFunction<GlProgramUniformMatrix4dvEXT>();
  glProgramUniformMatrix2x3dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2x3dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2x3dvEXT'))).asFunction<GlProgramUniformMatrix2x3dvEXT>();
  glProgramUniformMatrix2x4dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix2x4dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix2x4dvEXT'))).asFunction<GlProgramUniformMatrix2x4dvEXT>();
  glProgramUniformMatrix3x2dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3x2dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3x2dvEXT'))).asFunction<GlProgramUniformMatrix3x2dvEXT>();
  glProgramUniformMatrix3x4dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix3x4dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix3x4dvEXT'))).asFunction<GlProgramUniformMatrix3x4dvEXT>();
  glProgramUniformMatrix4x2dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4x2dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4x2dvEXT'))).asFunction<GlProgramUniformMatrix4x2dvEXT>();
  glProgramUniformMatrix4x3dvEXT = fromAddress<Pointer<NativeFunction<GlProgramUniformMatrix4x3dvEXTNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformMatrix4x3dvEXT'))).asFunction<GlProgramUniformMatrix4x3dvEXT>();
  glTextureBufferRangeEXT = fromAddress<Pointer<NativeFunction<GlTextureBufferRangeEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureBufferRangeEXT'))).asFunction<GlTextureBufferRangeEXT>();
  glTextureStorage1DEXT = fromAddress<Pointer<NativeFunction<GlTextureStorage1DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage1DEXT'))).asFunction<GlTextureStorage1DEXT>();
  glTextureStorage2DEXT = fromAddress<Pointer<NativeFunction<GlTextureStorage2DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage2DEXT'))).asFunction<GlTextureStorage2DEXT>();
  glTextureStorage3DEXT = fromAddress<Pointer<NativeFunction<GlTextureStorage3DEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage3DEXT'))).asFunction<GlTextureStorage3DEXT>();
  glTextureStorage2DMultisampleEXT = fromAddress<Pointer<NativeFunction<GlTextureStorage2DMultisampleEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage2DMultisampleEXT'))).asFunction<GlTextureStorage2DMultisampleEXT>();
  glTextureStorage3DMultisampleEXT = fromAddress<Pointer<NativeFunction<GlTextureStorage3DMultisampleEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTextureStorage3DMultisampleEXT'))).asFunction<GlTextureStorage3DMultisampleEXT>();
  glVertexArrayBindVertexBufferEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayBindVertexBufferEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayBindVertexBufferEXT'))).asFunction<GlVertexArrayBindVertexBufferEXT>();
  glVertexArrayVertexAttribFormatEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexAttribFormatEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexAttribFormatEXT'))).asFunction<GlVertexArrayVertexAttribFormatEXT>();
  glVertexArrayVertexAttribIFormatEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexAttribIFormatEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexAttribIFormatEXT'))).asFunction<GlVertexArrayVertexAttribIFormatEXT>();
  glVertexArrayVertexAttribLFormatEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexAttribLFormatEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexAttribLFormatEXT'))).asFunction<GlVertexArrayVertexAttribLFormatEXT>();
  glVertexArrayVertexAttribBindingEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexAttribBindingEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexAttribBindingEXT'))).asFunction<GlVertexArrayVertexAttribBindingEXT>();
  glVertexArrayVertexBindingDivisorEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexBindingDivisorEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexBindingDivisorEXT'))).asFunction<GlVertexArrayVertexBindingDivisorEXT>();
  glVertexArrayVertexAttribLOffsetEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexAttribLOffsetEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexAttribLOffsetEXT'))).asFunction<GlVertexArrayVertexAttribLOffsetEXT>();
  glTexturePageCommitmentEXT = fromAddress<Pointer<NativeFunction<GlTexturePageCommitmentEXTNative>>>(glGetProcAddress(CString.fromUtf8('glTexturePageCommitmentEXT'))).asFunction<GlTexturePageCommitmentEXT>();
  glVertexArrayVertexAttribDivisorEXT = fromAddress<Pointer<NativeFunction<GlVertexArrayVertexAttribDivisorEXTNative>>>(glGetProcAddress(CString.fromUtf8('glVertexArrayVertexAttribDivisorEXT'))).asFunction<GlVertexArrayVertexAttribDivisorEXT>();
  glDrawArraysInstancedEXT = fromAddress<Pointer<NativeFunction<GlDrawArraysInstancedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glDrawArraysInstancedEXT'))).asFunction<GlDrawArraysInstancedEXT>();
  glDrawElementsInstancedEXT = fromAddress<Pointer<NativeFunction<GlDrawElementsInstancedEXTNative>>>(glGetProcAddress(CString.fromUtf8('glDrawElementsInstancedEXT'))).asFunction<GlDrawElementsInstancedEXT>();
  glPolygonOffsetClampEXT = fromAddress<Pointer<NativeFunction<GlPolygonOffsetClampEXTNative>>>(glGetProcAddress(CString.fromUtf8('glPolygonOffsetClampEXT'))).asFunction<GlPolygonOffsetClampEXT>();
  glRasterSamplesEXT = fromAddress<Pointer<NativeFunction<GlRasterSamplesEXTNative>>>(glGetProcAddress(CString.fromUtf8('glRasterSamplesEXT'))).asFunction<GlRasterSamplesEXT>();
  glUseShaderProgramEXT = fromAddress<Pointer<NativeFunction<GlUseShaderProgramEXTNative>>>(glGetProcAddress(CString.fromUtf8('glUseShaderProgramEXT'))).asFunction<GlUseShaderProgramEXT>();
  glActiveProgramEXT = fromAddress<Pointer<NativeFunction<GlActiveProgramEXTNative>>>(glGetProcAddress(CString.fromUtf8('glActiveProgramEXT'))).asFunction<GlActiveProgramEXT>();
  glCreateShaderProgramEXT = fromAddress<Pointer<NativeFunction<GlCreateShaderProgramEXTNative>>>(glGetProcAddress(CString.fromUtf8('glCreateShaderProgramEXT'))).asFunction<GlCreateShaderProgramEXT>();
  glFramebufferFetchBarrierEXT = fromAddress<Pointer<NativeFunction<GlFramebufferFetchBarrierEXTNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferFetchBarrierEXT'))).asFunction<GlFramebufferFetchBarrierEXT>();
  glWindowRectanglesEXT = fromAddress<Pointer<NativeFunction<GlWindowRectanglesEXTNative>>>(glGetProcAddress(CString.fromUtf8('glWindowRectanglesEXT'))).asFunction<GlWindowRectanglesEXT>();
  glApplyFramebufferAttachmentCMAAINTEL = fromAddress<Pointer<NativeFunction<GlApplyFramebufferAttachmentCMAAINTELNative>>>(glGetProcAddress(CString.fromUtf8('glApplyFramebufferAttachmentCMAAINTEL'))).asFunction<GlApplyFramebufferAttachmentCMAAINTEL>();
  glBeginPerfQueryINTEL = fromAddress<Pointer<NativeFunction<GlBeginPerfQueryINTELNative>>>(glGetProcAddress(CString.fromUtf8('glBeginPerfQueryINTEL'))).asFunction<GlBeginPerfQueryINTEL>();
  glCreatePerfQueryINTEL = fromAddress<Pointer<NativeFunction<GlCreatePerfQueryINTELNative>>>(glGetProcAddress(CString.fromUtf8('glCreatePerfQueryINTEL'))).asFunction<GlCreatePerfQueryINTEL>();
  glDeletePerfQueryINTEL = fromAddress<Pointer<NativeFunction<GlDeletePerfQueryINTELNative>>>(glGetProcAddress(CString.fromUtf8('glDeletePerfQueryINTEL'))).asFunction<GlDeletePerfQueryINTEL>();
  glEndPerfQueryINTEL = fromAddress<Pointer<NativeFunction<GlEndPerfQueryINTELNative>>>(glGetProcAddress(CString.fromUtf8('glEndPerfQueryINTEL'))).asFunction<GlEndPerfQueryINTEL>();
  glGetFirstPerfQueryIdINTEL = fromAddress<Pointer<NativeFunction<GlGetFirstPerfQueryIdINTELNative>>>(glGetProcAddress(CString.fromUtf8('glGetFirstPerfQueryIdINTEL'))).asFunction<GlGetFirstPerfQueryIdINTEL>();
  glGetNextPerfQueryIdINTEL = fromAddress<Pointer<NativeFunction<GlGetNextPerfQueryIdINTELNative>>>(glGetProcAddress(CString.fromUtf8('glGetNextPerfQueryIdINTEL'))).asFunction<GlGetNextPerfQueryIdINTEL>();
  glGetPerfCounterInfoINTEL = fromAddress<Pointer<NativeFunction<GlGetPerfCounterInfoINTELNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfCounterInfoINTEL'))).asFunction<GlGetPerfCounterInfoINTEL>();
  glGetPerfQueryDataINTEL = fromAddress<Pointer<NativeFunction<GlGetPerfQueryDataINTELNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfQueryDataINTEL'))).asFunction<GlGetPerfQueryDataINTEL>();
  glGetPerfQueryIdByNameINTEL = fromAddress<Pointer<NativeFunction<GlGetPerfQueryIdByNameINTELNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfQueryIdByNameINTEL'))).asFunction<GlGetPerfQueryIdByNameINTEL>();
  glGetPerfQueryInfoINTEL = fromAddress<Pointer<NativeFunction<GlGetPerfQueryInfoINTELNative>>>(glGetProcAddress(CString.fromUtf8('glGetPerfQueryInfoINTEL'))).asFunction<GlGetPerfQueryInfoINTEL>();
  glMultiDrawArraysIndirectBindlessNV = fromAddress<Pointer<NativeFunction<GlMultiDrawArraysIndirectBindlessNVNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawArraysIndirectBindlessNV'))).asFunction<GlMultiDrawArraysIndirectBindlessNV>();
  glMultiDrawElementsIndirectBindlessNV = fromAddress<Pointer<NativeFunction<GlMultiDrawElementsIndirectBindlessNVNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawElementsIndirectBindlessNV'))).asFunction<GlMultiDrawElementsIndirectBindlessNV>();
  glMultiDrawArraysIndirectBindlessCountNV = fromAddress<Pointer<NativeFunction<GlMultiDrawArraysIndirectBindlessCountNVNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawArraysIndirectBindlessCountNV'))).asFunction<GlMultiDrawArraysIndirectBindlessCountNV>();
  glMultiDrawElementsIndirectBindlessCountNV = fromAddress<Pointer<NativeFunction<GlMultiDrawElementsIndirectBindlessCountNVNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawElementsIndirectBindlessCountNV'))).asFunction<GlMultiDrawElementsIndirectBindlessCountNV>();
  glGetTextureHandleNV = fromAddress<Pointer<NativeFunction<GlGetTextureHandleNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureHandleNV'))).asFunction<GlGetTextureHandleNV>();
  glGetTextureSamplerHandleNV = fromAddress<Pointer<NativeFunction<GlGetTextureSamplerHandleNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetTextureSamplerHandleNV'))).asFunction<GlGetTextureSamplerHandleNV>();
  glMakeTextureHandleResidentNV = fromAddress<Pointer<NativeFunction<GlMakeTextureHandleResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glMakeTextureHandleResidentNV'))).asFunction<GlMakeTextureHandleResidentNV>();
  glMakeTextureHandleNonResidentNV = fromAddress<Pointer<NativeFunction<GlMakeTextureHandleNonResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glMakeTextureHandleNonResidentNV'))).asFunction<GlMakeTextureHandleNonResidentNV>();
  glGetImageHandleNV = fromAddress<Pointer<NativeFunction<GlGetImageHandleNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetImageHandleNV'))).asFunction<GlGetImageHandleNV>();
  glMakeImageHandleResidentNV = fromAddress<Pointer<NativeFunction<GlMakeImageHandleResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glMakeImageHandleResidentNV'))).asFunction<GlMakeImageHandleResidentNV>();
  glMakeImageHandleNonResidentNV = fromAddress<Pointer<NativeFunction<GlMakeImageHandleNonResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glMakeImageHandleNonResidentNV'))).asFunction<GlMakeImageHandleNonResidentNV>();
  glUniformHandleui64NV = fromAddress<Pointer<NativeFunction<GlUniformHandleui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniformHandleui64NV'))).asFunction<GlUniformHandleui64NV>();
  glUniformHandleui64vNV = fromAddress<Pointer<NativeFunction<GlUniformHandleui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniformHandleui64vNV'))).asFunction<GlUniformHandleui64vNV>();
  glProgramUniformHandleui64NV = fromAddress<Pointer<NativeFunction<GlProgramUniformHandleui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformHandleui64NV'))).asFunction<GlProgramUniformHandleui64NV>();
  glProgramUniformHandleui64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniformHandleui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformHandleui64vNV'))).asFunction<GlProgramUniformHandleui64vNV>();
  glIsTextureHandleResidentNV = fromAddress<Pointer<NativeFunction<GlIsTextureHandleResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsTextureHandleResidentNV'))).asFunction<GlIsTextureHandleResidentNV>();
  glIsImageHandleResidentNV = fromAddress<Pointer<NativeFunction<GlIsImageHandleResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsImageHandleResidentNV'))).asFunction<GlIsImageHandleResidentNV>();
  glBlendParameteriNV = fromAddress<Pointer<NativeFunction<GlBlendParameteriNVNative>>>(glGetProcAddress(CString.fromUtf8('glBlendParameteriNV'))).asFunction<GlBlendParameteriNV>();
  glBlendBarrierNV = fromAddress<Pointer<NativeFunction<GlBlendBarrierNVNative>>>(glGetProcAddress(CString.fromUtf8('glBlendBarrierNV'))).asFunction<GlBlendBarrierNV>();
  glViewportPositionWScaleNV = fromAddress<Pointer<NativeFunction<GlViewportPositionWScaleNVNative>>>(glGetProcAddress(CString.fromUtf8('glViewportPositionWScaleNV'))).asFunction<GlViewportPositionWScaleNV>();
  glCreateStatesNV = fromAddress<Pointer<NativeFunction<GlCreateStatesNVNative>>>(glGetProcAddress(CString.fromUtf8('glCreateStatesNV'))).asFunction<GlCreateStatesNV>();
  glDeleteStatesNV = fromAddress<Pointer<NativeFunction<GlDeleteStatesNVNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteStatesNV'))).asFunction<GlDeleteStatesNV>();
  glIsStateNV = fromAddress<Pointer<NativeFunction<GlIsStateNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsStateNV'))).asFunction<GlIsStateNV>();
  glStateCaptureNV = fromAddress<Pointer<NativeFunction<GlStateCaptureNVNative>>>(glGetProcAddress(CString.fromUtf8('glStateCaptureNV'))).asFunction<GlStateCaptureNV>();
  glGetCommandHeaderNV = fromAddress<Pointer<NativeFunction<GlGetCommandHeaderNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetCommandHeaderNV'))).asFunction<GlGetCommandHeaderNV>();
  glGetStageIndexNV = fromAddress<Pointer<NativeFunction<GlGetStageIndexNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetStageIndexNV'))).asFunction<GlGetStageIndexNV>();
  glDrawCommandsNV = fromAddress<Pointer<NativeFunction<GlDrawCommandsNVNative>>>(glGetProcAddress(CString.fromUtf8('glDrawCommandsNV'))).asFunction<GlDrawCommandsNV>();
  glDrawCommandsAddressNV = fromAddress<Pointer<NativeFunction<GlDrawCommandsAddressNVNative>>>(glGetProcAddress(CString.fromUtf8('glDrawCommandsAddressNV'))).asFunction<GlDrawCommandsAddressNV>();
  glDrawCommandsStatesNV = fromAddress<Pointer<NativeFunction<GlDrawCommandsStatesNVNative>>>(glGetProcAddress(CString.fromUtf8('glDrawCommandsStatesNV'))).asFunction<GlDrawCommandsStatesNV>();
  glDrawCommandsStatesAddressNV = fromAddress<Pointer<NativeFunction<GlDrawCommandsStatesAddressNVNative>>>(glGetProcAddress(CString.fromUtf8('glDrawCommandsStatesAddressNV'))).asFunction<GlDrawCommandsStatesAddressNV>();
  glCreateCommandListsNV = fromAddress<Pointer<NativeFunction<GlCreateCommandListsNVNative>>>(glGetProcAddress(CString.fromUtf8('glCreateCommandListsNV'))).asFunction<GlCreateCommandListsNV>();
  glDeleteCommandListsNV = fromAddress<Pointer<NativeFunction<GlDeleteCommandListsNVNative>>>(glGetProcAddress(CString.fromUtf8('glDeleteCommandListsNV'))).asFunction<GlDeleteCommandListsNV>();
  glIsCommandListNV = fromAddress<Pointer<NativeFunction<GlIsCommandListNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsCommandListNV'))).asFunction<GlIsCommandListNV>();
  glListDrawCommandsStatesClientNV = fromAddress<Pointer<NativeFunction<GlListDrawCommandsStatesClientNVNative>>>(glGetProcAddress(CString.fromUtf8('glListDrawCommandsStatesClientNV'))).asFunction<GlListDrawCommandsStatesClientNV>();
  glCommandListSegmentsNV = fromAddress<Pointer<NativeFunction<GlCommandListSegmentsNVNative>>>(glGetProcAddress(CString.fromUtf8('glCommandListSegmentsNV'))).asFunction<GlCommandListSegmentsNV>();
  glCompileCommandListNV = fromAddress<Pointer<NativeFunction<GlCompileCommandListNVNative>>>(glGetProcAddress(CString.fromUtf8('glCompileCommandListNV'))).asFunction<GlCompileCommandListNV>();
  glCallCommandListNV = fromAddress<Pointer<NativeFunction<GlCallCommandListNVNative>>>(glGetProcAddress(CString.fromUtf8('glCallCommandListNV'))).asFunction<GlCallCommandListNV>();
  glBeginConditionalRenderNV = fromAddress<Pointer<NativeFunction<GlBeginConditionalRenderNVNative>>>(glGetProcAddress(CString.fromUtf8('glBeginConditionalRenderNV'))).asFunction<GlBeginConditionalRenderNV>();
  glEndConditionalRenderNV = fromAddress<Pointer<NativeFunction<GlEndConditionalRenderNVNative>>>(glGetProcAddress(CString.fromUtf8('glEndConditionalRenderNV'))).asFunction<GlEndConditionalRenderNV>();
  glSubpixelPrecisionBiasNV = fromAddress<Pointer<NativeFunction<GlSubpixelPrecisionBiasNVNative>>>(glGetProcAddress(CString.fromUtf8('glSubpixelPrecisionBiasNV'))).asFunction<GlSubpixelPrecisionBiasNV>();
  glConservativeRasterParameterfNV = fromAddress<Pointer<NativeFunction<GlConservativeRasterParameterfNVNative>>>(glGetProcAddress(CString.fromUtf8('glConservativeRasterParameterfNV'))).asFunction<GlConservativeRasterParameterfNV>();
  glConservativeRasterParameteriNV = fromAddress<Pointer<NativeFunction<GlConservativeRasterParameteriNVNative>>>(glGetProcAddress(CString.fromUtf8('glConservativeRasterParameteriNV'))).asFunction<GlConservativeRasterParameteriNV>();
  glDrawVkImageNV = fromAddress<Pointer<NativeFunction<GlDrawVkImageNVNative>>>(glGetProcAddress(CString.fromUtf8('glDrawVkImageNV'))).asFunction<GlDrawVkImageNV>();
  glGetVkProcAddrNV = fromAddress<Pointer<NativeFunction<GlGetVkProcAddrNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetVkProcAddrNV'))).asFunction<GlGetVkProcAddrNV>();
  glWaitVkSemaphoreNV = fromAddress<Pointer<NativeFunction<GlWaitVkSemaphoreNVNative>>>(glGetProcAddress(CString.fromUtf8('glWaitVkSemaphoreNV'))).asFunction<GlWaitVkSemaphoreNV>();
  glSignalVkSemaphoreNV = fromAddress<Pointer<NativeFunction<GlSignalVkSemaphoreNVNative>>>(glGetProcAddress(CString.fromUtf8('glSignalVkSemaphoreNV'))).asFunction<GlSignalVkSemaphoreNV>();
  glSignalVkFenceNV = fromAddress<Pointer<NativeFunction<GlSignalVkFenceNVNative>>>(glGetProcAddress(CString.fromUtf8('glSignalVkFenceNV'))).asFunction<GlSignalVkFenceNV>();
  glFragmentCoverageColorNV = fromAddress<Pointer<NativeFunction<GlFragmentCoverageColorNVNative>>>(glGetProcAddress(CString.fromUtf8('glFragmentCoverageColorNV'))).asFunction<GlFragmentCoverageColorNV>();
  glCoverageModulationTableNV = fromAddress<Pointer<NativeFunction<GlCoverageModulationTableNVNative>>>(glGetProcAddress(CString.fromUtf8('glCoverageModulationTableNV'))).asFunction<GlCoverageModulationTableNV>();
  glGetCoverageModulationTableNV = fromAddress<Pointer<NativeFunction<GlGetCoverageModulationTableNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetCoverageModulationTableNV'))).asFunction<GlGetCoverageModulationTableNV>();
  glCoverageModulationNV = fromAddress<Pointer<NativeFunction<GlCoverageModulationNVNative>>>(glGetProcAddress(CString.fromUtf8('glCoverageModulationNV'))).asFunction<GlCoverageModulationNV>();
  glRenderbufferStorageMultisampleCoverageNV = fromAddress<Pointer<NativeFunction<GlRenderbufferStorageMultisampleCoverageNVNative>>>(glGetProcAddress(CString.fromUtf8('glRenderbufferStorageMultisampleCoverageNV'))).asFunction<GlRenderbufferStorageMultisampleCoverageNV>();
  glUniform1i64NV = fromAddress<Pointer<NativeFunction<GlUniform1i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1i64NV'))).asFunction<GlUniform1i64NV>();
  glUniform2i64NV = fromAddress<Pointer<NativeFunction<GlUniform2i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2i64NV'))).asFunction<GlUniform2i64NV>();
  glUniform3i64NV = fromAddress<Pointer<NativeFunction<GlUniform3i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3i64NV'))).asFunction<GlUniform3i64NV>();
  glUniform4i64NV = fromAddress<Pointer<NativeFunction<GlUniform4i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4i64NV'))).asFunction<GlUniform4i64NV>();
  glUniform1i64vNV = fromAddress<Pointer<NativeFunction<GlUniform1i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1i64vNV'))).asFunction<GlUniform1i64vNV>();
  glUniform2i64vNV = fromAddress<Pointer<NativeFunction<GlUniform2i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2i64vNV'))).asFunction<GlUniform2i64vNV>();
  glUniform3i64vNV = fromAddress<Pointer<NativeFunction<GlUniform3i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3i64vNV'))).asFunction<GlUniform3i64vNV>();
  glUniform4i64vNV = fromAddress<Pointer<NativeFunction<GlUniform4i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4i64vNV'))).asFunction<GlUniform4i64vNV>();
  glUniform1ui64NV = fromAddress<Pointer<NativeFunction<GlUniform1ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1ui64NV'))).asFunction<GlUniform1ui64NV>();
  glUniform2ui64NV = fromAddress<Pointer<NativeFunction<GlUniform2ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2ui64NV'))).asFunction<GlUniform2ui64NV>();
  glUniform3ui64NV = fromAddress<Pointer<NativeFunction<GlUniform3ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3ui64NV'))).asFunction<GlUniform3ui64NV>();
  glUniform4ui64NV = fromAddress<Pointer<NativeFunction<GlUniform4ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4ui64NV'))).asFunction<GlUniform4ui64NV>();
  glUniform1ui64vNV = fromAddress<Pointer<NativeFunction<GlUniform1ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform1ui64vNV'))).asFunction<GlUniform1ui64vNV>();
  glUniform2ui64vNV = fromAddress<Pointer<NativeFunction<GlUniform2ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform2ui64vNV'))).asFunction<GlUniform2ui64vNV>();
  glUniform3ui64vNV = fromAddress<Pointer<NativeFunction<GlUniform3ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform3ui64vNV'))).asFunction<GlUniform3ui64vNV>();
  glUniform4ui64vNV = fromAddress<Pointer<NativeFunction<GlUniform4ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniform4ui64vNV'))).asFunction<GlUniform4ui64vNV>();
  glGetUniformi64vNV = fromAddress<Pointer<NativeFunction<GlGetUniformi64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformi64vNV'))).asFunction<GlGetUniformi64vNV>();
  glProgramUniform1i64NV = fromAddress<Pointer<NativeFunction<GlProgramUniform1i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1i64NV'))).asFunction<GlProgramUniform1i64NV>();
  glProgramUniform2i64NV = fromAddress<Pointer<NativeFunction<GlProgramUniform2i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2i64NV'))).asFunction<GlProgramUniform2i64NV>();
  glProgramUniform3i64NV = fromAddress<Pointer<NativeFunction<GlProgramUniform3i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3i64NV'))).asFunction<GlProgramUniform3i64NV>();
  glProgramUniform4i64NV = fromAddress<Pointer<NativeFunction<GlProgramUniform4i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4i64NV'))).asFunction<GlProgramUniform4i64NV>();
  glProgramUniform1i64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniform1i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1i64vNV'))).asFunction<GlProgramUniform1i64vNV>();
  glProgramUniform2i64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniform2i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2i64vNV'))).asFunction<GlProgramUniform2i64vNV>();
  glProgramUniform3i64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniform3i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3i64vNV'))).asFunction<GlProgramUniform3i64vNV>();
  glProgramUniform4i64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniform4i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4i64vNV'))).asFunction<GlProgramUniform4i64vNV>();
  glProgramUniform1ui64NV = fromAddress<Pointer<NativeFunction<GlProgramUniform1ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1ui64NV'))).asFunction<GlProgramUniform1ui64NV>();
  glProgramUniform2ui64NV = fromAddress<Pointer<NativeFunction<GlProgramUniform2ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2ui64NV'))).asFunction<GlProgramUniform2ui64NV>();
  glProgramUniform3ui64NV = fromAddress<Pointer<NativeFunction<GlProgramUniform3ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3ui64NV'))).asFunction<GlProgramUniform3ui64NV>();
  glProgramUniform4ui64NV = fromAddress<Pointer<NativeFunction<GlProgramUniform4ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4ui64NV'))).asFunction<GlProgramUniform4ui64NV>();
  glProgramUniform1ui64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniform1ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform1ui64vNV'))).asFunction<GlProgramUniform1ui64vNV>();
  glProgramUniform2ui64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniform2ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform2ui64vNV'))).asFunction<GlProgramUniform2ui64vNV>();
  glProgramUniform3ui64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniform3ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform3ui64vNV'))).asFunction<GlProgramUniform3ui64vNV>();
  glProgramUniform4ui64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniform4ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniform4ui64vNV'))).asFunction<GlProgramUniform4ui64vNV>();
  glGetInternalformatSampleivNV = fromAddress<Pointer<NativeFunction<GlGetInternalformatSampleivNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetInternalformatSampleivNV'))).asFunction<GlGetInternalformatSampleivNV>();
  glGetMemoryObjectDetachedResourcesuivNV = fromAddress<Pointer<NativeFunction<GlGetMemoryObjectDetachedResourcesuivNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetMemoryObjectDetachedResourcesuivNV'))).asFunction<GlGetMemoryObjectDetachedResourcesuivNV>();
  glResetMemoryObjectParameterNV = fromAddress<Pointer<NativeFunction<GlResetMemoryObjectParameterNVNative>>>(glGetProcAddress(CString.fromUtf8('glResetMemoryObjectParameterNV'))).asFunction<GlResetMemoryObjectParameterNV>();
  glTexAttachMemoryNV = fromAddress<Pointer<NativeFunction<GlTexAttachMemoryNVNative>>>(glGetProcAddress(CString.fromUtf8('glTexAttachMemoryNV'))).asFunction<GlTexAttachMemoryNV>();
  glBufferAttachMemoryNV = fromAddress<Pointer<NativeFunction<GlBufferAttachMemoryNVNative>>>(glGetProcAddress(CString.fromUtf8('glBufferAttachMemoryNV'))).asFunction<GlBufferAttachMemoryNV>();
  glTextureAttachMemoryNV = fromAddress<Pointer<NativeFunction<GlTextureAttachMemoryNVNative>>>(glGetProcAddress(CString.fromUtf8('glTextureAttachMemoryNV'))).asFunction<GlTextureAttachMemoryNV>();
  glNamedBufferAttachMemoryNV = fromAddress<Pointer<NativeFunction<GlNamedBufferAttachMemoryNVNative>>>(glGetProcAddress(CString.fromUtf8('glNamedBufferAttachMemoryNV'))).asFunction<GlNamedBufferAttachMemoryNV>();
  glDrawMeshTasksNV = fromAddress<Pointer<NativeFunction<GlDrawMeshTasksNVNative>>>(glGetProcAddress(CString.fromUtf8('glDrawMeshTasksNV'))).asFunction<GlDrawMeshTasksNV>();
  glDrawMeshTasksIndirectNV = fromAddress<Pointer<NativeFunction<GlDrawMeshTasksIndirectNVNative>>>(glGetProcAddress(CString.fromUtf8('glDrawMeshTasksIndirectNV'))).asFunction<GlDrawMeshTasksIndirectNV>();
  glMultiDrawMeshTasksIndirectNV = fromAddress<Pointer<NativeFunction<GlMultiDrawMeshTasksIndirectNVNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawMeshTasksIndirectNV'))).asFunction<GlMultiDrawMeshTasksIndirectNV>();
  glMultiDrawMeshTasksIndirectCountNV = fromAddress<Pointer<NativeFunction<GlMultiDrawMeshTasksIndirectCountNVNative>>>(glGetProcAddress(CString.fromUtf8('glMultiDrawMeshTasksIndirectCountNV'))).asFunction<GlMultiDrawMeshTasksIndirectCountNV>();
  glGenPathsNV = fromAddress<Pointer<NativeFunction<GlGenPathsNVNative>>>(glGetProcAddress(CString.fromUtf8('glGenPathsNV'))).asFunction<GlGenPathsNV>();
  glDeletePathsNV = fromAddress<Pointer<NativeFunction<GlDeletePathsNVNative>>>(glGetProcAddress(CString.fromUtf8('glDeletePathsNV'))).asFunction<GlDeletePathsNV>();
  glIsPathNV = fromAddress<Pointer<NativeFunction<GlIsPathNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsPathNV'))).asFunction<GlIsPathNV>();
  glPathCommandsNV = fromAddress<Pointer<NativeFunction<GlPathCommandsNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathCommandsNV'))).asFunction<GlPathCommandsNV>();
  glPathCoordsNV = fromAddress<Pointer<NativeFunction<GlPathCoordsNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathCoordsNV'))).asFunction<GlPathCoordsNV>();
  glPathSubCommandsNV = fromAddress<Pointer<NativeFunction<GlPathSubCommandsNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathSubCommandsNV'))).asFunction<GlPathSubCommandsNV>();
  glPathSubCoordsNV = fromAddress<Pointer<NativeFunction<GlPathSubCoordsNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathSubCoordsNV'))).asFunction<GlPathSubCoordsNV>();
  glPathStringNV = fromAddress<Pointer<NativeFunction<GlPathStringNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathStringNV'))).asFunction<GlPathStringNV>();
  glPathGlyphsNV = fromAddress<Pointer<NativeFunction<GlPathGlyphsNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathGlyphsNV'))).asFunction<GlPathGlyphsNV>();
  glPathGlyphRangeNV = fromAddress<Pointer<NativeFunction<GlPathGlyphRangeNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathGlyphRangeNV'))).asFunction<GlPathGlyphRangeNV>();
  glWeightPathsNV = fromAddress<Pointer<NativeFunction<GlWeightPathsNVNative>>>(glGetProcAddress(CString.fromUtf8('glWeightPathsNV'))).asFunction<GlWeightPathsNV>();
  glCopyPathNV = fromAddress<Pointer<NativeFunction<GlCopyPathNVNative>>>(glGetProcAddress(CString.fromUtf8('glCopyPathNV'))).asFunction<GlCopyPathNV>();
  glInterpolatePathsNV = fromAddress<Pointer<NativeFunction<GlInterpolatePathsNVNative>>>(glGetProcAddress(CString.fromUtf8('glInterpolatePathsNV'))).asFunction<GlInterpolatePathsNV>();
  glTransformPathNV = fromAddress<Pointer<NativeFunction<GlTransformPathNVNative>>>(glGetProcAddress(CString.fromUtf8('glTransformPathNV'))).asFunction<GlTransformPathNV>();
  glPathParameterivNV = fromAddress<Pointer<NativeFunction<GlPathParameterivNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathParameterivNV'))).asFunction<GlPathParameterivNV>();
  glPathParameteriNV = fromAddress<Pointer<NativeFunction<GlPathParameteriNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathParameteriNV'))).asFunction<GlPathParameteriNV>();
  glPathParameterfvNV = fromAddress<Pointer<NativeFunction<GlPathParameterfvNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathParameterfvNV'))).asFunction<GlPathParameterfvNV>();
  glPathParameterfNV = fromAddress<Pointer<NativeFunction<GlPathParameterfNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathParameterfNV'))).asFunction<GlPathParameterfNV>();
  glPathDashArrayNV = fromAddress<Pointer<NativeFunction<GlPathDashArrayNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathDashArrayNV'))).asFunction<GlPathDashArrayNV>();
  glPathStencilFuncNV = fromAddress<Pointer<NativeFunction<GlPathStencilFuncNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathStencilFuncNV'))).asFunction<GlPathStencilFuncNV>();
  glPathStencilDepthOffsetNV = fromAddress<Pointer<NativeFunction<GlPathStencilDepthOffsetNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathStencilDepthOffsetNV'))).asFunction<GlPathStencilDepthOffsetNV>();
  glStencilFillPathNV = fromAddress<Pointer<NativeFunction<GlStencilFillPathNVNative>>>(glGetProcAddress(CString.fromUtf8('glStencilFillPathNV'))).asFunction<GlStencilFillPathNV>();
  glStencilStrokePathNV = fromAddress<Pointer<NativeFunction<GlStencilStrokePathNVNative>>>(glGetProcAddress(CString.fromUtf8('glStencilStrokePathNV'))).asFunction<GlStencilStrokePathNV>();
  glStencilFillPathInstancedNV = fromAddress<Pointer<NativeFunction<GlStencilFillPathInstancedNVNative>>>(glGetProcAddress(CString.fromUtf8('glStencilFillPathInstancedNV'))).asFunction<GlStencilFillPathInstancedNV>();
  glStencilStrokePathInstancedNV = fromAddress<Pointer<NativeFunction<GlStencilStrokePathInstancedNVNative>>>(glGetProcAddress(CString.fromUtf8('glStencilStrokePathInstancedNV'))).asFunction<GlStencilStrokePathInstancedNV>();
  glPathCoverDepthFuncNV = fromAddress<Pointer<NativeFunction<GlPathCoverDepthFuncNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathCoverDepthFuncNV'))).asFunction<GlPathCoverDepthFuncNV>();
  glCoverFillPathNV = fromAddress<Pointer<NativeFunction<GlCoverFillPathNVNative>>>(glGetProcAddress(CString.fromUtf8('glCoverFillPathNV'))).asFunction<GlCoverFillPathNV>();
  glCoverStrokePathNV = fromAddress<Pointer<NativeFunction<GlCoverStrokePathNVNative>>>(glGetProcAddress(CString.fromUtf8('glCoverStrokePathNV'))).asFunction<GlCoverStrokePathNV>();
  glCoverFillPathInstancedNV = fromAddress<Pointer<NativeFunction<GlCoverFillPathInstancedNVNative>>>(glGetProcAddress(CString.fromUtf8('glCoverFillPathInstancedNV'))).asFunction<GlCoverFillPathInstancedNV>();
  glCoverStrokePathInstancedNV = fromAddress<Pointer<NativeFunction<GlCoverStrokePathInstancedNVNative>>>(glGetProcAddress(CString.fromUtf8('glCoverStrokePathInstancedNV'))).asFunction<GlCoverStrokePathInstancedNV>();
  glGetPathParameterivNV = fromAddress<Pointer<NativeFunction<GlGetPathParameterivNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathParameterivNV'))).asFunction<GlGetPathParameterivNV>();
  glGetPathParameterfvNV = fromAddress<Pointer<NativeFunction<GlGetPathParameterfvNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathParameterfvNV'))).asFunction<GlGetPathParameterfvNV>();
  glGetPathCommandsNV = fromAddress<Pointer<NativeFunction<GlGetPathCommandsNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathCommandsNV'))).asFunction<GlGetPathCommandsNV>();
  glGetPathCoordsNV = fromAddress<Pointer<NativeFunction<GlGetPathCoordsNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathCoordsNV'))).asFunction<GlGetPathCoordsNV>();
  glGetPathDashArrayNV = fromAddress<Pointer<NativeFunction<GlGetPathDashArrayNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathDashArrayNV'))).asFunction<GlGetPathDashArrayNV>();
  glGetPathMetricsNV = fromAddress<Pointer<NativeFunction<GlGetPathMetricsNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathMetricsNV'))).asFunction<GlGetPathMetricsNV>();
  glGetPathMetricRangeNV = fromAddress<Pointer<NativeFunction<GlGetPathMetricRangeNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathMetricRangeNV'))).asFunction<GlGetPathMetricRangeNV>();
  glGetPathSpacingNV = fromAddress<Pointer<NativeFunction<GlGetPathSpacingNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathSpacingNV'))).asFunction<GlGetPathSpacingNV>();
  glIsPointInFillPathNV = fromAddress<Pointer<NativeFunction<GlIsPointInFillPathNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsPointInFillPathNV'))).asFunction<GlIsPointInFillPathNV>();
  glIsPointInStrokePathNV = fromAddress<Pointer<NativeFunction<GlIsPointInStrokePathNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsPointInStrokePathNV'))).asFunction<GlIsPointInStrokePathNV>();
  glGetPathLengthNV = fromAddress<Pointer<NativeFunction<GlGetPathLengthNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetPathLengthNV'))).asFunction<GlGetPathLengthNV>();
  glPointAlongPathNV = fromAddress<Pointer<NativeFunction<GlPointAlongPathNVNative>>>(glGetProcAddress(CString.fromUtf8('glPointAlongPathNV'))).asFunction<GlPointAlongPathNV>();
  glMatrixLoad3x2fNV = fromAddress<Pointer<NativeFunction<GlMatrixLoad3x2fNVNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixLoad3x2fNV'))).asFunction<GlMatrixLoad3x2fNV>();
  glMatrixLoad3x3fNV = fromAddress<Pointer<NativeFunction<GlMatrixLoad3x3fNVNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixLoad3x3fNV'))).asFunction<GlMatrixLoad3x3fNV>();
  glMatrixLoadTranspose3x3fNV = fromAddress<Pointer<NativeFunction<GlMatrixLoadTranspose3x3fNVNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixLoadTranspose3x3fNV'))).asFunction<GlMatrixLoadTranspose3x3fNV>();
  glMatrixMult3x2fNV = fromAddress<Pointer<NativeFunction<GlMatrixMult3x2fNVNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixMult3x2fNV'))).asFunction<GlMatrixMult3x2fNV>();
  glMatrixMult3x3fNV = fromAddress<Pointer<NativeFunction<GlMatrixMult3x3fNVNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixMult3x3fNV'))).asFunction<GlMatrixMult3x3fNV>();
  glMatrixMultTranspose3x3fNV = fromAddress<Pointer<NativeFunction<GlMatrixMultTranspose3x3fNVNative>>>(glGetProcAddress(CString.fromUtf8('glMatrixMultTranspose3x3fNV'))).asFunction<GlMatrixMultTranspose3x3fNV>();
  glStencilThenCoverFillPathNV = fromAddress<Pointer<NativeFunction<GlStencilThenCoverFillPathNVNative>>>(glGetProcAddress(CString.fromUtf8('glStencilThenCoverFillPathNV'))).asFunction<GlStencilThenCoverFillPathNV>();
  glStencilThenCoverStrokePathNV = fromAddress<Pointer<NativeFunction<GlStencilThenCoverStrokePathNVNative>>>(glGetProcAddress(CString.fromUtf8('glStencilThenCoverStrokePathNV'))).asFunction<GlStencilThenCoverStrokePathNV>();
  glStencilThenCoverFillPathInstancedNV = fromAddress<Pointer<NativeFunction<GlStencilThenCoverFillPathInstancedNVNative>>>(glGetProcAddress(CString.fromUtf8('glStencilThenCoverFillPathInstancedNV'))).asFunction<GlStencilThenCoverFillPathInstancedNV>();
  glStencilThenCoverStrokePathInstancedNV = fromAddress<Pointer<NativeFunction<GlStencilThenCoverStrokePathInstancedNVNative>>>(glGetProcAddress(CString.fromUtf8('glStencilThenCoverStrokePathInstancedNV'))).asFunction<GlStencilThenCoverStrokePathInstancedNV>();
  glPathGlyphIndexRangeNV = fromAddress<Pointer<NativeFunction<GlPathGlyphIndexRangeNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathGlyphIndexRangeNV'))).asFunction<GlPathGlyphIndexRangeNV>();
  glPathGlyphIndexArrayNV = fromAddress<Pointer<NativeFunction<GlPathGlyphIndexArrayNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathGlyphIndexArrayNV'))).asFunction<GlPathGlyphIndexArrayNV>();
  glPathMemoryGlyphIndexArrayNV = fromAddress<Pointer<NativeFunction<GlPathMemoryGlyphIndexArrayNVNative>>>(glGetProcAddress(CString.fromUtf8('glPathMemoryGlyphIndexArrayNV'))).asFunction<GlPathMemoryGlyphIndexArrayNV>();
  glProgramPathFragmentInputGenNV = fromAddress<Pointer<NativeFunction<GlProgramPathFragmentInputGenNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramPathFragmentInputGenNV'))).asFunction<GlProgramPathFragmentInputGenNV>();
  glGetProgramResourcefvNV = fromAddress<Pointer<NativeFunction<GlGetProgramResourcefvNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetProgramResourcefvNV'))).asFunction<GlGetProgramResourcefvNV>();
  glFramebufferSampleLocationsfvNV = fromAddress<Pointer<NativeFunction<GlFramebufferSampleLocationsfvNVNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferSampleLocationsfvNV'))).asFunction<GlFramebufferSampleLocationsfvNV>();
  glNamedFramebufferSampleLocationsfvNV = fromAddress<Pointer<NativeFunction<GlNamedFramebufferSampleLocationsfvNVNative>>>(glGetProcAddress(CString.fromUtf8('glNamedFramebufferSampleLocationsfvNV'))).asFunction<GlNamedFramebufferSampleLocationsfvNV>();
  glResolveDepthValuesNV = fromAddress<Pointer<NativeFunction<GlResolveDepthValuesNVNative>>>(glGetProcAddress(CString.fromUtf8('glResolveDepthValuesNV'))).asFunction<GlResolveDepthValuesNV>();
  glScissorExclusiveNV = fromAddress<Pointer<NativeFunction<GlScissorExclusiveNVNative>>>(glGetProcAddress(CString.fromUtf8('glScissorExclusiveNV'))).asFunction<GlScissorExclusiveNV>();
  glScissorExclusiveArrayvNV = fromAddress<Pointer<NativeFunction<GlScissorExclusiveArrayvNVNative>>>(glGetProcAddress(CString.fromUtf8('glScissorExclusiveArrayvNV'))).asFunction<GlScissorExclusiveArrayvNV>();
  glMakeBufferResidentNV = fromAddress<Pointer<NativeFunction<GlMakeBufferResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glMakeBufferResidentNV'))).asFunction<GlMakeBufferResidentNV>();
  glMakeBufferNonResidentNV = fromAddress<Pointer<NativeFunction<GlMakeBufferNonResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glMakeBufferNonResidentNV'))).asFunction<GlMakeBufferNonResidentNV>();
  glIsBufferResidentNV = fromAddress<Pointer<NativeFunction<GlIsBufferResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsBufferResidentNV'))).asFunction<GlIsBufferResidentNV>();
  glMakeNamedBufferResidentNV = fromAddress<Pointer<NativeFunction<GlMakeNamedBufferResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glMakeNamedBufferResidentNV'))).asFunction<GlMakeNamedBufferResidentNV>();
  glMakeNamedBufferNonResidentNV = fromAddress<Pointer<NativeFunction<GlMakeNamedBufferNonResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glMakeNamedBufferNonResidentNV'))).asFunction<GlMakeNamedBufferNonResidentNV>();
  glIsNamedBufferResidentNV = fromAddress<Pointer<NativeFunction<GlIsNamedBufferResidentNVNative>>>(glGetProcAddress(CString.fromUtf8('glIsNamedBufferResidentNV'))).asFunction<GlIsNamedBufferResidentNV>();
  glGetBufferParameterui64vNV = fromAddress<Pointer<NativeFunction<GlGetBufferParameterui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetBufferParameterui64vNV'))).asFunction<GlGetBufferParameterui64vNV>();
  glGetNamedBufferParameterui64vNV = fromAddress<Pointer<NativeFunction<GlGetNamedBufferParameterui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetNamedBufferParameterui64vNV'))).asFunction<GlGetNamedBufferParameterui64vNV>();
  glGetIntegerui64vNV = fromAddress<Pointer<NativeFunction<GlGetIntegerui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetIntegerui64vNV'))).asFunction<GlGetIntegerui64vNV>();
  glUniformui64NV = fromAddress<Pointer<NativeFunction<GlUniformui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glUniformui64NV'))).asFunction<GlUniformui64NV>();
  glUniformui64vNV = fromAddress<Pointer<NativeFunction<GlUniformui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glUniformui64vNV'))).asFunction<GlUniformui64vNV>();
  glGetUniformui64vNV = fromAddress<Pointer<NativeFunction<GlGetUniformui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetUniformui64vNV'))).asFunction<GlGetUniformui64vNV>();
  glProgramUniformui64NV = fromAddress<Pointer<NativeFunction<GlProgramUniformui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformui64NV'))).asFunction<GlProgramUniformui64NV>();
  glProgramUniformui64vNV = fromAddress<Pointer<NativeFunction<GlProgramUniformui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glProgramUniformui64vNV'))).asFunction<GlProgramUniformui64vNV>();
  glBindShadingRateImageNV = fromAddress<Pointer<NativeFunction<GlBindShadingRateImageNVNative>>>(glGetProcAddress(CString.fromUtf8('glBindShadingRateImageNV'))).asFunction<GlBindShadingRateImageNV>();
  glGetShadingRateImagePaletteNV = fromAddress<Pointer<NativeFunction<GlGetShadingRateImagePaletteNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetShadingRateImagePaletteNV'))).asFunction<GlGetShadingRateImagePaletteNV>();
  glGetShadingRateSampleLocationivNV = fromAddress<Pointer<NativeFunction<GlGetShadingRateSampleLocationivNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetShadingRateSampleLocationivNV'))).asFunction<GlGetShadingRateSampleLocationivNV>();
  glShadingRateImageBarrierNV = fromAddress<Pointer<NativeFunction<GlShadingRateImageBarrierNVNative>>>(glGetProcAddress(CString.fromUtf8('glShadingRateImageBarrierNV'))).asFunction<GlShadingRateImageBarrierNV>();
  glShadingRateImagePaletteNV = fromAddress<Pointer<NativeFunction<GlShadingRateImagePaletteNVNative>>>(glGetProcAddress(CString.fromUtf8('glShadingRateImagePaletteNV'))).asFunction<GlShadingRateImagePaletteNV>();
  glShadingRateSampleOrderNV = fromAddress<Pointer<NativeFunction<GlShadingRateSampleOrderNVNative>>>(glGetProcAddress(CString.fromUtf8('glShadingRateSampleOrderNV'))).asFunction<GlShadingRateSampleOrderNV>();
  glShadingRateSampleOrderCustomNV = fromAddress<Pointer<NativeFunction<GlShadingRateSampleOrderCustomNVNative>>>(glGetProcAddress(CString.fromUtf8('glShadingRateSampleOrderCustomNV'))).asFunction<GlShadingRateSampleOrderCustomNV>();
  glTextureBarrierNV = fromAddress<Pointer<NativeFunction<GlTextureBarrierNVNative>>>(glGetProcAddress(CString.fromUtf8('glTextureBarrierNV'))).asFunction<GlTextureBarrierNV>();
  glVertexAttribL1i64NV = fromAddress<Pointer<NativeFunction<GlVertexAttribL1i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL1i64NV'))).asFunction<GlVertexAttribL1i64NV>();
  glVertexAttribL2i64NV = fromAddress<Pointer<NativeFunction<GlVertexAttribL2i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL2i64NV'))).asFunction<GlVertexAttribL2i64NV>();
  glVertexAttribL3i64NV = fromAddress<Pointer<NativeFunction<GlVertexAttribL3i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL3i64NV'))).asFunction<GlVertexAttribL3i64NV>();
  glVertexAttribL4i64NV = fromAddress<Pointer<NativeFunction<GlVertexAttribL4i64NVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL4i64NV'))).asFunction<GlVertexAttribL4i64NV>();
  glVertexAttribL1i64vNV = fromAddress<Pointer<NativeFunction<GlVertexAttribL1i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL1i64vNV'))).asFunction<GlVertexAttribL1i64vNV>();
  glVertexAttribL2i64vNV = fromAddress<Pointer<NativeFunction<GlVertexAttribL2i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL2i64vNV'))).asFunction<GlVertexAttribL2i64vNV>();
  glVertexAttribL3i64vNV = fromAddress<Pointer<NativeFunction<GlVertexAttribL3i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL3i64vNV'))).asFunction<GlVertexAttribL3i64vNV>();
  glVertexAttribL4i64vNV = fromAddress<Pointer<NativeFunction<GlVertexAttribL4i64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL4i64vNV'))).asFunction<GlVertexAttribL4i64vNV>();
  glVertexAttribL1ui64NV = fromAddress<Pointer<NativeFunction<GlVertexAttribL1ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL1ui64NV'))).asFunction<GlVertexAttribL1ui64NV>();
  glVertexAttribL2ui64NV = fromAddress<Pointer<NativeFunction<GlVertexAttribL2ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL2ui64NV'))).asFunction<GlVertexAttribL2ui64NV>();
  glVertexAttribL3ui64NV = fromAddress<Pointer<NativeFunction<GlVertexAttribL3ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL3ui64NV'))).asFunction<GlVertexAttribL3ui64NV>();
  glVertexAttribL4ui64NV = fromAddress<Pointer<NativeFunction<GlVertexAttribL4ui64NVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL4ui64NV'))).asFunction<GlVertexAttribL4ui64NV>();
  glVertexAttribL1ui64vNV = fromAddress<Pointer<NativeFunction<GlVertexAttribL1ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL1ui64vNV'))).asFunction<GlVertexAttribL1ui64vNV>();
  glVertexAttribL2ui64vNV = fromAddress<Pointer<NativeFunction<GlVertexAttribL2ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL2ui64vNV'))).asFunction<GlVertexAttribL2ui64vNV>();
  glVertexAttribL3ui64vNV = fromAddress<Pointer<NativeFunction<GlVertexAttribL3ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL3ui64vNV'))).asFunction<GlVertexAttribL3ui64vNV>();
  glVertexAttribL4ui64vNV = fromAddress<Pointer<NativeFunction<GlVertexAttribL4ui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribL4ui64vNV'))).asFunction<GlVertexAttribL4ui64vNV>();
  glGetVertexAttribLi64vNV = fromAddress<Pointer<NativeFunction<GlGetVertexAttribLi64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribLi64vNV'))).asFunction<GlGetVertexAttribLi64vNV>();
  glGetVertexAttribLui64vNV = fromAddress<Pointer<NativeFunction<GlGetVertexAttribLui64vNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetVertexAttribLui64vNV'))).asFunction<GlGetVertexAttribLui64vNV>();
  glVertexAttribLFormatNV = fromAddress<Pointer<NativeFunction<GlVertexAttribLFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribLFormatNV'))).asFunction<GlVertexAttribLFormatNV>();
  glBufferAddressRangeNV = fromAddress<Pointer<NativeFunction<GlBufferAddressRangeNVNative>>>(glGetProcAddress(CString.fromUtf8('glBufferAddressRangeNV'))).asFunction<GlBufferAddressRangeNV>();
  glVertexFormatNV = fromAddress<Pointer<NativeFunction<GlVertexFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexFormatNV'))).asFunction<GlVertexFormatNV>();
  glNormalFormatNV = fromAddress<Pointer<NativeFunction<GlNormalFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glNormalFormatNV'))).asFunction<GlNormalFormatNV>();
  glColorFormatNV = fromAddress<Pointer<NativeFunction<GlColorFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glColorFormatNV'))).asFunction<GlColorFormatNV>();
  glIndexFormatNV = fromAddress<Pointer<NativeFunction<GlIndexFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glIndexFormatNV'))).asFunction<GlIndexFormatNV>();
  glTexCoordFormatNV = fromAddress<Pointer<NativeFunction<GlTexCoordFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glTexCoordFormatNV'))).asFunction<GlTexCoordFormatNV>();
  glEdgeFlagFormatNV = fromAddress<Pointer<NativeFunction<GlEdgeFlagFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glEdgeFlagFormatNV'))).asFunction<GlEdgeFlagFormatNV>();
  glSecondaryColorFormatNV = fromAddress<Pointer<NativeFunction<GlSecondaryColorFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glSecondaryColorFormatNV'))).asFunction<GlSecondaryColorFormatNV>();
  glFogCoordFormatNV = fromAddress<Pointer<NativeFunction<GlFogCoordFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glFogCoordFormatNV'))).asFunction<GlFogCoordFormatNV>();
  glVertexAttribFormatNV = fromAddress<Pointer<NativeFunction<GlVertexAttribFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribFormatNV'))).asFunction<GlVertexAttribFormatNV>();
  glVertexAttribIFormatNV = fromAddress<Pointer<NativeFunction<GlVertexAttribIFormatNVNative>>>(glGetProcAddress(CString.fromUtf8('glVertexAttribIFormatNV'))).asFunction<GlVertexAttribIFormatNV>();
  glGetIntegerui64i_vNV = fromAddress<Pointer<NativeFunction<GlGetIntegerui64i_vNVNative>>>(glGetProcAddress(CString.fromUtf8('glGetIntegerui64i_vNV'))).asFunction<GlGetIntegerui64i_vNV>();
  glViewportSwizzleNV = fromAddress<Pointer<NativeFunction<GlViewportSwizzleNVNative>>>(glGetProcAddress(CString.fromUtf8('glViewportSwizzleNV'))).asFunction<GlViewportSwizzleNV>();
  glFramebufferTextureMultiviewOVR = fromAddress<Pointer<NativeFunction<GlFramebufferTextureMultiviewOVRNative>>>(glGetProcAddress(CString.fromUtf8('glFramebufferTextureMultiviewOVR'))).asFunction<GlFramebufferTextureMultiviewOVR>();
}

